#ifdef __cplusplus
extern "C" {
#endif

#define ALPHA    65535
#define KA       31
#define KB       57
#define EPSD8    1.e-08
#define EPSD5    1.e-05

#define   max(a,b)   ( ((a) < (b)) ? (b) : (a) )
#define   min(a,b)   ( ((a) < (b)) ? (a) : (b) )


#ifndef ubyte
typedef unsigned char ubyte;
#endif

typedef struct spoint {
  double  r,a;      /* h, area */
  float   x,y;
  int     ref,s;
  short   nv;
  ubyte   b,h;
} Point;
typedef Point * pPoint;

typedef struct stria {
  float   s;
  int     v[3];
  int     ref,mark;
} Tria;
typedef Tria * pTria;

typedef struct smesh {
  int      ns,nt,mark;
  pPoint   point;
  pTria    tria;
  
  int     *adja;
  ubyte   *voy;
} Mesh;
typedef Mesh * pMesh;

typedef struct ssol {
  float  *sol,*met;
  int     nbs,nbtyp;
} Sol;
typedef Sol * pSol;

typedef struct deriv {
  double  grd[2],hes[3];
} Deriv;
typedef Deriv * pDeriv;


#ifdef __cplusplus
}
#endif
