#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include "hde.h"
#include "metric.h"

using  namespace detri2;

//==============================================================================

int HDE_Triangulation::HDE_parse_commands(int argc, char* argv[])
{
  int i, j;
  char *pstr;

  for (i = 1; i < argc; i++) {
    if (strstr(argv[i], "len") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_target_length = atof(pstr);
        printf(" -target_length=%.2f", op_target_length);
      }
    }
    if (strstr(argv[i], "min_angle") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_target_min_angle = atof(pstr);
        op_target_cos_min_angle = cos(op_target_min_angle/180.*PI);
        printf(" -target_min_angle=%.2f", op_target_min_angle);
      }
    }
    if (strstr(argv[i], "max_angle") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      /*
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_target_max_angle = atof(pstr);
        op_target_cos_max_angle = cos(op_target_max_angle/180.*PI);
        printf(" -target_max_angle=%.2f", op_target_max_angle);
      }
      */
    }
    else if (strstr(argv[i], "s1") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_s1 = atof(pstr);
        printf(" -s1=%.2f", op_s1);
      }
    }
    else if (strstr(argv[i], "s2") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_s2 = atof(pstr);
        printf(" -s2=%.2f", op_s2);
      }
    }
    else if (strstr(argv[i], "s3") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_s3 = atof(pstr);
        printf(" -s3=%.2f", op_s3);
      }
    }
    else if (strstr(argv[i], "max_abs_fun") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_max_fun_abs = atof(pstr);
        printf(" -max_abs_fun=%f", op_max_fun_abs);
      }
    }
    else if (strstr(argv[i], "size_iter") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_max_size_iter = atoi(pstr);
        printf(" -max_size_iter=%d", op_max_size_iter);
      }
    }
    else if (strstr(argv[i], "quality_iter") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_max_quality_iter = atoi(pstr);
      }
    }
    else if (strstr(argv[i], "smooth_iter") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_smooth_iter = atoi(pstr);
        printf(" -smooth_iter=%d", op_smooth_iter);
      }
    }
    else if (strstr(argv[i], "smooth_alpha") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_smooth_alpha = atof(pstr);
        printf(" -smooth_alpha=%.2f", op_smooth_alpha);
      }
    }
    else if (strstr(argv[i], "bisect_iter") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_edge_bisect_iter = atoi(pstr);
        printf(" -bisect_iter=%d", op_edge_bisect_iter);
      }
    }
    else if (strstr(argv[i], "input_mesh") != NULL) { 
      // mesh file name, no .ele
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        strcpy(io_infilename, pstr);
        printf(" -input_mesh=%s", io_infilename);
      }
    }
    else if (strstr(argv[i], "verbose") != NULL) { 
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_db_verbose = atoi(pstr);
        printf(" -verbose=%d", op_db_verbose);
      }
    }
    else if (strstr(argv[i], "use_smoothing") != NULL) { 
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_use_smoothing = atoi(pstr);
        printf(" -use_smoothing=%d", op_use_smoothing);
      }
    }
    else if (strstr(argv[i], "use_repairing") != NULL) { 
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_use_repairing = atoi(pstr);
        printf(" -use_repairing=%d", op_use_repairing);
      }
    }
    else if (strstr(argv[i], "save_inter_mesh") != NULL) { 
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_save_inter_meshes = atoi(pstr);
        printf(" -save_inter_mesh=%d", op_save_inter_meshes);
      }
    }
    else if (strstr(argv[i], "use_intpoints") != NULL) { 
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_use_intpoints = atoi(pstr);
        printf(" -use_intpoints=%d", op_use_intpoints);
      }
    }
    else if (strstr(argv[i], "test_fun") != NULL) { 
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_test_function = atoi(pstr);
        printf(" -test_fun=%d", op_test_function);
      }
    }
    else if (strstr(argv[i], "edge_split_factor") != NULL) { 
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_edge_split_factor = atof(pstr);
        printf(" -edge_split_factor=%.2f", op_edge_split_factor);
      }
    }
    else if (strstr(argv[i], "edge_collapse_factor") != NULL) { 
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_edge_collapse_factor = atof(pstr);
        printf(" -edge_collapse_factor=%.2f", op_edge_collapse_factor);
      }
    }
    else if (strstr(argv[i], "max_enc_ang") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_max_enc_angle = atof(pstr) / 180.0 * PI;
      }
    }
    else if (strstr(argv[i], "min_enc_ang") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_min_enc_angle = atof(pstr) / 180.0 * PI;
      }
    }
    else if (strstr(argv[i], "report_quality") != NULL) {
      op_report_quality_only = 1;
    }
    else if (strstr(argv[i], "use_metric") != NULL) { 
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_use_metric = atoi(pstr);
        printf(" -use_metric");
      }
    }
    else if (strstr(argv[i], "mtr_coef") != NULL) { 
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        //op_mtr_coef = atof(pstr);
        //printf(" -mtr_coef=%f", op_mtr_coef);
      }
    }
    else if (strstr(argv[i], "HDE_metric") != NULL) {
      for (j = 0; j < strlen(argv[i]); j++) {
        if (argv[i][j] == '=') break;
      }
      if (j < strlen(argv[i])) {
        pstr = &(argv[i][j+1]);
        op_use_HDE_metric = atoi(pstr);
        printf(" -use_HDE_metric");
      }
    }
  } // argv[i]
  printf("\n");

  if (io_infilename[0] == '\0') {
    printf("!! No input mesh file is specified.\n");
    return 0;
  }

  if (io_infilename[0] == '\0') {
    // No input file name. Use a default output name.
    strcpy(io_outfilename, "output");
    return 0;
  }

  // Reconginze any file format.
  if (!strcmp(&io_infilename[strlen(io_infilename) - 5], ".node")) {
    io_infilename[strlen(io_infilename) - 5] = '\0';
  } else if (!strcmp(&io_infilename[strlen(io_infilename) - 4], ".ele")) {
    io_infilename[strlen(io_infilename) - 4] = '\0';
  } else if (!strcmp(&io_infilename[strlen(io_infilename) - 5], ".face")) {
    io_infilename[strlen(io_infilename) - 5] = '\0';
  } else if (!strcmp(&io_infilename[strlen(io_infilename) - 5], ".edge")) {
    io_infilename[strlen(io_infilename) - 5] = '\0';
  } else if (!strcmp(&io_infilename[strlen(io_infilename) - 5], ".poly")) {
    io_infilename[strlen(io_infilename) - 5] = '\0';
    io_poly = 1;
  } else if (!strcmp(&io_infilename[strlen(io_infilename) - 6], ".smesh")) {
    io_infilename[strlen(io_infilename) - 6] = '\0';
    io_poly = 1;
  } else if (!strcmp(&io_infilename[strlen(io_infilename) - 5], ".mesh")) {
    io_infilename[strlen(io_infilename) - 5] = '\0';
    io_inria_mesh = 1;
  }

  char workstring[256];
  int increment = 0;
  strcpy(workstring, io_infilename);
  j = 1;
  while (workstring[j] != '\0') {
    if ((workstring[j] == '.') && (workstring[j + 1] != '\0')) {
      increment = j + 1;
    }
    j++;
  }
  int meshnumber = 0;
  if (increment > 0) {
    j = increment;
    do {
      if ((workstring[j] >= '0') && (workstring[j] <= '9')) {
        meshnumber = meshnumber * 10 + (int) (workstring[j] - '0');
      } else {
        increment = 0;
      }
      j++;
    } while (workstring[j] != '\0');
  }
  if (increment == 0) {
    meshnumber = 0;
  } else {
    workstring[increment-1] = '\0';
  }
  sprintf(io_outfilename, "%s.%d", workstring, meshnumber + 1);

  return 1;
}

//==============================================================================
// Save function values

void HDE_Triangulation::writeEmbeddedMeshLifted(int meshidx)
{
  char filename[256];
  sprintf(filename, "/Users/si/tmp/HDE/lift_%d.inp", meshidx);
  FILE *outfile = fopen(filename, "w");

  int ntri = (int) tr_tris->objects - ct_hullsize;
  printf("Writing %d triangles to file %s.\n", ntri, filename);
  int nv = ct_in_vrts + (tr_steiners != NULL ? tr_steiners->objects : 0);
  nv -= ct_unused_vrts;

  fprintf(outfile, "%d %d 1 0 0\n", nv, ntri);

  int i, idx=1; // UCD index starts from 1.
  for (i = 0; i < ct_in_vrts; i++) {
    if (in_vrts[i].typ == UNUSEDVERTEX) continue;
    fprintf(outfile, "%d %g %g 0\n", idx, in_vrts[i].crd[0], in_vrts[i].crd[1]);
    in_vrts[i].idx = idx;
    idx++;
  }
  if (tr_steiners != NULL) {
    for (i = 0; i < tr_steiners->used_items; i++) {
      Vertex *vrt = (Vertex *) tr_steiners->get(i);
      if (vrt->is_deleted()) continue;
      fprintf(outfile, "%d %g %g 0\n", idx, vrt->crd[0], vrt->crd[1]);
      vrt->idx = idx;
      idx++;
    }
  }

  // UCD assumes vertex index starts from 1.
  int shift = (io_firstindex == 1 ? 0 : 1);
  idx = 1;
  for (i = 0; i < tr_tris->used_items; i++) {
    Triang* tri = (Triang *) tr_tris->get(i);
    if (!tri->is_deleted()) {
      // ignore a hull triangle.
      if (!tri->is_hulltri()) {
        fprintf(outfile, "%d %d tri %d %d %d\n", idx, tri->tag,
                tri->vrt[0]->idx + shift,
                tri->vrt[1]->idx + shift,
                tri->vrt[2]->idx + shift);
        tri->idx = idx;
        idx++;
      }
    }
  }

  // Output metric on nodes.
  fprintf(outfile, "1 1\n");
  fprintf(outfile, "lift, adim\n");
  idx = 1;
  // UCD index starts from 1.
  for (i = 0; i < ct_in_vrts; i++) {
    if (in_vrts[i].typ == UNUSEDVERTEX) continue;
    REAL val = in_vrts[i].Data->getSolution(); // / geo_average_length * op_max_abs_Fun;
    if (fabs(val) < 1.e-15) val = 0.0;
    fprintf(outfile, "%d %g \n", idx, val);
    //in_vrts[i].idx = idx;
    idx++;
  }
  if (tr_steiners != NULL) {
    for (i = 0; i < tr_steiners->used_items; i++) {
      Vertex *vrt = (Vertex *) tr_steiners->get(i);
      if (vrt->is_deleted()) continue;
      REAL val = vrt->Data->getSolution(); // / geo_average_length * op_max_abs_Fun;
      if (fabs(val) < 1.e-15) val = 0.0;
      fprintf(outfile, "%d %g \n", idx, val);
      //vrt->idx = idx;
      idx++;
    }
  }

  fclose(outfile); 
}

//==============================================================================
/*
void HDE_Triangulation::save_m()
{
  char filename[256];
  //sprintf(filename, "%s.m", io_outfilename);
  strcpy(filename, "/Users/si/tetgen_wrk/detri2/detri2qt/examples/dump_hde2.m");
  FILE *outfile = fopen(filename, "w");
  int i, idx;

  int ntri = (int) tr_tris->objects - ct_hullsize - ct_exteriors;
  printf("Writing %d triangles to file %s.\n", ntri, filename);
  int nv = ct_in_vrts + (tr_steiners != NULL ? tr_steiners->objects : 0);
  //nv -= ct_unused_vrts;

  idx=1; // UCD index starts from 1.
  for (i = 0; i < ct_in_vrts; i++) {
    //if (in_vrts[i].typ == UNUSEDVERTEX) continue;
    REAL val = in_vrts[i].Data->getSolution() / geo_domain_diameter * op_max_abs_Fun;
    if (fabs(val) < 1.e-15) val = 0.0;
    fprintf(outfile, "Vertex %d %g %g %g\n", idx,
            in_vrts[i].crd[0], in_vrts[i].crd[1], val);
    in_vrts[i].idx = idx;
    idx++;
  }
  if (tr_steiners != NULL) {
    for (i = 0; i < tr_steiners->used_items; i++) {
      Vertex *vrt = (Vertex *) tr_steiners->get(i);
      if (vrt->is_deleted()) continue;
      REAL val = vrt->Data->getSolution() / geo_domain_diameter * op_max_abs_Fun;
      if (fabs(val) < 1.e-15) val = 0.0;
      fprintf(outfile, "Vertex %d %g %g %g\n", idx, vrt->crd[0], vrt->crd[1], val);
      vrt->idx = idx;
      idx++;
    }
  }

  idx = 1;
  for (i = 0; i < tr_tris->used_items; i++) {
    Triang* tri = (Triang *) tr_tris->get(i);
    if (!tri->is_deleted()) {
      // ignore a hull triangle.
      if (!tri->is_hulltri() && !tri->is_exterior()) {
        fprintf(outfile, "Face %d %d %d %d\n", idx,
                tri->vrt[0]->idx, // + shift,
                tri->vrt[1]->idx, // + shift,
                tri->vrt[2]->idx); // + shift);
        tri->idx = idx;
        idx++;
      }
    }
  }

  fclose(outfile);
}
*/
//==============================================================================

void HDE_Triangulation::writeEmbeddedEdgeLength(int meshidx)
{
  char filename[256];
  sprintf(filename, "/Users/si/tmp/HDE/embeddedLength_%d.inp", meshidx);
  FILE *outfile = fopen(filename, "w");
  
  int ne = (3 * (tr_tris->objects - ct_hullsize) + ct_hullsize) / 2;
  int nv = ct_in_vrts + (tr_steiners != NULL ? tr_steiners->objects : 0);
  //nv -= ct_unused_vrts;

  printf("Writing %d edges to file %s.\n", ne, filename);

  //fprintf(outfile, "%d 1\n", ne);
  fprintf(outfile, "%d %d 0 1 0\n", nv, ne);

  int i, idx=1; // UCD index starts from 1.
  for (i = 0; i < ct_in_vrts; i++) {
    //if (in_vrts[i].typ == UNUSEDVERTEX) continue;
    fprintf(outfile, "%d %g %g 0\n", idx, in_vrts[i].crd[0], in_vrts[i].crd[1]);
    in_vrts[i].idx = idx;
    idx++;
  }
  if (tr_steiners != NULL) {
    for (i = 0; i < tr_steiners->used_items; i++) {
      Vertex *vrt = (Vertex *) tr_steiners->get(i);
      if (vrt->is_deleted()) continue;
      fprintf(outfile, "%d %g %g 0\n", idx, vrt->crd[0], vrt->crd[1]);
      vrt->idx = idx;
      idx++;
    }
  }

  REAL *edge_lengths = new REAL[ne];
  TriEdge E, S;

  // UCD assumes vertex index starts from 1.
  int shift = (io_firstindex == 1 ? 0 : 1);
  idx = 1; // io_firstindex;
  for (i = 0; i < tr_tris->used_items; i++) {
    Triang* tri = (Triang *) tr_tris->get(i);
    if (tri->is_deleted()) continue;
    E.tri = tri;
    if (!E.tri->is_hulltri()) {
      for (E.ver = 0; E.ver < 3; E.ver++) {
        if (E.esym().tri->is_hulltri() || !E.esym().tri->is_infected()) {
          // A segment will always be output.
          if (E.is_segment()) {
            S.tri = E.get_segment();
            if (S.tri->tag == 0) S.tri->tag = -1;
            //fprintf(outfile, "%d  %d %d  %d\n", idx, E.org()->idx,
            //        E.dest()->idx, S.tri->tag);
            fprintf(outfile, "%d %d line %d %d\n", idx, S.tri->tag,
                    E.org()->idx+shift, E.dest()->idx+shift);
            edge_lengths[idx-1] = HDE_dist(E.org(), E.dest());
            idx++;
          } else {
            //if (io_outedges) { // -Ie
              //if (!E.tri->is_hulltri()) {
                // Output an interior edge.
                //fprintf(outfile, "%d  %d %d  0\n", idx, E.org()->idx,
                //        E.dest()->idx);
                fprintf(outfile, "%d %d line %d %d\n", idx, 0,
                        E.org()->idx+shift, E.dest()->idx+shift);
                edge_lengths[idx-1] = HDE_dist(E.org(), E.dest());
                idx++;
              //}
            //}
          }
        }
      }
      E.tri->set_infect();
    }
  }
  
  // Uninfect all triangles.
  for (i = 0; i < tr_tris->used_items; i++) {
	Triang* tri = (Triang *) tr_tris->get(i);
	if (tri->is_deleted()) continue;
	if (!tri->is_hulltri()) {
      tri->clear_infect();
	} 
  }

  // Output metric on edges.
  fprintf(outfile, "1 1\n");
  fprintf(outfile, "max 5d lenght, adim\n");
  idx = 1;
  for (i = 0; i < ne; i++) {
    if (edge_lengths[i] < 1.0e-15) edge_lengths[i] = 0.;
    fprintf(outfile, "%d %g\n", idx, edge_lengths[i]);
    idx++;
  }

  delete [] edge_lengths;

  fclose(outfile);
}

//==============================================================================

void HDE_Triangulation::writeEmbeddedTriangleMaxAngle(int meshidx)
{
  char filename[256];
  sprintf(filename, "/Users/si/tmp/HDE/embeddedMaxAngle_%d.inp", meshidx);
  FILE *outfile = fopen(filename, "w");

  int ntri = (int) tr_tris->objects - ct_hullsize;
  printf("Writing %d triangles to file %s.\n", ntri, filename);
  int nv = ct_in_vrts + (tr_steiners != NULL ? tr_steiners->objects : 0);
  //nv -= ct_unused_vrts;

  fprintf(outfile, "%d %d 0 1 0\n", nv, ntri);

  int i, idx=1; // UCD index starts from 1.
  for (i = 0; i < ct_in_vrts; i++) {
    //if (in_vrts[i].typ == UNUSEDVERTEX) continue;
    fprintf(outfile, "%d %g %g 0\n", idx, in_vrts[i].crd[0], in_vrts[i].crd[1]);
    in_vrts[i].idx = idx;
    idx++;
  }
  if (tr_steiners != NULL) {
    for (i = 0; i < tr_steiners->used_items; i++) {
      Vertex *vrt = (Vertex *) tr_steiners->get(i);
      if (vrt->is_deleted()) continue;
      fprintf(outfile, "%d %g %g 0\n", idx, vrt->crd[0], vrt->crd[1]);
      vrt->idx = idx;
      idx++;
    }
  }

  // UCD assumes vertex index starts from 1.
  int shift = (io_firstindex == 1 ? 0 : 1);
  idx = 1;
  for (i = 0; i < tr_tris->used_items; i++) {
    Triang* tri = (Triang *) tr_tris->get(i);
    if (!tri->is_deleted()) {
      // ignore a hull triangle.
      if (!tri->is_hulltri()) {
        fprintf(outfile, "%d %d tri %d %d %d\n", idx, tri->tag,
                tri->vrt[0]->idx + shift,
                tri->vrt[1]->idx + shift,
                tri->vrt[2]->idx + shift);
        tri->idx = idx;
        idx++;
      }
    }
  }

  // Output metric on nodes.
  fprintf(outfile, "1 1\n");
  fprintf(outfile, "MaxAngle (degree), adim\n");

  //int shift = (io_firstindex == 1 ? 0 : 1);
  TriEdge E;
  idx = 1;
  for (i = 0; i < tr_tris->used_items; i++) {
    E.tri = (Triang *) tr_tris->get(i);
    if (!E.tri->is_deleted()) {
      // ignore a hull triangle.
      if (!E.tri->is_hulltri()) {
        double max_ang = HDE_get_max_angle(E);
        fprintf(outfile, "%d %g\n", idx, max_ang);
        idx++;
      }
    }
  }

  fclose(outfile);
}

//==============================================================================

void HDE_Triangulation::writeEmbeddedTriangleMinAngle(int meshidx)
{
  char filename[256];
  sprintf(filename, "/Users/si/tmp/HDE/embeddedMinAngle_%d.inp", meshidx);
  FILE *outfile = fopen(filename, "w");

  int ntri = (int) tr_tris->objects - ct_hullsize;
  printf("Writing %d triangles to file %s.\n", ntri, filename);
  int nv = ct_in_vrts + (tr_steiners != NULL ? tr_steiners->objects : 0);
  //nv -= ct_unused_vrts;

  fprintf(outfile, "%d %d 0 1 0\n", nv, ntri);

  int i, idx=1; // UCD index starts from 1.
  for (i = 0; i < ct_in_vrts; i++) {
    //if (in_vrts[i].typ == UNUSEDVERTEX) continue;
    fprintf(outfile, "%d %g %g 0\n", idx, in_vrts[i].crd[0], in_vrts[i].crd[1]);
    in_vrts[i].idx = idx;
    idx++;
  }
  if (tr_steiners != NULL) {
    for (i = 0; i < tr_steiners->used_items; i++) {
      Vertex *vrt = (Vertex *) tr_steiners->get(i);
      if (vrt->is_deleted()) continue;
      fprintf(outfile, "%d %g %g 0\n", idx, vrt->crd[0], vrt->crd[1]);
      vrt->idx = idx;
      idx++;
    }
  }

  // UCD assumes vertex index starts from 1.
  int shift = (io_firstindex == 1 ? 0 : 1);
  idx = 1;
  for (i = 0; i < tr_tris->used_items; i++) {
    Triang* tri = (Triang *) tr_tris->get(i);
    if (!tri->is_deleted()) {
      // ignore a hull triangle.
      if (!tri->is_hulltri()) {
        fprintf(outfile, "%d %d tri %d %d %d\n", idx, tri->tag,
                tri->vrt[0]->idx + shift,
                tri->vrt[1]->idx + shift,
                tri->vrt[2]->idx + shift);
        tri->idx = idx;
        idx++;
      }
    }
  }

  // Output metric on nodes.
  fprintf(outfile, "1 1\n");
  fprintf(outfile, "MinAngle (degree), adim\n");

  //int shift = (io_firstindex == 1 ? 0 : 1);
  TriEdge E;
  idx = 1;
  for (i = 0; i < tr_tris->used_items; i++) {
    E.tri = (Triang *) tr_tris->get(i);
    if (!E.tri->is_deleted()) {
      // ignore a hull triangle.
      if (!E.tri->is_hulltri()) {
        double min_ang = HDE_get_min_angle(E);
        fprintf(outfile, "%d %g\n", idx, min_ang);
        idx++;
      }
    }
  }

  fclose(outfile);
}

//==============================================================================

void HDE_Triangulation::writeEmbeddedTriangleError(int meshidx)
{
  // Save the errors in elements in two arrays.
  REAL *L2errs, *H1errs, total_L2err, total_H1err; 
  int nt = tr_tris->objects - ct_hullsize;
  L2errs = new REAL[nt]; H1errs = new REAL[nt];
  total_L2err = total_H1err = 0.;
  //int shift = (io_firstindex == 1 ? 0 : 1);
  TriEdge E;
  int tidx = 0;
  for (int i = 0; i < tr_tris->used_items; i++) {
    E.tri = (Triang *) tr_tris->get(i);
    if (!E.tri->is_deleted()) {
      if (!E.tri->is_hulltri()) {
        L2errs[tidx] = H1errs[tidx] = 0.0;
        HDE_get_interpolation_errors(E.tri, L2errs[tidx], H1errs[tidx]);
        total_L2err+=L2errs[tidx]; total_H1err+=H1errs[tidx];
        tidx++;
      }
    }
  }
  total_L2err = sqrt(total_L2err);
  total_H1err = sqrt(total_H1err);
  printf("L2err=%g, H1err=%g\n", total_L2err, total_H1err);

  ///////////////////////////////////////////////////////////////////
  char filename[256];
  sprintf(filename, "/Users/si/tmp/HDE/ErrorL2_%d.inp", meshidx);
  FILE *outfile = fopen(filename, "w");

  int ntri = (int) tr_tris->objects - ct_hullsize;
  printf("Writing %d triangles to file %s.\n", ntri, filename);
  int nv = ct_in_vrts + (tr_steiners != NULL ? tr_steiners->objects : 0);
  //nv -= ct_unused_vrts;

  fprintf(outfile, "%d %d 0 2 0\n", nv, ntri);

  int i, idx=1; // UCD index starts from 1.
  for (i = 0; i < ct_in_vrts; i++) {
    //if (in_vrts[i].typ == UNUSEDVERTEX) continue;
    fprintf(outfile, "%d %g %g 0\n", idx, in_vrts[i].crd[0], in_vrts[i].crd[1]);
    in_vrts[i].idx = idx;
    idx++;
  }
  if (tr_steiners != NULL) {
    for (i = 0; i < tr_steiners->used_items; i++) {
      Vertex *vrt = (Vertex *) tr_steiners->get(i);
      if (vrt->is_deleted()) continue;
      fprintf(outfile, "%d %g %g 0\n", idx, vrt->crd[0], vrt->crd[1]);
      vrt->idx = idx;
      idx++;
    }
  }

  // UCD assumes vertex index starts from 1.
  int shift = (io_firstindex == 1 ? 0 : 1);
  idx = 1;
  for (i = 0; i < tr_tris->used_items; i++) {
    Triang* tri = (Triang *) tr_tris->get(i);
    if (!tri->is_deleted()) {
      // ignore a hull triangle.
      if (!tri->is_hulltri()) {
        fprintf(outfile, "%d %d tri %d %d %d\n", idx, tri->tag,
                tri->vrt[0]->idx + shift,
                tri->vrt[1]->idx + shift,
                tri->vrt[2]->idx + shift);
        tri->idx = idx;
        idx++;
      }
    }
  }

  // Output Error on triangle.
  fprintf(outfile, "1 1\n");
  fprintf(outfile, "L2 error^2, adim\n");

  //int shift = (io_firstindex == 1 ? 0 : 1);
  idx = 0;
  for (i = 0; i < tr_tris->used_items; i++) {
    E.tri = (Triang *) tr_tris->get(i);
    if (!E.tri->is_deleted()) {
      // ignore a hull triangle.
      if (!E.tri->is_hulltri()) {
        //REAL l2err = 0., h1err = 0.;
        //HDE_get_interpolation_errors(E.tri, l2err, h1err);
        fprintf(outfile, "%d %g\n", idx, L2errs[idx]);
        idx++;
      }
    }
  }

  fclose(outfile);
  
  /////////////////////////////////////////////////////////////////////////////////////////////////////
  sprintf(filename, "/Users/si/tmp/HDE/ErrorH1_%d.inp", meshidx);
  outfile = fopen(filename, "w");

  ntri = (int) tr_tris->objects - ct_hullsize;
  printf("Writing %d triangles to file %s.\n", ntri, filename);
  nv = ct_in_vrts + (tr_steiners != NULL ? tr_steiners->objects : 0);
  //nv -= ct_unused_vrts;

  fprintf(outfile, "%d %d 0 2 0\n", nv, ntri);

  idx=1; // UCD index starts from 1.
  for (i = 0; i < ct_in_vrts; i++) {
    //if (in_vrts[i].typ == UNUSEDVERTEX) continue;
    fprintf(outfile, "%d %g %g 0\n", idx, in_vrts[i].crd[0], in_vrts[i].crd[1]);
    in_vrts[i].idx = idx;
    idx++;
  }
  if (tr_steiners != NULL) {
    for (i = 0; i < tr_steiners->used_items; i++) {
      Vertex *vrt = (Vertex *) tr_steiners->get(i);
      if (vrt->is_deleted()) continue;
      fprintf(outfile, "%d %g %g 0\n", idx, vrt->crd[0], vrt->crd[1]);
      vrt->idx = idx;
      idx++;
    }
  }

  // UCD assumes vertex index starts from 1.
  shift = (io_firstindex == 1 ? 0 : 1);
  idx = 1;
  for (i = 0; i < tr_tris->used_items; i++) {
    Triang* tri = (Triang *) tr_tris->get(i);
    if (!tri->is_deleted()) {
      // ignore a hull triangle.
      if (!tri->is_hulltri()) {
        fprintf(outfile, "%d %d tri %d %d %d\n", idx, tri->tag,
                tri->vrt[0]->idx + shift,
                tri->vrt[1]->idx + shift,
                tri->vrt[2]->idx + shift);
        tri->idx = idx;
        idx++;
      }
    }
  }

  // Output Error on triangle.
  fprintf(outfile, "1 1\n");
  fprintf(outfile, "H1 error^2, adim\n");

  //int shift = (io_firstindex == 1 ? 0 : 1);
  idx = 0;
  for (i = 0; i < tr_tris->used_items; i++) {
    E.tri = (Triang *) tr_tris->get(i);
    if (!E.tri->is_deleted()) {
      // ignore a hull triangle.
      if (!E.tri->is_hulltri()) {
        //REAL l2err = 0., h1err = 0.;
        //HDE_get_interpolation_errors(E.tri, l2err, h1err);
        fprintf(outfile, "%d %g\n", idx, H1errs[idx]);
        idx++;
      }
    }
  }

  fclose(outfile);
}

//==============================================================================

void HDE_Triangulation::HDE_dump_splitting_edges(arraypool* edge_list, void *fout)
{
  FILE *_fout = (FILE *) fout;
  if (_fout == NULL) {
    _fout = stderr;
  } else {
    printf("Writting %d edges to file split_edges.lua.\n", edge_list->objects);
  }

  for (int i = 0; i < edge_list->objects; i++) {
    Vertex **endpts = (Vertex **) edge_list->get(i);
    REAL Ed = get_distance(endpts[0], endpts[1]); // Euclidean distance
    REAL Hd = HDE_dist(endpts[0], endpts[1]); // HDE distance
    fprintf(_fout, "p:draw_subseg(%d,%d) -- Edist(%g) Hdist(%g)\n", 
            endpts[0]->idx, endpts[1]->idx, Ed, Hd);
  }
}

//==============================================================================

void HDE_Triangulation::HDE_dump_triangles(arraypool* tri_list, void *fout)
{
  FILE *_fout = (FILE *) fout;
  if (_fout == NULL) {
    _fout = stderr;
  } else {
    printf("Writting %d triangle to file split_tris.lua.\n", tri_list->objects);
  }

  fprintf(_fout, "-- %d triangles.\n", tri_list->used_items);
  for (int i = 0; i < tri_list->used_items; i++) {
    Triang *tri = (Triang *) tri_list->get(i);
    fprintf(_fout, "p:draw_subface(%d,%d,%d) -- maxang(%g) -- %d\n",
            tri->vrt[0]->idx, tri->vrt[1]->idx, tri->vrt[2]->idx, tri->cct[0], i);
  }
}

//==============================================================================

void HDE_Triangulation::HDE_save_metric() // for op_use_metric
{ /*
  char out_filename[256];
  char eigen_filename[256];
  strcpy(out_filename, "dump.mtr"); // for bamg
  strcpy(eigen_filename, "dump.eigen"); // for visualisation

  int nv = ct_in_vrts + (tr_steiners != NULL ? tr_steiners->objects : 0); 
  //  - ct_unused_vrts
  printf("Writting %d point metrics to file %s.\n", nv, out_filename);
  FILE *fout = fopen(out_filename, "w");
  fprintf(fout, "%d  3\n", nv);

  FILE *fout_eigen = fopen(eigen_filename, "w");
  printf("Writting %d eigen values and vectors to file %s.\n", nv, eigen_filename);
  fprintf(fout_eigen, "%d  3\n", nv);
  fprintf(fout_eigen, "# lambda1,lambda2,v1x,v1y,v2x,v2y\n");

  int i, idx = 1;
  for (i = 0; i < ct_in_vrts; i++) {
    //if (in_vrts[i].typ == UNUSEDVERTEX) continue;
    double a, b, c;
    // get a metric from the Hessian. 
    a = FunXX(&in_vrts[i]);
    b = FunXY(&in_vrts[i]);
    c = FunYY(&in_vrts[i]);
    MetricAnIso M(a,b,c);
    MatVVP2x2 Vp(M/op_mtr_coef); // scale the metric
    // Vp might contain negative eigenvalue(s).
    // Cut off the metric based on geometric size.
    // After this operation, all eigenvalue(s) are positive.
    Vp.Maxh(geo_hmin);
	Vp.Minh(geo_hmax);
    M = Vp;
    //     recompose M in: M = V^t lambda V 
    //     V = ( v,v^\perp)
    //  where v^\perp = (-v_1,v_0)
    fprintf(fout, "%g %g %g\n", M.a11, M.a21, M.a22);
    fprintf(fout_eigen, "%g %g, %g %g, %g %g\n", 
            Vp.lambda1, Vp.lambda2, 
             Vp.v.x, Vp.v.y, 
            -Vp.v.y, Vp.v.x); 
    in_vrts[i].idx = idx;
    idx++;
  }
  if (tr_steiners != NULL) {
    for (i = 0; i < tr_steiners->used_items; i++) {
      Vertex *vrt = (Vertex *) tr_steiners->get(i);
      if (vrt->is_deleted()) continue;
      double a = FunXX(vrt);
      double b = FunXY(vrt);
      double c = FunYY(vrt);
      MetricAnIso M(a,b,c);
      MatVVP2x2 Vp(M/op_mtr_coef);
      Vp.Maxh(geo_hmin);
	  Vp.Minh(geo_hmax);
      M = Vp;
      fprintf(fout, "%g %g %g\n", M.a11, M.a21, M.a22);
      fprintf(fout_eigen, "%g %g, %g %g, %g %g\n", 
              Vp.lambda1, Vp.lambda2, 
               Vp.v.x, Vp.v.y, 
              -Vp.v.y, Vp.v.x);
      //fprintf(outfile, "%d %g %g 0\n", idx, vrt->crd[0], vrt->crd[1]);
      vrt->idx = idx;
      idx++;
    }
  }

  fclose(fout);
  fclose(fout_eigen);
  */
}

//==============================================================================

void HDE_Triangulation::HDE_db_vrt(int v)
{
  Vertex *e = db_vrt(v);
  if (e == NULL) return;

  e->print();
  printf("  Solution = %g\n", e->Data->getSolution());
  printf("  GradX    = %g\n", e->Data->getGradientX());
  printf("  GradY    = %g\n", e->Data->getGradientY());
  printf("  GradZ    = %g\n", e->Data->getGradientZ());
}

REAL HDE_Triangulation::HDE_db_dist(int v1, int v2)
{
  Vertex *e1 = db_vrt(v1);
  if (e1 == NULL) return 0.0;
  Vertex *e2 = db_vrt(v2);
  if (e2 == NULL) return 0.0;

  e1->print();
  printf("  Solution = %g\n", e1->Data->getSolution());
  printf("  GradX    = %g\n", e1->Data->getGradientX());
  printf("  GradY    = %g\n", e1->Data->getGradientY());
  printf("  GradZ    = %g\n", e1->Data->getGradientZ());

  e2->print();
  printf("  Solution = %g\n", e2->Data->getSolution());
  printf("  GradX    = %g\n", e2->Data->getGradientX());
  printf("  GradY    = %g\n", e2->Data->getGradientY());
  printf("  GradZ    = %g\n", e2->Data->getGradientZ());

  printf("Euclidean_dist = %g\n", get_distance(e1, e2));

  REAL hdist = HDE_dist(e1, e2);
  printf("HDE_dist = %g\n", hdist);

  return hdist;
}

REAL HDE_Triangulation::HDE_db_angle(int v1, int v2, int v3)
{
  Vertex *e0 = db_vrt(v1);
  if (e0 == NULL) return 0.0;
  Vertex *e1 = db_vrt(v2);
  if (e1 == NULL) return 0.0;
  Vertex *e2 = db_vrt(v3);
  if (e2 == NULL) return 0.0;

  REAL a0 = get_distance(e0, e1);
  REAL b0 = get_distance(e0, e2);
  REAL c0 = get_distance(e1, e2);

  REAL cosC0 = (a0*a0 + b0*b0 - c0*c0) / (2.0*a0*b0);
  if (cosC0 > 1.0) cosC0 = 1.0;
  if (cosC0 < -1.0) cosC0 = -1.0;
  REAL Euc_ang0 = acos(cosC0);

  printf("  Euc_dist (%d,%d) = %g\n", v1, v2, a0);
  printf("  Euc_dist (%d,%d) = %g\n", v1, v3, b0);
  printf("  Euc_dist (%d,%d) = %g\n", v2, v3, c0);
  printf("  Euc_angle at (%d) = %g (degree)\n", v1, Euc_ang0 / PI * 180.);
  printf("\n");

  REAL a = HDE_dist(e0, e1);
  REAL b = HDE_dist(e0, e2);
  REAL c = HDE_dist(e1, e2);  

  REAL cosC = (a*a + b*b - c*c) / (2.0*a*b);
  if (cosC > 1.0) cosC = 1.0;
  if (cosC < -1.0) cosC = -1.0;
  REAL ang0 = acos(cosC);

  printf("  HDE_dist (%d,%d) = %g\n", v1, v2, a);
  printf("  HDE_dist (%d,%d) = %g\n", v1, v3, b);
  printf("  HDE_dist (%d,%d) = %g\n", v2, v3, c);
  printf("  HDE_angle at (%d) = %g (degree)\n", v1, ang0 / PI * 180.);

  return ang0;
}

void HDE_Triangulation::HDE_db_tri(int v1, int v2, int v3)
{
  // to do ...
}

//==============================================================================
// [2019-11-05]
//   - reconstruct a background mesh (OMT_domain) from the input mesh.
//   - sol, gradx, grady are solutions, gradients at vertices of the 
//     input mesh. 

//int HDE_Triangulation::HDE_reconstruct_OMT_domain(REAL *sol, REAL *gradx, REAL *grady)
//int HDE_Triangulation::HDE_reconstruct_OMT_domain()
int HDE_Triangulation::HDE_prepare()
{
  if (op_db_verbose) {
    printf("  Preparing mesh adaptation via HDE.\n");
  }

  // Calculate the diameter of the bbox.
  REAL dx = io_xmax - io_xmin;
  REAL dy = io_ymax - io_ymin;
  geo_domain_diameter = sqrt(dx * dx + dy * dy);
  if (geo_domain_diameter == 0.0) {
    printf("!! Wrong domain diameter.\n");
    return 0;
  }
  //if (op_db_verbose) {
    printf("  Diameter of the domain: %g\n", geo_domain_diameter);
  //}

  assert(VertexDataPool == NULL);

  // Estimate the final mesh size.
  int est_size = 8192;
  int log2objperblk = 0;
  while (est_size >>= 1) log2objperblk++;

  VertexDataPool = new arraypool(sizeof(VertexData), log2objperblk);

  //for (int i = 0; i < ct_in_vrts; i++) {
  //  in_vrts[i].Data = (VertexData *) VertexDataPool->alloc();
  //  in_vrts[i].Data->init();
  //  HDE_set_VertexData(&(in_vrts[i]));
  //}

  // We will need Steiner points.
  if (tr_steiners == NULL) {
    tr_steiners = new arraypool(sizeof(Vertex), log2objperblk);
  }

  // Create a background mesh to storing the data.
  assert(OMT_domain == NULL);
  assert(OMT_domain_VertexDataPool == NULL);

  OMT_domain = new Triangulation();
  OMT_domain->io_firstindex = io_firstindex;

  assert(op_max_fun_abs == 0.);
  assert(op_max_grd_mag == 0.);

  //int est_size = 8192;
  //int log2objperblk = 0;
  //while (est_size >>= 1) log2objperblk++;
  OMT_domain_VertexDataPool = new arraypool(sizeof(VertexData), log2objperblk);

  REAL hmin = 1e30, hmax = 0;
  REAL sol, grdx, grdy;

  OMT_domain->ct_in_vrts = ct_in_vrts;
  OMT_domain->in_vrts = new Vertex[ct_in_vrts];
  for (int i = 0; i < ct_in_vrts; i++) {
    Vertex *vrt = &(OMT_domain->in_vrts[i]);
    OMT_domain->ct_unused_vrts++;
    vrt->init();
    vrt->crd[0] = in_vrts[i].crd[0];
    vrt->crd[1] = in_vrts[i].crd[1];
    vrt->crd[2] = in_vrts[i].crd[2];
    vrt->idx = in_vrts[i].idx;
    vrt->val = in_vrts[i].val; // mtr
    vrt->tag = in_vrts[i].tag;

    // Save vertex data (unnormalised).
    sol = in_vrts[i].fval;
    grdx = in_vrts[i].grd[0];
    grdy = in_vrts[i].grd[1];
    
    in_vrts[i].Data = (VertexData *) VertexDataPool->alloc();
    in_vrts[i].Data->init();
    //  HDE_set_VertexData(&(in_vrts[i]));
    in_vrts[i].Data->setSolution(sol);
    in_vrts[i].Data->setGradientX(grdx);
    in_vrts[i].Data->setGradientY(grdy);
    in_vrts[i].Data->setGradientZ(-1.0);
    
    vrt->Data = (VertexData *) OMT_domain_VertexDataPool->alloc();
    vrt->Data->init();
    vrt->Data->setSolution(sol);
    vrt->Data->setGradientX(grdx);
    vrt->Data->setGradientY(grdy);
    vrt->Data->setGradientZ(-1.0);

    if (vrt->val < hmin) hmin = vrt->val;
    if (vrt->val > hmax) hmax = vrt->val;

    if (fabs(sol) > op_max_fun_abs) op_max_fun_abs = fabs(sol);
    REAL grd_mag = sqrt(grdx*grdx + grdy*grdy);
    if (grd_mag > op_max_grd_mag) op_max_grd_mag = grd_mag;
  }

  OMT_domain->tr_tris = new arraypool(sizeof(Triang), 10);
  for (int i = 0; i < tr_tris->used_items; i++) {
    Triang *ot = (Triang *) tr_tris->get(i);
    if (ot->is_deleted() || ot->is_hulltri()) continue;
    Vertex *p1 = &(OMT_domain->in_vrts[ot->vrt[0]->idx - io_firstindex]);
	Vertex *p2 = &(OMT_domain->in_vrts[ot->vrt[1]->idx - io_firstindex]);
	Vertex *p3 = &(OMT_domain->in_vrts[ot->vrt[2]->idx - io_firstindex]);
    Triang *tri = (Triang *) OMT_domain->tr_tris->alloc();
	tri->init();
	tri->vrt[0] = p1;
	tri->vrt[1] = p2;
	tri->vrt[2] = p3;
  }

  // Make the OMT_domain be convex (needed by point location).
  OMT_domain->op_convex = 1;
  OMT_domain->reconstruct_mesh(0); // check_delaunay = 0

  // for debug
  //strcpy(OMT_domain->io_outfilename, "/Users/si/tmp/tmp");
  //OMT_domain->save_triangulation();

  // Create the map vertex-to-OMT_domain for interpolation.
  // [2019-11-05] Every mesh vertex is pointing to a triangle of the OMT_domain.
  for (int i = 0; i < ct_in_vrts; i++) {
    Vertex *v = &(in_vrts[i]);
    Vertex *v_ot = &(OMT_domain->in_vrts[i]);
    v->on_dm = v_ot->adj; 
  }

  HDE_get_average_length();

  printf("  minimum mesh size: %g\n", hmin);
  printf("  maximum mesh size: %g\n", hmax);
  printf("  maximum function abs value = %.17g\n", op_max_fun_abs);
  printf("  maximum gradient magnitude = %.17g\n", op_max_grd_mag);

  return 1;
}

//==============================================================================

double HDE_Triangulation::HDE_get_average_length()
{  // distmesh, set op_target_length

  // The number of edges (also used to validate if we have iterate all edges).
  int ne = (3 * (tr_tris->objects - ct_hullsize) + ct_hullsize) / 2;
  REAL sumL2 = 0.0, sumL2_Euc = 0.0;
  REAL Fscale = 1.2;
  TriEdge E;

  int idx = io_firstindex;
  for (int i = 0; i < tr_tris->used_items; i++) {
    Triang* tri = (Triang *) tr_tris->get(i);
    if (tri->is_deleted()) continue;
    E.tri = tri;
    if (!E.tri->is_hulltri()) {
      for (E.ver = 0; E.ver < 3; E.ver++) {
        if (E.esym().tri->is_hulltri() || !E.esym().tri->is_infected()) {
          sumL2_Euc += get_innerproduct(E.org(), E.dest());
          //sumL2 += HDE_dot(E.org(), E.dest());
          Vertex *v1 = E.org();
          Vertex *v2 = E.dest();
          REAL x1 = v1->crd[0];
          REAL y1 = v1->crd[1];
          REAL x2 = v2->crd[0];
          REAL y2 = v2->crd[1];
          REAL s1 = v1->Data->getSolution(); //sol[v1->idx - 1];
          REAL s2 = v2->Data->getSolution(); //sol[v2->idx - 1];
          REAL vec[3];
          vec[0] = x2 - x1;
          vec[1] = y2 - y1;
          vec[2] = s2 - s1;
          sumL2 += vec[0]*vec[0]+vec[1]*vec[1]+vec[2]*vec[2];
          idx++;
        }
      } // E.ver
      E.tri->set_infect();
    }
  }

  // Uninfect all triangles.
  for (int i = 0; i < tr_tris->used_items; i++) {
	Triang* tri = (Triang *) tr_tris->get(i);
	if (tri->is_deleted()) continue;
	if (!tri->is_hulltri()) {
      tri->clear_infect();
	} // if (!tri->is_hulltri()) {
  }

  assert(idx == (ne + 1));

  //  L0=hbars*Fscale*sqrt(sum(L.^2)/sum(hbars.^2));     % L0 = Desired lengths
  
  geo_average_length = Fscale * sqrt(sumL2 / ne);
  printf("  geo_average_length = %g\n", geo_average_length);

  REAL euc_average_length = Fscale * sqrt(sumL2_Euc / ne);
  printf("  euc_average_length = %g\n", euc_average_length);

  return geo_average_length;
}

//==============================================================================
// 'pt' is a (new) mesh vertex, 'E_dm' is a (suggested) triangle in OMT_domain.
// We assume that OMT_domain is strictly convex and with no holes.

int HDE_Triangulation::HDE_interpolate_node_data(Vertex *pt, TriEdge &E_dm,
  REAL* val, REAL* sol, REAL* fx, REAL* fy, REAL *uh0, REAL *uh1)
{
  int loc = OMT_domain->locate_point(pt, E_dm, 0); // encflag = 0+

  if (loc == LOC_IN_OUTSIDE) {
    //printf("Bug: point locates outside (or in hole)!\n");
    //assert(0); // non-convex or have holes.
    //return 0;
    assert(E_dm.tri->is_hulltri());
    E_dm = E_dm.esym();
    assert(!E_dm.tri->is_hulltri());
    loc = LOC_IN_TRI;
  }

  // Round the results.
  if (loc == LOC_IN_TRI) {
    // Approximating the location of the point w.r.t. this triangle.
    //
    //                    * v3
    //                  / | \
    //                 /  |  \
    //                /   |   \
    //               /a3  | a2 \
    //              /    *pt    \
    //             /    /    \   \
    //            /       a1      \
    //        v1 *-----------------* v2
    //                 -- E -->
    //
    Vertex *v1 = E_dm.org();
    Vertex *v2 = E_dm.dest();
    Vertex *v3 = E_dm.apex();
    double a1 = get_tri_area(pt, v1, v2);
    double a2 = get_tri_area(pt, v2, v3);
    double a3 = get_tri_area(pt, v3, v1);
    double triarea = a1 + a2 + a3;
    if (triarea > 0.) {
      // Round the areas
      if (fabs(a1 / triarea - 1.0) < 1e-5) a1 = 0.0;
      if (fabs(a2 / triarea - 1.0) < 1e-5) a2 = 0.0;
      if (fabs(a3 / triarea - 1.0) < 1e-5) a3 = 0.0;
      if (a1 == 0) {
        if (a2 == 0) {
          if (a3 > 0) {
            // on v2.
            E_dm = E_dm.enext(); // E.enextself();
            loc = LOC_ON_VERT;
          } else {
            assert(0); // not possible
          }
        } else if (a3 == 0) {
          // on v1.
          loc = LOC_ON_VERT;
        } else {
          // on edge (v1, v2)
          loc = LOC_ON_EDGE;
        }
      } else if (a2 == 0) {
        if (a3 == 0) {
          // on v3
          E_dm = E_dm.eprev();
          loc = LOC_ON_VERT;
        } else {
          // on edge (v2, v3).
          E_dm = E_dm.enext();
          loc = LOC_ON_EDGE;
        }
      } else if (a3 == 0) {
        // on edge (v3, v1).
        E_dm = E_dm.eprev();
        loc = LOC_ON_EDGE;
      }
    } else {
      // A degenerated triangle. Choose the longest edge
      a1 = get_distance(v1, v2);
      a2 = get_distance(v2, v3);
      a3 = get_distance(v3, v1);
      if (a1 > a2) {
        if (a1 > a3) {
          // Choose edge (v1, v2)
          //loc = LOC_ON_EDGE;
        } else {
          // Choose edge (v3, v1)
          E_dm = E_dm.eprev();
        }
      } else {
        if (a2 > a3) {
          // Choose edge (v2, v3)
          E_dm = E_dm.enext();
        } else {
          // Choose edge (v3, v1)
          E_dm = E_dm.eprev();
        }
      }
      loc = LOC_ON_EDGE;
    }
  }

  // Interpolate node data.
  //REAL val, fx, fy;

  if (loc == LOC_ON_VERT) {
    Vertex *ppt = E_dm.org();
    *val = ppt->val;
    *sol = ppt->Data->getSolution();
    *fx  = ppt->Data->getGradientX();
    *fy  = ppt->Data->getGradientY();
    *uh0 = ppt->Data->uh0;
    *uh1 = ppt->Data->uh1;
  } else if (loc == LOC_ON_EDGE) {
    // Linear interpolation on edge E.
    Vertex *pa = E_dm.org();
    Vertex *pb = E_dm.dest();
    double L  = get_distance(pa, pb);
    double Wa = get_distance(pt, pb);
    double Wb = get_distance(pa, pt);
    *val = (pa->val * Wa + pb->val * Wb) / L;
    *sol = (pa->Data->getSolution() * Wa + pb->Data->getSolution() * Wb) / L;
    *fx  = (pa->Data->getGradientX() * Wa + pb->Data->getGradientX() * Wb) / L;
    *fy  = (pa->Data->getGradientY() * Wa + pb->Data->getGradientY() * Wb) / L;
    *uh0 = (pa->Data->uh0 * Wa + pb->Data->uh0 * Wb) / L;
    *uh1 = (pa->Data->uh1 * Wa + pb->Data->uh1 * Wb) / L;
  } else { // in triangle
    // P^1 interpolation in triangle.
    Vertex *pa = E_dm.org();
    Vertex *pb = E_dm.dest();
    Vertex *pc = E_dm.apex();    
    double A  = get_tri_area(pa, pb, pc);
    double Wa = get_tri_area(pt, pb, pc);
    double Wb = get_tri_area(pa, pt, pc);
    double Wc = get_tri_area(pa, pb, pt);
    *val = (pa->val * Wa +
            pb->val * Wb +
            pc->val * Wc) / A;
    *sol = (pa->Data->getSolution() * Wa +
            pb->Data->getSolution() * Wb + 
            pc->Data->getSolution() * Wc) / A;
    *fx  = (pa->Data->getGradientX() * Wa + 
            pb->Data->getGradientX() * Wb + 
            pc->Data->getGradientX() * Wc) / A;
    *fy  = (pa->Data->getGradientY() * Wa + 
            pb->Data->getGradientY() * Wb + 
            pc->Data->getGradientY() * Wc) / A;
    *uh0 = (pa->Data->uh0 * Wa +
            pb->Data->uh0 * Wb +
            pc->Data->uh0 * Wc) / A;
    *uh1 = (pa->Data->uh1 * Wa +
            pb->Data->uh1 * Wb +
            pc->Data->uh1 * Wc) / A;
  }

  //assert(pt->Data != NULL);
  //pt->Data->setSolution((val / op_max_abs_Fun) * geo_domain_diameter);
  //norm = sqrt(fx*fx + fy*fy + 1.0);
  //pt->Data->setGradientX((fx / norm) * geo_domain_diameter);
  //pt->Data->setGradientY((fy / norm) * geo_domain_diameter);
  //pt->Data->setGradientZ((-1.0 / norm) * geo_domain_diameter);

  return 1;
}

/*
int HDE_Triangulation::HDE_p1_interpolate_node(Vertex *pt, TriEdge &E_dm,
                                               REAL* val, REAL* fx, REAL* fy)
{
  //int loc = OMT_domain->locate_point(pt, E_dm, 1, 0); // encflag = 0
  int loc = OMT_domain->locate_point(pt, E_dm, 0); // encflag = 0

  if (E_dm.tri->is_hulltri()) {
    // Check if it is colinear with this hull edge.
    while (E_dm.apex() != OMT_domain->tr_infvrt) E_dm = E_dm.enext();
    Vertex *v1 = E_dm.org();
    Vertex *v2 = E_dm.dest();
    //if ((v1 != OMT_domain->tr_infvrt) && (v2 != OMT_domain->tr_infvrt)) {
      double l1 = get_distance(pt, v1);
      double l2 = get_distance(pt, v2);
      double len = get_distance(v1, v2);
      if (((l1 + l2) / len) < 1e-5) {
        // It is nearly collinear.
        E_dm = E_dm.esym();
        loc = 2;
      }
    //}
  } else {
    // Not find. Search this point globally.
    // To do...
    assert(0);
  }

  // Remember this triangle.
  pt->on_dm = E_dm;

  if (loc == 1) { // in triangle
    // P^1 interpolation in triangle.
    Vertex *pa = E_dm.org();
    Vertex *pb = E_dm.dest();
    Vertex *pc = E_dm.apex();    
    double A  = get_tri_area(pa, pb, pc);
    double Wa = get_tri_area(pt, pb, pc);
    double Wb = get_tri_area(pa, pt, pc);
    double Wc = get_tri_area(pa, pb, pt);   
    *val = (pa->Data->getSolution() * Wa + 
            pb->Data->getSolution() * Wb + 
            pc->Data->getSolution() * Wc) / A;
    *fx  = (pa->Data->getGradientX() * Wa + 
            pb->Data->getGradientX() * Wb + 
            pc->Data->getGradientX() * Wc) / A;
    *fy  = (pa->Data->getGradientY() * Wa + 
            pb->Data->getGradientY() * Wb + 
            pc->Data->getGradientY() * Wc) / A;
  } else if (loc == 2) { // On edge
    // Linear interpolation on edge E.
    Vertex *pa = E_dm.org();
    Vertex *pb = E_dm.dest();
    double L  = get_distance(pa, pb);
    double Wa = get_distance(pt, pb);
    double Wb = get_distance(pa, pt);
    *val = (pa->Data->getSolution() * Wa + pb->Data->getSolution() * Wb) / L;
    *fx  = (pa->Data->getGradientX() * Wa + pb->Data->getGradientX() * Wb) / L;
    *fy  = (pa->Data->getGradientY() * Wa + pb->Data->getGradientY() * Wb) / L;
  } else if (loc == 3) { // On vertex.
    Vertex *ppt = E_dm.org();
    *val = ppt->Data->getSolution();
    *fx  = ppt->Data->getGradientX();
    *fy  = ppt->Data->getGradientY();
  } else {
    assert(0); // Not possibel.
  }

  //pt->Data->setSolution(val / op_rangeFun * geo_domain_diameter);
  //norm = sqrt(fx*fx + fy*fy + 1.0);
  //pt->Data->setGradientX(fx / norm * geo_domain_diameter);
  //pt->Data->setGradientY(fy / norm * geo_domain_diameter);
  //pt->Data->setGradientZ(-1.0 / norm * geo_domain_diameter);

  return 1;
}
*/

//==============================================================================

int HDE_Triangulation::HDE_set_VertexData(Vertex *mid)
{
  //if (op_use_metric || op_use_HDE_metric) {
  //  return 1; // for metric case, no need to set vertex data.
  //}

  REAL val, sol, fx, fy, uh0, uh1; //, norm;
  val = sol = fx = fy = 0.0;
  if (OMT_domain) {
    TriEdge E_dm = mid->on_dm;
    if (!HDE_interpolate_node_data(mid, E_dm, &val, &sol, &fx, &fy, &uh0, &uh1)) {
      // Failed to locate the vertex.
      assert(0); // maybe it is a bug.
      return 0;
    }
    //assert(mid->on_dm.tri == E_dm.tri); // Remembered.
    mid->on_dm.tri = E_dm.tri;
  } else if (Func != NULL) {
    val = 0.;
    sol = Func(mid);
    fx  = GradX(mid);
    fy  = GradY(mid);
    uh0 = 0.;
    uh1 = 0.;
  } else {
    assert(0); // not possible
    return 0;    
  }
  assert(mid->Data != NULL);

  // [2019-11-11] Do the following in HDE_dot()
  //mid->Data->setSolution((val / op_max_abs_Fun) * geo_average_length);
  //norm = sqrt(fx*fx + fy*fy + 1.0);
  //mid->Data->setGradientX((fx / norm) * geo_average_length);
  //mid->Data->setGradientY((fy / norm) * geo_average_length);
  //mid->Data->setGradientZ((-1.0 / norm) * geo_average_length);

  mid->val = val;
  mid->Data->setSolution(sol);
  mid->Data->setGradientX(fx);
  mid->Data->setGradientY(fy);
  mid->Data->setGradientZ(-1.0);
  mid->Data->uh0 = uh0;
  mid->Data->uh1 = uh1;

  return 1;
}

//==============================================================================
/*
int HDE_Triangulation::HDE_prepare()
{
  if (op_db_verbose) {
    printf("  Preparing mesh adaptation via HDE.\n");
  }
  assert(VertexDataPool == NULL);

  // Calculate the diameter of the bbox.
  REAL dx = io_xmax - io_xmin;
  REAL dy = io_ymax - io_ymin;
  geo_domain_diameter = sqrt(dx * dx + dy * dy);
  if (geo_domain_diameter == 0.0) {
    printf("!! Wrong domain diameter.\n");
    return 0;
  }
  if (op_db_verbose) {
    printf("  Diameter of the domain: %g\n", geo_domain_diameter);
  }

  // Estimate the final mesh size.
  int est_size = 8192;
  int log2objperblk = 0;
  while (est_size >>= 1) log2objperblk++;

  VertexDataPool = new arraypool(sizeof(VertexData), log2objperblk);

  for (int i = 0; i < ct_in_vrts; i++) {
    in_vrts[i].Data = (VertexData *) VertexDataPool->alloc();
    in_vrts[i].Data->init();
    HDE_set_VertexData(&(in_vrts[i]));
  }

  // We will need Steiner points.
  if (tr_steiners == NULL) {
    tr_steiners = new arraypool(sizeof(Vertex), log2objperblk);
  }

  return 1;
}
*/

/*
int HDE_Triangulation::HDE_metric_prepare()
{
  if (op_db_verbose) {
    printf("  Preparing mesh adaptation via metric.\n");
  }
  //assert(VertexDataPool == NULL);

  REAL Dx = (io_xmax - io_xmin) * 0.05;
  REAL Dy = (io_ymax - io_ymin) * 0.05;
  io_xmin -= Dx;
  io_ymin -= Dy;
  io_xmax += Dx;
  io_ymax += Dy;

  // Calculate the diameter.
  REAL dx = io_xmax - io_xmin;
  REAL dy = io_ymax - io_ymin;
  geo_domain_diameter = sqrt(dx * dx + dy * dy);
  if (geo_domain_diameter == 0.0) {
    printf("!! Wrong domain diameter.\n");
    return 0;
  }
  if (op_db_verbose) {
    printf("  Diameter of the domain: %g\n", geo_domain_diameter);
  }

  // coefIcoor= (MaxICoor)/(Max(pmax.x-pmin.x,pmax.y-pmin.y));
  //long MaxICoor = 1073741823; // 2^30 - 1
  double dmax = dx > dy ? dx : dy;
  double coefIcoor = ((double) MaxICoor) / dmax;
  assert(coefIcoor >0);

  geo_hmin=1.e-100, geo_hmax=1.e17;
  //hmin = Max(hmin,BTh.MinimalHmin());
  double hhmin = 2.0 / coefIcoor; //BTh.MinimalHmin();
  geo_hmin = geo_hmin > hhmin ? geo_hmin : hhmin; // Max(hmin,hhmin);
  //hmax = Min(hmax,BTh.MaximalHmax());
  double hhmax = dmax; // BTh.MaximalHmax();
  geo_hmax = geo_hmax < hhmax ? geo_hmax : hhmax; // Min(hmax,hhmax);

  if (op_db_verbose) {
    printf("  hmin = %g, hmax = %g, coef = %g\n", geo_hmin, geo_hmax, op_mtr_coef);
  }

  // Estimate the final mesh size.
  int est_size = 8192;
  int log2objperblk = 0;
  while (est_size >>= 1) log2objperblk++;
  VertexDataPool = new arraypool(sizeof(VertexData), log2objperblk);

  // // BTh.BoundAnisotropy(anisomax,hminaniso); // bamg.cpp: line 609
  // //REAL h1=1.e30,h2=1e-30,rx=0;
  // //REAL hn1=1.e30,hn2=1e-30,rnx =1.e-30;
  // REAL coef = 1./(op_mtr_anisomax * op_mtr_anisomax);
  // double hminaniso = 1e-100;
  // double lminaniso = 1. / (Max(hminaniso*hminaniso,1e-100));
  // 
  // if (OMT_domain != NULL) {
  //   assert(0); // to be done.
  // } else {
  //   assert((FunXX != NULL) && (FunXY != NULL) && (FunYY != NULL));
  //   for (int i = 0; i < ct_in_vrts; i++) {
  //     in_vrts[i].Data = (VertexData *) VertexDataPool->alloc();
  //     in_vrts[i].Data->init();
  //     // get a metric from the Hessian. 
  //     double a = FunXX(&in_vrts[i]);
  //     double b = FunXY(&in_vrts[i]);
  //     double c = FunYY(&in_vrts[i]);
  //     MetricAnIso M(a,b,c);
  //     MatVVP2x2 Vp(M/op_mtr_coef);
  //     Vp.Maxh(geo_hmin);
	//   Vp.Minh(geo_hmax);
  //     if (0) { // if (op_mtr_anisomax > 0) {
  //       double lmax=Vp.lmax();
  //       Vp *= Min(lminaniso,lmax)/lmax;
  //       Vp.BoundAniso2(coef);
  //       //h1=Min(h1,Vp.lmin());
  //       //h2=Max(h2,Vp.lmax());
  //       //rx = Max(rx,Vp.Aniso2());
  //       //hn1=Min(hn1,Vp.lmin());
  //       //hn2=Max(hn2,Vp.lmax());
  //       //rnx = Max(rnx,Vp.Aniso2());
  //     }
  //     M = Vp;
  //     in_vrts[i].Data->set_a11(M.a11);
  //     in_vrts[i].Data->set_a21(M.a21);
  //     in_vrts[i].Data->set_a22(M.a22);
  //   }
  //   // BTh.IntersectGeomMetric(errg,iso); // bamg.cpp, line 602
  // }

  // We will need Steiner points.
  if (tr_steiners == NULL) {
    tr_steiners = new arraypool(sizeof(Vertex), log2objperblk);
  }

  return 1;
}
*/

//==============================================================================
// HDE innerproduct.
// set op_s1 = 0, op_s2 = 0, op_s3 = 0, will return the Euclidean norm.

REAL HDE_Triangulation::HDE_dot(Vertex* v1, Vertex* v2)
{
  REAL h1 = 1.0, h2 = 1.0;
  if (v1->val > 0.) {
    h1 /= v1->val; // scale value.
  }
  if (v2->val > 0.) {
    h2 /= v2->val; // scale value.
  }

  REAL sol1 = v1->Data->getSolution();
  REAL sol2 = v2->Data->getSolution();

  sol1 = sol1 / op_max_fun_abs * geo_average_length;
  sol2 = sol2 / op_max_fun_abs * geo_average_length;
  sol1 *= h1;
  sol2 *= h2;

  REAL grdx1 = v1->Data->getGradientX();
  REAL grdy1 = v1->Data->getGradientY();
  //REAL grdz1 = v1->Data->getGradientZ();
  //REAL nrm1 = sqrt(grdx1*grdx1 + grdy1*grdy1 + grdz1*grdz1);
  REAL nrm1 = sqrt(grdx1*grdx1 + grdy1*grdy1);
  REAL ratio = nrm1 / op_max_grd_mag;
  if (nrm1 > 0.) {
    grdx1 /= nrm1;
    grdy1 /= nrm1;
    //grdz1 /= nrm1;
  }
  //grdx1 *= (geo_average_length * ratio);
  //grdy1 *= (geo_average_length * ratio);
  //grdz1 *= geo_average_length;
  grdx1 *= (geo_domain_diameter * ratio);
  grdy1 *= (geo_domain_diameter * ratio);
  // Scale the gradient by its inversed edge size.
  grdx1 *= h1;
  grdy1 *= h1;
  
  REAL grdx2 = v2->Data->getGradientX();
  REAL grdy2 = v2->Data->getGradientY();
  //REAL grdz2 = v2->Data->getGradientZ();
  //REAL nrm2 = sqrt(grdx2*grdx2 + grdy2*grdy2 + grdz2*grdz2);
  REAL nrm2 = sqrt(grdx2*grdx2 + grdy2*grdy2);
  ratio = nrm2 / op_max_grd_mag;
  if (nrm2 > 0.) {
    grdx2 /= nrm2;
    grdy2 /= nrm2;
    //grdz2 /= nrm2;
  }
  //grdx2 *= (geo_average_length * ratio);
  //grdy2 *= (geo_average_length * ratio);
  //grdz2 *= geo_average_length;
  grdx2 *= (geo_domain_diameter * ratio);
  grdy2 *= (geo_domain_diameter * ratio);
  // Scale the gradient by its inversed edge size.
  grdx2 *= h2;
  grdy2 *= h2;

  REAL dot = 0.;

  REAL vec[6];
  vec[0] = v1->crd[0] - v2->crd[0];
  vec[1] = v1->crd[1] - v2->crd[1];
  vec[2] = op_s1 * (sol1  - sol2);
  vec[3] = op_s2 * (grdx1 - grdx2);
  vec[4] = op_s2 * (grdy1 - grdy2);
  vec[5] = 0.0; // op_s3 * (grdz1 - grdz2);
  for (int i = 0; i < 6; i++) {
    dot += (vec[i] * vec[i]);
  }

  return dot;
}

//==============================================================================

REAL HDE_Triangulation::HDE_dist(Vertex* v1, Vertex* v2)
{
  REAL distsum = 0.0;

  /*
  if (op_use_intpoints > 0) {
    Vertex IntV[16], *mid;
    REAL s = 1.0 / ((REAL)(op_use_intpoints + 1));
    int i;
    for (i = 0; i < op_use_intpoints; i++) {
      mid = &(IntV[i]);
      mid->init();
      REAL t = ((REAL) (i+1) * s);
      mid->crd[0] = v1->crd[0] + t * (v2->crd[0] - v1->crd[0]);
      mid->crd[1] = v1->crd[1] + t * (v2->crd[1] - v1->crd[1]);
      mid->Data = (VertexData *) VertexDataPool->alloc();
      mid->Data->init();
      mid->on_dm = v1->on_dm; // [2019-11-06] for point location.
      HDE_set_VertexData(mid);
    }
    // Summation
    distsum = sqrt(HDE_dot(v1, &(IntV[0])));
    for (i = 1; i < op_use_intpoints; i++) {
      distsum += sqrt(HDE_dot(&(IntV[i-1]), &(IntV[i])));
    }
    distsum += sqrt(HDE_dot(&(IntV[i-1]), v2));
    // deallocate the tmp space used by IntV[i]
    for (i = 0; i < op_use_intpoints; i++) {
      VertexDataPool->dealloc((void *) IntV[i].Data);
    }
  } else {
    distsum = sqrt(HDE_dot(v1, v2));
  }
  */
  distsum = sqrt(HDE_dot(v1, v2));

  return distsum;
}

REAL HDE_Triangulation::HDE_angle(Vertex* v0, Vertex* v1, Vertex* v2)
{ // angle at v0
  // Use the law of cosines: cos(C) = (a^2 + b^2 - c^2) / (2ab);
  // see https://en.wikipedia.org/wiki/Law_of_cosines

  REAL a = HDE_dist(v0, v1);
  REAL b = HDE_dist(v0, v2);
  REAL c = HDE_dist(v1, v2);

  REAL cosC = (a*a + b*b - c*c) / (2.0*a*b);
  if (cosC > 1.0) cosC = 1.0;
  if (cosC < -1.0) cosC = -1.0;

  return acos(cosC);
}

//==============================================================================
// Given two triangles [a,b,c] and [b,a,d], check if the edge [a,b]
//   is locally regular, i.e., locally Delaunay in Euclidean metric.

int HDE_Triangulation::HDE_regular_test(Vertex* pa,Vertex* pb,Vertex* pc,Vertex* pd)
{
  REAL l_ab = HDE_dist(pa, pb);
  REAL l_cd = HDE_dist(pc, pd);
  REAL l_bc = HDE_dist(pb, pc);
  REAL l_ca = HDE_dist(pc, pa);
  REAL l_ad = HDE_dist(pa, pd);
  REAL l_db = HDE_dist(pd, pb);

  REAL cosa = (l_ca*l_ca + l_ad*l_ad - l_cd*l_cd) / (2.0 * l_ca*l_ad);
  REAL cosb = (l_bc*l_bc + l_db*l_db - l_cd*l_cd) / (2.0 * l_bc*l_db);
  REAL cosc = (l_bc*l_bc + l_ca*l_ca - l_ab*l_ab) / (2.0 * l_bc*l_ca);
  REAL cosd = (l_ad*l_ad + l_db*l_db - l_ab*l_ab) / (2.0 * l_ad*l_db);

  // Rounding
  if (cosa >  1.0) cosa =  1.0;
  if (cosa < -1.0) cosa = -1.0;
  if (cosb >  1.0) cosb =  1.0;
  if (cosb < -1.0) cosb = -1.0;
  if (cosc >  1.0) cosc =  1.0;
  if (cosc < -1.0) cosc = -1.0;
  if (cosd >  1.0) cosd =  1.0;
  if (cosd < -1.0) cosd = -1.0;
  
  REAL angA = acos(cosa);
  REAL angB = acos(cosb);
  REAL angC = acos(cosc);
  REAL angD = acos(cosd);

  REAL sum_ab = angA + angB;
  REAL sum_cd = angC + angD;
  if ((fabs(sum_ab - PI) / PI) < 1.e-4) sum_ab = PI; // Roundoff
  if ((fabs(sum_cd - PI) / PI) < 1.e-4) sum_cd = PI; 

  // Do flip?
  if ((sum_cd > PI) && (sum_ab < PI)) {
    return 1; //     ori = 1.0; // need to flip.
  } else {
    return 0;
  }
}

//==============================================================================

int HDE_Triangulation::HDE_lawson_flip(Vertex *pt, arraypool *fqueue)
{
  if (fqueue->objects == 0) {
    TriEdge E, N;
    if (pt != NULL) {
      // Collect the link edges of pt.
      E = pt->adj;
      do {
        N = E.enext();
        N.set_edge_infect();
        * (TriEdge *) fqueue->alloc() = N;
        E = E.eprev_esym(); // ccw rotate
      } while (E.tri != pt->adj.tri);
    } else {
      // Collect all edges of the triangulation.
      for (int i = 0; i < tr_tris->used_items; i++) {
        E.tri = (Triang *) tr_tris->get(i);
        if (E.tri->is_deleted()) continue;
        if (!E.tri->is_hulltri()) {
          for (E.ver = 0; E.ver < 3; E.ver++) {
            if (!E.esym().tri->is_infected()) {
              E.set_edge_infect();
              * (TriEdge *) fqueue->alloc() = E;
            }
          }
          E.tri->set_infect();
        }
      }
      // Uninfect all triangles.
      for (int i = 0; i < tr_tris->used_items; i++) {
        E.tri = (Triang *) tr_tris->get(i);
        if (E.tri->is_deleted()) continue;
        if (!E.tri->is_hulltri()) {
          E.tri->clear_infect();
        }
      }
    }
  }

  if (op_db_verbose > 2) {
    printf("  Flipping %d edges...\n", fqueue->objects);
  }
  TriEdge tt[4];
  int fcount = 0;

  for (int i = 0; i < fqueue->used_items; i++) {
    TriEdge *pte = (TriEdge *) fqueue->get(i);
    if (pte->tri->is_deleted()) continue;
    if (!pte->is_edge_infected()) continue; // is it still in queue?
    pte->clear_edge_infect();
    if (pt != NULL) {
      if (pte->apex() != pt) continue;
    }
    // Check if this edge is locally regular.
    int ori = 0;
    tt[0] = *pte;
    tt[1] = tt[0].esym();
    if (!tt[0].tri->is_hulltri()) {
      if (!tt[1].tri->is_hulltri()) { 
        // An interior edge.
        //ori = Orient3d(tt[0].org(), tt[0].dest(), tt[0].apex(), tt[1].apex()) 
        //    * op_dt_nearest;
        // Another way to check locally Delaunay.
        Vertex *pa = tt[0].org();
        Vertex *pb = tt[0].dest();
        Vertex *pc = tt[0].apex();
        Vertex *pd = tt[1].apex();
        /*
        REAL ang_a = HDE_angle(pa, pc, pd);
        REAL ang_b = HDE_angle(pb, pc, pd);
        REAL ang_c = HDE_angle(pc, pa, pb);
        REAL ang_d = HDE_angle(pd, pa, pb);
        REAL sum_ab = ang_a + ang_b;
        REAL sum_cd = ang_c + ang_d;
        if ((fabs(sum_ab - PI) / PI) < 1e-5) sum_ab = PI; // Roundoff
        if ((fabs(sum_cd - PI) / PI) < 1e-5) sum_cd = PI; 
        // Do flip?
        if ((sum_cd > PI) && (sum_ab < PI)) {
          ori = 1.0; // need to flip.
        }
        */
        ori = HDE_regular_test(pa, pb, pc, pd);
      }
    } /* 
    else {
      if (tt[1].tri->is_hulltri()) {
        // Only do flip if it is the Delaunay case.
        if (hullflag) {
          // Check if an exterior flip (for convexity) is needed.
          if (tt[0].org() != tr_infvrt) tt[0] = tt[0].esym();
          assert(tt[0].org() == tr_infvrt);
          tt[1] = tt[0].esym();
          ori = Orient2d(tt[1].apex(), tt[1].org(), tt[0].apex());
        }
      }
    } */
    if (ori > 0) {
      // This edge is either locally non-regular or non-convex.
      int fflag = FLIP_UNKNOWN;
      Vertex *ppt = NULL; // Check deleted vertex.
      if (flip(tt, &ppt, fflag, fqueue)) {
        if (ppt != NULL) {
          // A vertex is deleted by this flip.
          //assert(0); // Debug it once.
          // Recycle its vertex data.
          VertexDataPool->dealloc((void *) ppt->Data);
          ppt->Data = NULL;
        }
        fcount++;
      }
    }
  } // i

  if (op_db_verbose > 2) {
    printf("  Fliped %d edges\n", fcount);
  }

  fqueue->clean(); // clean it.
  return fcount;
}

//==============================================================================

// Return the shortest edge length at this vertex.
REAL HDE_Triangulation::HDE_get_vertex_size(Vertex *pt)
{
  TriEdge E = pt->adj;
  if (E.dest() == tr_infvrt) {
    // Get a non-hull edge.
    E = E.eprev_esym(); // ccw rotate.
    assert(E.dest() != tr_infvrt);
    pt->adj = E;
  }
  REAL lmin = HDE_dist(pt, E.dest()); // init.
  do {
    if (E.dest() != tr_infvrt) { 
      REAL l = HDE_dist(pt, E.dest());
      //lmin = (l < lmin) ? l : lmin;
      if (l < lmin) {
        lmin = l;
        pt->adj = E; // Remember the shortest edge.
      }
    }
    E = E.eprev_esym();
  } while (E.tri != pt->adj.tri);
  assert(lmin > 0.);
  pt->val = lmin; // Remember this HDE length.
  return lmin;
}

//==============================================================================
// Return the largest angle (measured in Euclidean norm) of this triangle.

REAL HDE_Triangulation::HDE_get_max_angle(TriEdge &E)
{
  Vertex *pa = E.org();
  Vertex *pb = E.dest();
  Vertex *pc = E.apex();

  if (op_db_verbose > 3) {
    printf("  Triangle ABC: [%d,%d,%d]:\n", pa->idx, pb->idx, pc->idx);
  }

  REAL l_ab = HDE_dist(pa, pb);
  REAL l_bc = HDE_dist(pb, pc);
  REAL l_ca = HDE_dist(pc, pa);

  // Check if there is a bad angle.
  REAL cosA = (l_ca*l_ca + l_ab*l_ab - l_bc*l_bc) / (2.* l_ca * l_ab);
  REAL cosB = (l_ab*l_ab + l_bc*l_bc - l_ca*l_ca) / (2.* l_ab * l_bc);
  REAL cosC = (l_bc*l_bc + l_ca*l_ca - l_ab*l_ab) / (2.* l_bc * l_ca);

  if (cosA >  1.0) cosA =  1.0;
  if (cosA < -1.0) cosA = -1.0;
  if (cosB >  1.0) cosB =  1.0;
  if (cosB < -1.0) cosB = -1.0;
  if (cosC >  1.0) cosC =  1.0;
  if (cosC < -1.0) cosC = -1.0;
    
  if (op_db_verbose > 3) {
    printf("  Angles (degree) A=%g, B=%g, C=%g\n", acos(cosA) / PI * 180.0,
           acos(cosB) / PI * 180.0, acos(cosC) / PI * 180.0);
  }

  // Get the largest angle.
  REAL cosMaxAngle = cosA;
  if (cosB < cosMaxAngle) {
    if (cosC < cosB) {
      cosMaxAngle = cosC;
      E = E.eprev(); // [c,a]
    } else {
      cosMaxAngle = cosB;
      E = E.enext(); // [b,c]
    }
  } else if (cosC < cosMaxAngle) {
    cosMaxAngle = cosC;
    E = E.eprev(); // [c,a]
  }
    
  if (op_db_verbose > 3) {
    printf("  Largest angle at [%d] %g (degree)\n",
           E.org()->idx, acos(cosMaxAngle) / PI * 180.0);
  }

  return acos(cosMaxAngle) / PI * 180.0;
}

//==============================================================================

REAL HDE_Triangulation::HDE_get_min_angle(TriEdge &E)
{
  Vertex *pa = E.org();
  Vertex *pb = E.dest();
  Vertex *pc = E.apex();

  if (op_db_verbose > 3) {
    printf("  Triangle ABC: [%d,%d,%d]:\n", pa->idx, pb->idx, pc->idx);
  }

  REAL l_ab = HDE_dist(pa, pb);
  REAL l_bc = HDE_dist(pb, pc);
  REAL l_ca = HDE_dist(pc, pa);

  // Check if there is a bad angle.
  REAL cosA = (l_ca*l_ca + l_ab*l_ab - l_bc*l_bc) / (2.* l_ca * l_ab);
  REAL cosB = (l_ab*l_ab + l_bc*l_bc - l_ca*l_ca) / (2.* l_ab * l_bc);
  REAL cosC = (l_bc*l_bc + l_ca*l_ca - l_ab*l_ab) / (2.* l_bc * l_ca);

  if (cosA >  1.0) cosA =  1.0;
  if (cosA < -1.0) cosA = -1.0;
  if (cosB >  1.0) cosB =  1.0;
  if (cosB < -1.0) cosB = -1.0;
  if (cosC >  1.0) cosC =  1.0;
  if (cosC < -1.0) cosC = -1.0;
    
  if (op_db_verbose > 3) {
    printf("  Angles (degree) A=%g, B=%g, C=%g\n", acos(cosA) / PI * 180.0,
           acos(cosB) / PI * 180.0, acos(cosC) / PI * 180.0);
  }

  // Get the minimum angle.
  TriEdge EminAng = E;
  REAL cosMinAngle = cosA;
  if (cosB > cosMinAngle) {
    if (cosC > cosB) {
      cosMinAngle = cosC;
      EminAng = E.eprev(); // [c,a]
    } else {
      cosMinAngle = cosB;
      EminAng = E.enext(); // [b,c]
    }
  } else if (cosC > cosMinAngle) {
    cosMinAngle = cosC;
    EminAng = E.eprev(); // [c,a]
  }
  E = EminAng;
    
  if (op_db_verbose > 3) {
    printf("  Smallest angle at [%d] %g (degree)\n",
           EminAng.org()->idx, acos(cosMinAngle) / PI * 180.0);
  }

  return acos(cosMinAngle) / PI * 180.0;
}

//==============================================================================

int HDE_Triangulation::HDE_remove_point(Vertex *pt, arraypool* fqueue)
{
  if (op_db_verbose > 3) {
    printf("      Remove point [%d]\n", pt->idx);
  }

  int status = remove_point(pt, fqueue);

  if (status > 0) {
    // Vertex is removed.
    // Recycle the vertex data of this point.
    VertexDataPool->dealloc((void *) pt->Data);
    pt->Data = NULL;
  }

  return status;

  /*
  TriEdge E, tt[4];
  Vertex *ppt = NULL;
  int fflag;

  if (pt->is_fixed()) {
    return 0;
  } 

  if (op_db_verbose > 3) {
    printf("      Remove point [%d]\n", pt->idx);
  }

  //VertexData *ptdata = pt->Data; // Remember this address.
  E = pt->adj;
  while (1) {
    if (!E.tri->is_hulltri()) {
      tt[0] = E; fflag = FLIP_UNKNOWN; ppt = NULL;
      if (flip(tt, &ppt, fflag, fqueue)) {
        if (ppt != NULL) {
          // Recycle the vertex data of this point.
          VertexDataPool->dealloc((void *) ppt->Data);
          if (ppt == pt) {
            return 1; // point is removed.
          }
        }
        E = pt->adj;
        continue;
      } else {
        if (fflag == FLIP_INVERTED) {
          printf("!! Failed to remove vertex %d.\n", pt->idx);
          assert(0); // Debug this case.
          break; //return 0;
        }
      }
    }
    E = E.eprev_esym(); // ccw
  } // while (E.tri != pt->adj.tri);

  return 0;
  */
}

//==============================================================================

int HDE_Triangulation::HDE_coarsen_mesh()
{
  if (op_db_verbose > 1) {
    printf("  Coarsening mesh...\n");
  }
  //arraypool *delptlist = new arraypool(sizeof(Vertex*), 8);
  arraypool *fqueue = new arraypool(sizeof(TriEdge), 8);
  double lmin, diff, ratio;
  int rem_count = 0;

  for (int i = 0; i < ct_in_vrts; i++) {
    Vertex *v = &(in_vrts[i]);
    if (v->typ == UNUSEDVERTEX) continue;
    if (v->is_fixed()) continue;
    
    if (op_no_bisect) { // -Y
      // Do not remove a boundary vertex.
      TriEdge E = v->adj;
      do {
        if (E.is_segment()) break;
        E = E.eprev_esym();
      } while (E.tri != v->adj.tri);
      if (E.is_segment()) continue;
    }
    
    lmin = HDE_get_vertex_size(v);
    //lmin = get_vertex_size_average(v);
    diff = lmin - op_target_length;
    ratio = lmin / op_target_length; 
    if ((ratio < op_edge_collapse_factor) && (diff < 0)) {
      //v->set_infect();
      //* (Vertex **) delptlist->alloc() = v;
      if (op_db_verbose > 2) {
        printf("      Removing vertex [%d] typ(%d), lmin=%g.\n", v->idx, (int) v->typ, lmin);
      }
      if (HDE_remove_point(v, fqueue)) {
        HDE_lawson_flip(NULL, fqueue);
        rem_count++;
      }
    }
  }
  if (tr_steiners != NULL) {
    // There are Steiner points.
    for (int i = 0; i < tr_steiners->used_items; i++) {
      Vertex *v = (Vertex *) tr_steiners->get(i);
      if (v->is_deleted()) continue;
      assert(v->typ == STEINERVERTEX);
      if (v->is_fixed()) continue; // A fixed Steiner point.
      
      if (op_no_bisect) { // -Y
        // Do not remove a boundary vertex.
        TriEdge E = v->adj;
        do {
          if (E.is_segment()) break;
          E = E.eprev_esym();
        } while (E.tri != v->adj.tri);
        if (E.is_segment()) continue;
      }
      
      lmin = HDE_get_vertex_size(v);
      diff = lmin - op_target_length;
      ratio = lmin / op_target_length; 
      if ((ratio < op_edge_collapse_factor) && (diff < 0)) {
        //v->set_infect();
        //* (Vertex **) delptlist->alloc() = v;
        if (op_db_verbose > 2) {
          printf("      Removing vertex [%d] typ(%d), lmin=%g.\n", v->idx, (int) v->typ, lmin);
        }
        if (HDE_remove_point(v, fqueue)) {
          HDE_lawson_flip(NULL, fqueue);
          rem_count++;
        }
      }
    }
  }

  int rem_count1 = 0;
  //int rem_count2 = 0;

if (0) {
  // Remove vertices which are too close to boundary.
  // Remove boundary vertices which are too close to adjacent vertices.
  TriEdge E;
  for (int i = 0; i < tr_tris->objects; i++) {
    E.tri = (Triang *) tr_tris->get(i);
    if (E.tri->is_deleted()) continue;
    if (E.tri->is_hulltri() || E.tri->is_exterior()) continue;
    for (E.ver = 0; E.ver < 3; E.ver++) {
      if (E.is_segment()) {
        //assert(!E.apex()->is_infected());
        if (( E.org()->typ == STEINERVERTEX) ||
            ( E.org()->typ == SEGMENTVERTEX) ||
            (E.dest()->typ == STEINERVERTEX) ||
            (E.dest()->typ == SEGMENTVERTEX) ||
            (E.apex()->typ == STEINERVERTEX) ||
            (E.apex()->typ == FREEVERTEX)) {
          // Check if this triangle has a bad angle at boundary.
          // Only calculate the Euclidean angles.
          Vertex *e1 = E.org();
          Vertex *e2 = E.dest();
          Vertex *e3 = E.apex();
          double V12[2], V23[2], V31[2];
          V12[0] = e2->crd[0] - e1->crd[0];
          V12[1] = e2->crd[1] - e1->crd[1];
          V23[0] = e3->crd[0] - e2->crd[0];
          V23[1] = e3->crd[1] - e2->crd[1];
          V31[0] = e1->crd[0] - e3->crd[0];
          V31[1] = e1->crd[1] - e3->crd[1];
          double V12_norm = sqrt(V12[0]*V12[0]+V12[1]*V12[1]);
          double V23_norm = sqrt(V23[0]*V23[0]+V23[1]*V23[1]);
          double V31_norm = sqrt(V31[0]*V31[0]+V31[1]*V31[1]);
          double cos_e1 = (V12[0]*(-V31[0])+V12[1]*(-V31[1])) / (V12_norm*V31_norm);
          double cos_e2 = ((-V12[0])*V23[0]+(-V12[1])*V23[1]) / (V12_norm*V23_norm);
          // rounding
          if (cos_e1 > 1) cos_e1 = 1.0;
          if (cos_e1 < -1) cos_e1 = -1.0;
          if (cos_e2 > 1) cos_e2 = 1.0;
          if (cos_e2 < -1) cos_e2 = -1.0;
          double ang_e1 = acos(cos_e1);
          double ang_e2 = acos(cos_e2);
          double ang_e3 = PI - ang_e1 - ang_e2;
          if ((ang_e3 > op_max_enc_angle) ||
              (ang_e1 < op_min_enc_angle) ||
              (ang_e2 < op_min_enc_angle)) {
            if (op_db_verbose > 2) {
              printf("      Removing an encraoching vertex [%d] typ(%d).\n", 
                     e3->idx, (int) e3->typ);
              printf("      ang_e1(%g), ang_e2(%g), ang_e3(%g) degree.\n",
                     ang_e1/PI*180., ang_e2/PI*180., ang_e3/PI*180.);
            }
            if (HDE_remove_point(e3, fqueue)) {
              HDE_lawson_flip(NULL, fqueue);
              rem_count1++;
            }
          } else if (ang_e3 < op_min_enc_angle) {
            /*
            // This segment is too small. Remove it if one of its endpoints 
            //   is Steiner point.
            Vertex *rempt = NULL;
            if ((e1->typ == STEINERVERTEX) || (e1->typ == SEGMENTVERTEX)) {
              rempt = e1;
            } else if ((e2->typ == STEINERVERTEX) || (e2->typ == SEGMENTVERTEX)) {
              rempt = e2;
            }
            if (rempt != NULL) {
              if (op_db_verbose > 2) {
                printf("      Removing a boundary vertex [%d] typ(%d).\n", 
                       rempt->idx, (int) rempt->typ);
                printf("      ang_e1(%g), ang_e2(%g), ang_e3(%g) degree.\n",
                       ang_e1/PI*180., ang_e2/PI*180., ang_e3/PI*180.);
              }
              if (HDE_remove_point(rempt, fqueue)) {
                HDE_lawson_flip(NULL, fqueue);
                rem_count2++;
              }
            }
            */
          }
        }
        break;
      }
    }
  }
} // if (0)

  if (op_db_verbose > 1) {
    printf("  Removed %d vertices (%d encroaching segments).\n", 
           rem_count + rem_count1, rem_count1);
  }

  delete fqueue;
  return rem_count + rem_count1; // + rem_count2;
}

//==============================================================================

int HDE_Triangulation::HDE_get_edge_bisector(Vertex *pa, Vertex *pb, Vertex *mid, 
                                             REAL *lo, REAL *hi, int iter)
{ // Using the simple bisector algorithm.
  REAL split = 0.5 * (*lo + *hi);
  if (op_db_verbose > 2) {
    printf("      lo = %g, hi = %g, split = %g, iter = %d\n", *lo, *hi, split, iter);
  }
  mid->crd[0] = (1.0 - split) * pa->crd[0] + split * pb->crd[0];
  mid->crd[1] = (1.0 - split) * pa->crd[1] + split * pb->crd[1];
  mid->crd[2] = (1.0 - split) * pa->crd[2] + split * pb->crd[2]; // No use

  mid->on_dm = pa->on_dm; 
  if (!HDE_set_VertexData(mid)) {
    assert(0); // debug it.
    return 0;
  }

  REAL dist_to_a = HDE_dist(pa, mid);
  REAL dist_to_b = HDE_dist(pb, mid);
  if (op_db_verbose > 2) {
    printf("      dist_to_a=%g, dist_to_b=%g\n", dist_to_a, dist_to_b);
  }

  // Check if this is the midpoint (or different to it not much).
  REAL diff = dist_to_a - dist_to_b;
  if ((fabs(diff) / (dist_to_a + dist_to_a)) < 0.3) {
    return iter; // Found! Return the midpoint.
  }

  if (iter > 0) {
    int next_iter = iter - 1;
    if (dist_to_a > dist_to_b) {
      // move it towards to pa.
      *hi = split;
    } else {
      // move it towards to pb.
      *lo = split;
    }
    return HDE_get_edge_bisector(pa, pb, mid, lo, hi, next_iter); 
  } else {
    return 0; // Not converged. Return the midpoint.
  }
}

//==============================================================================

int HDE_Triangulation::HDE_split_edge(TriEdge &E, double t, Vertex** ppt, arraypool* fqueue)
{
  if (op_no_bisect > 0) { // -Y option
    if (E.is_segment()) {
      return 0; // do not split a segment.
    }
  }

  Vertex *endpts[2];
  endpts[0] = E.org();
  endpts[1] = E.dest();

  if (op_db_verbose > 2) {
    printf("      Split edge [%d, %d]\n", endpts[0]->idx, endpts[1]->idx);
    if ((endpts[0]->idx == 2698) && (endpts[1]->idx == 1857)) {
      printf("dbeug...");
    }
  }

  Vertex *newvrt = (Vertex *) tr_steiners->alloc();
  newvrt->init();
  newvrt->on_dm = endpts[0]->on_dm; // [2019-11-06]
  newvrt->Data = (VertexData *) VertexDataPool->alloc();
  newvrt->Data->init();
  newvrt->idx = io_firstindex + (ct_in_vrts + tr_steiners->objects - 1);
  newvrt->typ = STEINERVERTEX;

  if (t > 0. && t < 1.) {
    newvrt->crd[0] = (1.-t) * endpts[0]->crd[0] + t * endpts[1]->crd[0];
    newvrt->crd[1] = (1.-t) * endpts[0]->crd[1] + t * endpts[1]->crd[1];
    newvrt->crd[2] = (1.-t) * endpts[0]->crd[2] + t * endpts[1]->crd[2]; // no use.
    if (!HDE_set_VertexData(newvrt)) {
      assert(0);
      VertexDataPool->dealloc((void *) newvrt->Data);
      newvrt->set_deleted();
      tr_steiners->dealloc((void *) newvrt);
      return 0;
    }
  } else {
    // Get the bisector point on this edge.
    REAL lo = 0., hi = 1.0;
    int it = HDE_get_edge_bisector(endpts[0], endpts[1], newvrt, &lo, &hi, op_edge_bisect_iter);
    if (op_db_verbose > 3) {
      REAL split = 0.5 * (lo + hi);
      printf("      lo = %g, hi = %g, split = %g, iterations = %d, .\n", lo, hi, split,
             op_edge_bisect_iter - it);
      REAL dist_to_a = get_distance(endpts[0], newvrt);
      REAL dist_to_b = get_distance(endpts[1], newvrt);
      REAL hde_dist_to_a = HDE_dist(endpts[0], newvrt);
      REAL hde_dist_to_b = HDE_dist(endpts[1], newvrt);
      printf("      Eda=%g, Edb=%g, Hda=%g, Hdb=%g\n", dist_to_a, dist_to_b,
             hde_dist_to_a, hde_dist_to_b);
    }
  }

  // Validate if the new vertex does not result inverted triangles.
  TriEdge tt[4];
  tt[0] = E;
  tt[1] = tt[0].esym();
  Vertex *pa = tt[0].org();
  Vertex *pb = tt[0].dest();
  Vertex *pc = tt[0].apex();
  Vertex *pd = tt[1].apex();
  REAL o1, o2, o3, o4;
  if (pc != tr_infvrt) {
    o1 = Orient2d(pa, newvrt, pc);
    o2 = Orient2d(newvrt, pb, pc);
  } else {
    o1 = o2 = 1.0;
  }
  if (pd != tr_infvrt) {
    o3 = Orient2d(pb, newvrt, pd);
    o4 = Orient2d(newvrt, pa, pd);
  } else {
    o3 = o4 = 1.0;
  }
  if ((o1 > 0.) && (o2 > 0.) && (o3 > 0.) && (o4 > 0.)) {
    // Insert the point.
    int fflag = FLIP_24;
    if (flip(tt, &newvrt, fflag, NULL)) {
      HDE_lawson_flip(newvrt, fqueue);
    } else {
      assert(0);
    }
    if (ppt != NULL) {
      *ppt = newvrt;
    }
    return 1;
  } else {
    if (op_db_verbose > 2) {
      printf("      Reject a new point on edge [%d,%d].\n", endpts[0]->idx, endpts[1]->idx);
    }
    VertexDataPool->dealloc((void *) newvrt->Data);
    newvrt->set_deleted();
    tr_steiners->dealloc((void *) newvrt);
    return 0;
  }
}

//==============================================================================

int HDE_Triangulation::HDE_split_edges()
{
  arraypool *edge_list = new arraypool(sizeof(Vertex *) * 2, 10);
  double len, diff, ratio;
  int split_count = 0;
  TriEdge E;

  TriEdge Emax;
  double max_len = 0.0;

  // Collect all edges to be split of the triangulation.
  for (int i = 0; i < tr_tris->used_items; i++) {
    E.tri = (Triang *) tr_tris->get(i);
    if (E.tri->is_deleted()) continue;
    if (!E.tri->is_hulltri()) {
      for (E.ver = 0; E.ver < 3; E.ver++) {
        if (!E.esym().tri->is_infected()) {
          len = HDE_dist(E.org(), E.dest());
          diff = len - op_target_length;
          ratio = len / op_target_length; // Roundoff
          if ((ratio > op_edge_split_factor) && (diff > 0)) {
            if (len > max_len) { // Record the maximum edge length.
              Emax = E;
              max_len = len;
            }
            Vertex **endpts = (Vertex **) edge_list->alloc();
            endpts[0] = E.org();
            endpts[1] = E.dest();
          }
        }
      }
      E.tri->set_infect();
    }
  }
  // Uninfect all triangles.
  for (int i = 0; i < tr_tris->used_items; i++) {
    E.tri = (Triang *) tr_tris->get(i);
    if (E.tri->is_deleted()) continue;
    if (!E.tri->is_hulltri()) {
      E.tri->clear_infect();
    }
  }

  if (edge_list->objects > 0) {
    if (op_db_verbose) {
      printf("  Found %d long edges, maxlen at (%d,%d) = %g.\n", 
            edge_list->objects, Emax.org()->idx, Emax.dest()->idx, max_len);
    }
    if (op_db_verbose > 4) {
      FILE *fout = fopen("split_edges.lua", "w");
      HDE_dump_splitting_edges(edge_list, fout);
      fclose(fout);
    }
    //mesh_phase = 4;
    arraypool *fqueue = new arraypool(sizeof(TriEdge), 8);

    for (int i = 0; i < edge_list->objects; i++) {
      Vertex **endpts = (Vertex **) edge_list->get(i);
      if (get_edge(endpts[0], endpts[1], E)) {
        if (HDE_split_edge(E, 0., NULL, fqueue)) { // t = 0.
          split_count++;
        }
      }
    }

    if (op_db_verbose > 1) {
      printf("  Split %d edges\n", split_count);
    }

    delete fqueue;
    //mesh_phase = 0;
  }

  delete edge_list;
  return split_count;
}

//==============================================================================

int HDE_Triangulation::HDE_move_interior_point(Vertex *pt)
{
  Vertex *starOfPoints[32];
  int nv = 0, i;
  int is_interior = 1;

  TriEdge E = pt->adj;
  do {
    starOfPoints[nv] = E.dest();
    if (starOfPoints[nv]->typ == INFVERTEX) {
      is_interior = 0;
      return 0; // Do not smooth it.
    }
    nv++;
    if (nv > 31) {
      return 0; // Too many adjacent vertices.
    }
    E = E.eprev_esym(); // ccw rotate.
  } while (E.tri != pt->adj.tri);

  if (op_db_verbose > 2) {
    printf("      Move interior point #%d, degree = %d.\n", pt->idx, nv);
  }

  REAL embeddedDistances[32], weights[32];
  REAL unitDirX[32], unitDirY[32];
  REAL minDistance = 9e+99;
  REAL meanOfWeights = 0.0; 

  for (i = 0; i < nv; i++) {
    Vertex *tmpPt = starOfPoints[i];
    REAL dist = get_distance(pt, tmpPt);
    /*
    if ((dist / domain_diameter) < 1e-6) {
      if (op_db_verbose > 2) {
        printf("      Found a very close vertex #%d, distance = %g.\n", tmpPt->idx, dist);
      }
      // Delete this vertex.
      arraypool *fqueue = new arraypool(sizeof(TriEdge), 4);
      HDE_remove_point(pt, fqueue);
      delete fqueue;
      return -1; 
    }
    */
    if(dist < minDistance) minDistance = dist;
    unitDirX[i] = -(pt->crd[0] - tmpPt->crd[0]) / dist;
    unitDirY[i] = -(pt->crd[1] - tmpPt->crd[1]) / dist;
    embeddedDistances[i] = HDE_dist(pt, tmpPt);
    meanOfWeights += embeddedDistances[i];
  }

  for (i = 0; i < nv; i++) {
    embeddedDistances[i] /= meanOfWeights;
  }

  for (i = 0; i < nv; i++) {
    REAL d4 = embeddedDistances[i] * embeddedDistances[i]
            * embeddedDistances[i] * embeddedDistances[i];
    weights[i] = (1.-d4) * exp(-d4);
  }

  REAL dx = 0.;
  REAL dy = 0.;
  for(i = 0; i < nv; i++) {
    dx += unitDirX[i] * weights[i];
    dy += unitDirY[i] * weights[i];
  }

  Vertex newPos;
  newPos.crd[0] = pt->crd[0] + dx * op_smooth_alpha * minDistance;
  newPos.crd[1] = pt->crd[1] + dy * op_smooth_alpha * minDistance;

  // Do not move if the move distance is too small.
  REAL dist = get_distance(pt, &newPos);
  if (dist / minDistance < 1e-4) {
    return 0; // The movement is too small.
  }

  // Check if this position is valid.
  E = pt->adj;
  i = 0;
  do {
    REAL ori = Orient2d(&newPos, E.dest(), E.apex());
    if (ori <= 0) break;
    i++;
    E = E.eprev_esym(); // ccw rotate.
  } while (E.tri != pt->adj.tri);

  if (i < nv) {
    // There are inverted triangles.
    return 0;
  }

  if (op_db_verbose > 2) {
    //REAL dist = get_distance(pt, &newPos);
    printf("      Moved from (%g,%g) to new positon (%g,%g) dist(%g).\n", 
           pt->crd[0], pt->crd[1], newPos.crd[0], newPos.crd[1], dist);
  }

  // Update the vertex position.
  pt->crd[0] = newPos.crd[0];
  pt->crd[1] = newPos.crd[1];
  pt->crd[2] = pt->crd[0]*pt->crd[0] + pt->crd[1]*pt->crd[1];

  // Update vertex data.
  HDE_set_VertexData(pt);
  /*
  REAL val, fx, fy, norm;
  val = fx = fy = 0.0;
  if (OMT_domain != NULL) {
    TriEdge E_dm = pt->on_dm;
    if (!HDE_p1_interpolate_node(&newPos, E_dm, &val, &fx, &fy)) {
      printf("!! Failed to interpolate point values on vertex #%d\n", pt->idx);
      // Do not insert move point.
      return 0;
    }
  } else {
    val = Func(&newPos);
    fx = GradX(&newPos);
    fy = GradY(&newPos);
  }
  pt->Data->setSolution((val / op_max_abs_Fun) * geo_domain_diameter);
  norm = sqrt(fx*fx + fy*fy + 1.0);
  pt->Data->setGradientX((fx / norm) * geo_domain_diameter);
  pt->Data->setGradientY((fy / norm) * geo_domain_diameter);
  pt->Data->setGradientZ((-1.0 / norm) * geo_domain_diameter);
  */

  return 1; 
}

//==============================================================================

int HDE_Triangulation::HDE_get_distmesh_point(Vertex *mesh_vertex, Vertex *movept)
{
  // Variables cooresponding to the paper.
  // L, bar length, barvec[2], bar (edge) vector (unique).
  // F, force (> 0) on each bar, the direction of the force is given by
  // its barvec[2]. Ftot[2], the sum of force vectors at node.
  REAL L, F, barvec[2], Ftot[2];

  Ftot[0] = Ftot[1] = 0.;
  bool is_seg_vertex = false;
  TriEdge E = mesh_vertex->adj;
  do {
    if (E.is_segment()) {
      is_seg_vertex = true;
      break;
    }
    Vertex *pd = E.dest();
    if (pd != tr_infvrt) {
      //if (mesh_vertex->idx < pd->idx) {
        barvec[0] = pd->crd[0] - mesh_vertex->crd[0];
        barvec[1] = pd->crd[1] - mesh_vertex->crd[1];
      //} else {
      //  barvec[0] = mesh_vertex->crd[0] - pd->crd[0]; // test
      //  barvec[1] = mesh_vertex->crd[1] - pd->crd[1]; // test
      //}
      L = HDE_dist(mesh_vertex, pd); //L = get_distance(mesh_vertex, pd);
      F = op_target_length - L;
      if (F < 0.) F = 0.;
      // Ftot += Fvec
      Ftot[0] += (-barvec[0] * F / L);
      Ftot[1] += (-barvec[1] * F / L);
    }
    E = E.eprev_esym(); // CCW
  } while (E.tri != mesh_vertex->adj.tri);

  if (!is_seg_vertex) {
    // Save this point.
    movept->crd[0] = mesh_vertex->crd[0] + op_smooth_deltat * Ftot[0];
    movept->crd[1] = mesh_vertex->crd[1] + op_smooth_deltat * Ftot[1];
    //movept->Pair = mesh_vertex; // Remember it.
    return 1;
  }

  return 0;
}

//==============================================================================

int HDE_Triangulation::HDE_smooth_vertices()
{
  /* [2019-11-13] old version.
  int smooth_count = 0;
  
  for (int i = 0; i < ct_in_vrts; i++) {
    Vertex *pt = &(in_vrts[i]);
    if ((pt->typ == UNUSEDVERTEX) ||
        (pt->is_fixed())) continue;
    if (HDE_move_interior_point(pt)) smooth_count++;
  }

  for (int i = 0; i < tr_steiners->used_items; i++) {
    Vertex *pt = (Vertex *) tr_steiners->get(i);
    if (pt->is_deleted()) continue;
    if (HDE_move_interior_point(pt)) smooth_count++;
  }
  */

  int ptcount = ct_in_vrts - ct_unused_vrts;
  if (tr_steiners) {
    ptcount += tr_steiners->objects;
  }
  Vertex *moveptlist = new Vertex[ptcount];

  if (op_db_verbose > 1) {
    printf("  Calculating locations for %d points by distmesh, L0 = %g\n",
           ptcount, op_target_length);
  }
  int mcount = 0;
  int i, idx = 0;

  for (i = 0; i < ct_in_vrts; i++) {
    Vertex *mesh_vertex = &(in_vrts[i]);
    if (mesh_vertex->typ == UNUSEDVERTEX) continue;
  
    Vertex *movept = &(moveptlist[idx]);
    movept->init();
    idx++;
    
    //printf("  idx = %d fixed(%d)\n", i, mesh_vertex->is_fixed());
    if (mesh_vertex->is_fixed()) {
      // Skip a fixed vertex. Copy its coordinates for visualising.
      movept->crd[0] = mesh_vertex->crd[0];
      movept->crd[1] = mesh_vertex->crd[1];
      continue;
    }

    //if (get_distmesh_point(mesh_vertex, movept)) {
    if (HDE_get_distmesh_point(mesh_vertex, movept)) {
      movept->Pair = mesh_vertex; // Remember it.
      mcount++;
    } else {
      // Copy the vertex for visualising.
      movept->crd[0] = mesh_vertex->crd[0];
      movept->crd[1] = mesh_vertex->crd[1];
    }
  }

  if (tr_steiners != NULL) {
    for (i = 0; i < tr_steiners->used_items; i++) {
      Vertex *mesh_vertex = (Vertex *) tr_steiners->get(i);
      if (mesh_vertex->is_deleted()) continue;
    
      Vertex *movept = &(moveptlist[idx]);
      movept->init();
      idx++;

      //if (get_distmesh_point(mesh_vertex, movept)) {
      if (HDE_get_distmesh_point(mesh_vertex, movept)) {
        movept->Pair = mesh_vertex; // Remember it.
        mcount++;
      } else {
        // Copy the vertex for visualising.
        movept->crd[0] = mesh_vertex->crd[0];
        movept->crd[1] = mesh_vertex->crd[1];
      }
    }
  }

  /*
  // Save the list of new points for visualising.
  char data[256];
  sprintf(data, "%s.a.node", io_outfilename);
  FILE *fout = fopen(data, "w");
  printf("  dump moving %d vertices to %s\n", ptcount, data);
  fprintf(fout, "%d 2 0\n", ptcount);
  for (i = 0; i < ptcount; i++) {
    fprintf(fout, "%d  %g %g  0\n", i+1, moveptlist[i].crd[0], moveptlist[i].crd[1]);
  }
  fclose(fout);
  */

  if (op_db_verbose > 1) {
    printf("  Relocating %d vertices.\n", mcount);
  }
  arraypool *fqueue = new arraypool(sizeof(TriEdge), 4);
  int smooth_count = 0;   // number of direct moved vertices.
  int delins_count = 0; // number of delete/insert vertices.
  
  for (i = 0; i < ptcount; i++) {
    Vertex *mcpt = &(moveptlist[i]);
    if (mcpt->Pair == NULL) continue;
    
    Vertex *mesh_vert = mcpt->Pair;

    // This vertex might be deleted by flips.
    if (mesh_vert->typ == UNUSEDVERTEX) continue;
    if (mesh_vert->is_deleted()) continue;
    
    if (op_db_verbose > 2) {
      printf("    Relocating vertex %d.\n", mesh_vert->idx);
    }
    
    // [2019-09-11] Do not move it, if it belongs to a boundary segment.
    int bdryflag = 0; // Check if it is a boundary segment vertex (fixed).
    TriEdge E = mesh_vert->adj;
    do {
      if (E.is_segment()) {
        bdryflag = 1; break;
      } else if (E.tri->is_hulltri()) {
        bdryflag = 1; break;
      }
      E = E.eprev_esym(); // ccw
    } while (E.tri != mesh_vert->adj.tri);
    if (bdryflag) continue;
    
    // Check if we can directly move it.    
    bool bflag = true;
    //int hullflag = 0; // Check if it is a hull vertex.
    E = mesh_vert->adj;
    do {
      //if (!E.tri->is_hulltri()) {
        Vertex *pa = E.dest();
        Vertex *pb = E.apex();
        //if (Orient2d(E.dest(), E.apex(), mcpt) <= 0.) {
        if (Orient2d(pa, pb, mcpt) <= 0.) {
          bflag = false; break;
        } else {
          // Check if this triangle is nearly degenerate.
          REAL cosang_at_pa = get_cosangle(pa, pb, mcpt);
          REAL tol = 1.0 - fabs(cosang_at_pa);
          /*
          tetview>a=0.01/180.*math.pi
          tetview>print(a)
          0.00017453292519943
          tetview>print(math.cos(a))
          0.99999998476913
          tetview>a=0.1/180.*math.pi
          tetview>print(a)
          0.0017453292519943
          tetview>print(math.cos(a))
          0.99999847691329
          tetview>a=179.9/180.*math.pi
          tetview>print(a)
          3.1398473243378
          tetview>print(math.cos(a))
          -0.99999847691329
          */
          if (fabs(tol) < 1e-5) { // approx < 0.5 degree or > 179.5
            bflag = false; break;
          }
          REAL cosang_at_pb = get_cosangle(pb, pa, mcpt);
          tol = 1.0 - fabs(cosang_at_pb);
          if (fabs(tol) < 1e-5) {
            bflag = false; break;
          }
          REAL cosang_at_mc = get_cosangle(mcpt, pa, pb);
          tol = 1.0 - fabs(cosang_at_mc);
          if (fabs(tol) < 1e-5) {
            bflag = false; break;
          }
        }
      //} if (!E.tri->is_hulltri()) {
      E = E.eprev_esym(); // ccw
    } while (E.tri != mesh_vert->adj.tri);
    
    if (bflag) {
      REAL x = mcpt->crd[0];
      REAL y = mcpt->crd[1];
      if (op_db_verbose > 2) {
        //printf("    Directly move to its new position - hull(%d).\n", hullflag);
        printf("    Directly move to its new position.\n");
      }
      mesh_vert->crd[0] = x;
      mesh_vert->crd[1] = y;
      //mesh_vert->crd[2] = x*x + y*y - mesh_vert->wei;
      
      //if (op_metric > 0) {
      //  //set_vertex_metric(mesh_vert);
      //}
      HDE_set_VertexData(mesh_vert);

      // Do flips to recover Delaunayness.
      TriEdge N;
      E = mesh_vert->adj;
      do {
        E.set_edge_infect(); // A star edge
        * (TriEdge *) fqueue->alloc() = E;
        N = E.enext();       // A link edge
        N.set_edge_infect();
        * (TriEdge *) fqueue->alloc() = N;
        E = E.eprev_esym(); // ccw
      } while (E.tri != mesh_vert->adj.tri);

      HDE_lawson_flip(NULL, fqueue);
      
      smooth_count++;
      continue;
    }
    
    // Check if the new location still inside the domain.
    int chkloc = locate_point(mcpt, E, 1); // Stop at segment.
    if (chkloc == LOC_ENC_SEG) {
      // The new location is outside the domain.
      // Project it back to the segment.
      // to do...
      printf("!!! Warning: ignore an exterior location.\n");
      continue;
    } else if (chkloc == LOC_IN_OUTSIDE) {
      assert(0); // not possible in HDE case.
      continue;
    }
    
    if (op_db_verbose > 2) {
      printf("    Delete-and-Insert to its new position.\n");
    }
    // Bakup
    mcpt->idx = mesh_vert->idx;
    mcpt->tag = mesh_vert->tag;
    mcpt->wei = mesh_vert->wei;
    mcpt->val = mesh_vert->val;
    mcpt->typ = mesh_vert->typ;
    mcpt->on_dm = mesh_vert->on_dm; // for set_vertex_metric()
    
    // Remove this vertex from the triangulation.
    if (!HDE_remove_point(mesh_vert, fqueue)) {
      //assert(0); // This should always succeed.
      if (op_db_verbose > 2) {
        printf("    Failed to remove vertex %d\n", mesh_vert->idx);
      }
      // Recover Delaunay at this vertex.
      // push the link edges of mesh_vert.
      TriEdge N;
      E = mesh_vert->adj;
      do {
        E.set_edge_infect(); // A star edge
        * (TriEdge *) fqueue->alloc() = E;
        N = E.enext();       // A link edge
        N.set_edge_infect();
        * (TriEdge *) fqueue->alloc() = N;
        E = E.eprev_esym(); // ccw
      } while (E.tri != mesh_vert->adj.tri);

      HDE_lawson_flip(NULL, fqueue);
      continue;
    }
    
    HDE_lawson_flip(NULL, fqueue);

    // Insert a new vertex at (x,y).
    Vertex *newpt;
    if (mcpt->typ == STEINERVERTEX) {
      newpt = (Vertex *) tr_steiners->alloc();
      newpt->init();
    } else {
      newpt = mesh_vert;
      assert(newpt->typ == UNUSEDVERTEX);
      //ct_unused_vrts++; // [2019-11-14] Wrong counter.
      assert(mcpt->typ == FREEVERTEX);
      ct_unused_vrts--; // This input vertex will be re-used (typ = FREEVERTEX).
    }
    REAL x = mcpt->crd[0];
    REAL y = mcpt->crd[1];
    newpt->crd[0] = x;
    newpt->crd[1] = y;
    newpt->crd[2] = x*x + y*y - mcpt->wei;
    newpt->idx = mcpt->idx;
    newpt->wei = mcpt->wei; // the weight
    newpt->val = mcpt->val; // mesh size
    newpt->typ = mcpt->typ;
    newpt->on_dm = mcpt->on_dm;
    //newpt->Pair = mcpt->Pair;
    
    //if (op_metric > 0) {
      //set_vertex_metric(newpt);
    //}
    // Allocate VertexData for this new vertex.
    assert(newpt->Data == NULL);
    newpt->Data = (VertexData *) VertexDataPool->alloc();
    HDE_set_VertexData(newpt);

    TriEdge tt[4];
    E.tri = NULL;
    int loc = locate_point(newpt, E, 1); // Stop at segment.
    tt[0] = E;
    if (loc == LOC_IN_OUTSIDE) {
      int fflag = FLIP_13;
      flip(tt, &newpt, fflag, fqueue);
    } else if (loc == LOC_IN_TRI) {
      int fflag = FLIP_13;
      flip(tt, &newpt, fflag, fqueue);
    } else if (loc == LOC_ON_EDGE) {
      int fflag = FLIP_24;
      flip(tt, &newpt, fflag, fqueue);
    } else {
      assert(0); // Not possible.
    }
    HDE_lawson_flip(newpt, fqueue);
    delins_count++;
  } // i
  
  delete fqueue;

  if (op_db_verbose > 1) {
    printf("  Smoothed %d vertices, deleted/inserted %d vertices\n",
           smooth_count, delins_count);
  }

  return smooth_count + delins_count;
}

//==============================================================================

int HDE_Triangulation::HDE_check_triangle_inequality(TriEdge &E)
{
  Vertex *pa = E.org();
  Vertex *pb = E.dest();
  Vertex *pc = E.apex();

  if (op_db_verbose > 3) {
    printf("  Triangle ABC: [%d,%d,%d]:\n", pa->idx, pb->idx, pc->idx);
  }

  REAL l_ab = HDE_dist(pa, pb);
  REAL l_bc = HDE_dist(pb, pc);
  REAL l_ca = HDE_dist(pc, pa);

  if (op_db_verbose > 3) {
    printf("  Lengths AB=%g, BC=%g, CA=%g\n", l_ab, l_bc, l_ca);
  }

  // Check if triangle inequality is satisfied.
  int nonvalidflag = 0;
  if (((l_ab + l_bc) < l_ca) && (((l_ab + l_bc) / l_ca) > 1e-3)) {
    // Split edge [c,a]
    if (op_db_verbose > 3) {
      printf("  AB(%g)+BC(%g)<CA(%g)\n", l_ab, l_bc, l_ca);
    }
    E = E.eprev(); // edge [c,a]
    nonvalidflag = 1;
  }
  else if (((l_bc + l_ca) < l_ab) && (((l_bc + l_ca) / l_ab) > 1e-3)) {
    // Split edge [a,b]
    if (op_db_verbose > 3) {
      printf("  BC(%g)+CA(%g)<AB(%g)\n", l_bc, l_ca, l_ab);
    }
    nonvalidflag = 1;
  }
  else if (((l_ca + l_ab) < l_bc) && (((l_ca + l_ab) / l_bc) > 1e-3)) {
    // Split edge [b,c]
    if (op_db_verbose > 3) {
      printf("  CA(%g)+AB(%g)<BC(%g)\n", l_ca, l_ab, l_bc);
    }
    E = E.enext(); // edge [b,c]
    nonvalidflag = 1;
  }

  return nonvalidflag;
}

//==============================================================================
// A trianle is bad if contains small or large HDE-angles.

int HDE_Triangulation::HDE_check_triangle_quality(TriEdge &E)
{
  Vertex *pa = E.org();
  Vertex *pb = E.dest();
  Vertex *pc = E.apex();

  if (op_db_verbose > 3) {
    printf("  Triangle ABC: [%d,%d,%d]:\n", pa->idx, pb->idx, pc->idx);
  }

  // Check if it is valid.
  REAL ori = Orient2d(pa, pb, pc);
  if (ori <= 0.) {
    return 1; // An inverted or degenerated triangle.
  }

  REAL l_ab = get_distance(pa, pb); //HDE_dist(pa, pb);
  REAL l_bc = get_distance(pb, pc); //HDE_dist(pb, pc);
  REAL l_ca = get_distance(pc, pa); //HDE_dist(pc, pa);

  if (op_db_verbose > 3) {
    printf("  Lengths AB=%g, BC=%g, CA=%g\n", l_ab, l_bc, l_ca);
  }

  /*
  // First check if triangle inequality is satisfied.
  int nonvalid_flag = 0;
  if (((l_ab + l_bc) < l_ca) && (((l_ab + l_bc) / l_ca) > 1e-3)) {
    // Split edge [c,a]
    if (op_db_verbose > 3) {
      printf("  AB(%g)+BC(%g)<CA(%g)\n", l_ab, l_bc, l_ca);
    }
    E = E.eprev(); // edge [c,a]
    nonvalid_flag = 1;
  }
  else if (((l_bc + l_ca) < l_ab) && (((l_bc + l_ca) / l_ab) > 1e-3)) {
    // Split edge [a,b]
    if (op_db_verbose > 3) {
      printf("  BC(%g)+CA(%g)<AB(%g)\n", l_bc, l_ca, l_ab);
    }
    nonvalid_flag = 1;
  }
  else if (((l_ca + l_ab) < l_bc) && (((l_ca + l_ab) / l_bc) > 1e-3)) {
    // Split edge [b,c]
    if (op_db_verbose > 3) {
      printf("  CA(%g)+AB(%g)<BC(%g)\n", l_ca, l_ab, l_bc);
    }
    E = E.enext(); // edge [b,c]
    nonvalid_flag = 1;
  }

  if (nonvalid_flag) {
    return 1; // A bad quality triangle.
  }
  */

  // Check if there is a bad angle.
  REAL cosA = (l_ca*l_ca + l_ab*l_ab - l_bc*l_bc) / (2.* l_ca * l_ab);
  REAL cosB = (l_ab*l_ab + l_bc*l_bc - l_ca*l_ca) / (2.* l_ab * l_bc);
  REAL cosC = (l_bc*l_bc + l_ca*l_ca - l_ab*l_ab) / (2.* l_bc * l_ca);
    
  if (cosA >  1.0) cosA =  1.0;
  if (cosA < -1.0) cosA = -1.0;
  if (cosB >  1.0) cosB =  1.0;
  if (cosB < -1.0) cosB = -1.0;
  if (cosC >  1.0) cosC =  1.0;
  if (cosC < -1.0) cosC = -1.0;
    
  if (op_db_verbose > 3) {
    printf("  Angles (degree) A=%g, B=%g, C=%g\n", acos(cosA) / PI * 180.0,
           acos(cosB) / PI * 180.0, acos(cosC) / PI * 180.0);
  }

  // Get the largest HDE angle of this triangle.
  TriEdge EmaxAng = E;
  REAL cosMaxAngle = cosA;
  if (cosB < cosMaxAngle) {
    if (cosC < cosB) {
      cosMaxAngle = cosC;
      EmaxAng = E.eprev(); // [c,a]
    } else {
      cosMaxAngle = cosB;
      EmaxAng = E.enext(); // [b,c]
    }
  } else if (cosC < cosMaxAngle) {
    cosMaxAngle = cosC;
    EmaxAng = E.eprev(); // [c,a]
  }

  if (op_db_verbose > 3) {
    printf("  Largest angle at [%d] %g (degree)\n", EmaxAng.org()->idx,
           acos(cosMaxAngle) / PI * 180.0);
  }

  //if (cosMaxAngle < op_target_cos_max_angle) {
  //  E = EmaxAng;
  //  return 2; // The largest HDE angle of this triangle is too big.
  //}

  // Get the minimum angle.
  TriEdge EminAng = E;
  REAL cosMinAngle = cosA;
  if (cosB > cosMinAngle) {
    if (cosC > cosB) {
      cosMinAngle = cosC;
      EminAng = E.eprev(); // [c,a]
    } else {
      cosMinAngle = cosB;
      EminAng = E.enext(); // [b,c]
    }
  } else if (cosC > cosMinAngle) {
    cosMinAngle = cosC;
    EminAng = E.eprev(); // [c,a]
  }

  if (op_db_verbose > 3) {
    printf("  Smallest angle at [%d] %g (degree)\n",
           EminAng.org()->idx, acos(cosMinAngle) / PI * 180.0);
  }

  if (cosMinAngle > op_target_cos_min_angle) {
    E = EminAng;
    return 3;
  }

  return 0;
}

//==============================================================================
// Remove the given triangle (tri) which has a large HDE angle at tri->vrt[0].

int HDE_Triangulation::HDE_repair_large_angle(Triang *tri, int *remove_count, arraypool* fqueue)
{
  TriEdge E;
  if (!get_triangle(tri->vrt[0], tri->vrt[1], tri->vrt[2], E)) {
    return 0;
  }

  Vertex *pa = E.org();
  Vertex *pb = E.dest();
  Vertex *pc = E.apex();

  if (op_db_verbose > 3) {
    printf("  Repair a large HDE angle (%g) at ABC: [%d,%d,%d]\n",
           tri->cct[0], pa->idx, pb->idx, pc->idx);
  }
  *remove_count = 0;

  /*
  // Split the opposite edge [B,C] at the projection of A.
  // TO DO... find the bisector of the large angle.
  double l_ab = get_distance(pa, pb);
  double l_bc = get_distance(pb, pc);
  double l_ca = get_distance(pc, pa);
  double cosB = (l_ab*l_ab + l_bc*l_bc - l_ca*l_ca) / (2.* l_ab * l_bc);
  double l_bd = l_ab * cosB;
  double t = l_bd / l_bc;

  Vertex *ppt; // for returning the new vertex.
  if ((t > 0.) && (t < 1.)) {
    E = E.enext(); // the split edge [b,c].
    if (!HDE_split_edge(E, t, &ppt, fqueue)) {
      return 0;
    }
  } else {
    return 0;
  }
  */
  
  // Remove this large angle by moving the vertex A to the middle of the edge [B,C].
  // Split the opposite edge [B,C] at its middle -- bisect the largest angle.
  Vertex *ppt; // for returning the new vertex.
  E = E.enext(); // the split edge [b,c].
  if (!HDE_split_edge(E, 0., &ppt, fqueue)) { // t = 0.
    return 0;
  }
  // Remov the vertex A.
  if (!HDE_remove_point(pa, fqueue)) {
    //assert(0); // Debug this case.
    return 0;
  }

  // Remove too close vertices measured in HDE distance.
  while (1) {
    assert(ppt != NULL);
    if (ppt->is_deleted()) {
      break;
    }
    double lmin = HDE_get_vertex_size(ppt);
    //int conflict_flag = 0;
    if (lmin < (op_target_length * 0.1)) {
      Vertex *rempt = ppt->adj.dest();
      if (op_db_verbose > 3) {
        printf("    Remove a very close vertex %d.\n", rempt->idx);
      }
      //if (rempt == pa) {
        // The neartest point is just the apex (with a large angle).
        //assert(0); // A conflict is detected.
        //conflict_flag = 1;
      //}
      if (HDE_remove_point(rempt, fqueue)) {
        (*remove_count)++;
        continue;
      } else {
        if (rempt->typ == STEINERVERTEX) {
          assert(0); // Debug, why we can't remove it.
        }
      }
    }
    break;
  } // while (1)

  return 1;
}

//==============================================================================
// Remove the given triangle (tri) which has a small HDE angle at tri->vrt[0].

int HDE_Triangulation::HDE_repair_small_angle(Triang *tri, int *remove_count, arraypool* fqueue)
{
  TriEdge E;
  if (!get_triangle(tri->vrt[0], tri->vrt[1], tri->vrt[2], E)) {
    return 0;
  }

  Vertex *pa = E.org();
  Vertex *pb = E.dest();
  Vertex *pc = E.apex();

  if (op_db_verbose > 3) {
    printf("  Repair a small HDE angle (%g) at ABC: [%d,%d,%d]\n", 
           tri->cct[0], pa->idx, pb->idx, pc->idx);
  }
  *remove_count = 0;

  // Get the two HDE lengths at the vertex A (small angle).
  REAL l_ab = get_distance(pa, pb); // HDE_dist(pa, pb);
  REAL l_ac = get_distance(pa, pc); // HDE_dist(pa, pc);

  // Compare them.
  REAL diff  = (l_ab / l_ac - 1.0);
  REAL diff2 = (l_ac / l_ab - 1.0);
  if ((fabs(diff) > 0.3) || (fabs(diff2) > 0.3)) {
    // The two edge lengths are much different.
    // Remove this triangle by moving one of the vertices (B or C) onto the 
    //   longer edge [A,B] or [A,C].
        /*
    Vertex *ppt;
    if (diff > 0) {
      // Move C onto [A,B].
      if (pc->is_fixed()) {
        return 0;
      }
      if (!HDE_split_edge(E, 0., &ppt, fqueue)) { // t = 0.
        return 0;
      }
      if (!HDE_remove_point(pc, fqueue)) {
        return 0;
      }
    } else {
      // Move B onto [C,A]
      if (pb->is_fixed()) {
        return 0;
      }
      E = E.eprev();
      if (!HDE_split_edge(E, 0., &ppt, fqueue)) { // t = 0.
        return 0;
      }
      if (!HDE_remove_point(pb, fqueue)) {
        return 0;
      }
    }

    // Remove too close vertices measured in HDE distance.
    while (1) {
      assert(ppt != NULL);
      if (ppt->is_deleted()) {
        break;
      }
      double lmin = HDE_get_vertex_size(ppt);
      //int conflict_flag = 0;
      if (lmin < (op_target_length * 0.1)) {
        Vertex *rempt = ppt->adj.dest();
        if (op_db_verbose > 3) {
          printf("    Remove a very close vertex %d.\n", rempt->idx);
        }
        if (HDE_remove_point(rempt, fqueue)) {
          (*remove_count)++;
          continue;
        }
      }
      break;
    } // while (1)
    */
    
    // [2019-11-18]
    if (diff > 0) {
      // Move C onto [A,B].
      if (pc->is_fixed()) {
        return 0;
      }

      Vertex *newvrt = (Vertex *) tr_steiners->alloc();
      newvrt->init();
      newvrt->on_dm = pc->on_dm; // [2019-11-06]
      newvrt->Data = (VertexData *) VertexDataPool->alloc();
      newvrt->Data->init();
      newvrt->idx = io_firstindex + (ct_in_vrts + tr_steiners->objects - 1);
      newvrt->typ = STEINERVERTEX;

      // Split [A, B] at its middle.
      newvrt->crd[0] = 0.5 * (pa->crd[0] + pb->crd[0]);
      newvrt->crd[1] = 0.5 * (pa->crd[1] + pb->crd[1]);
      HDE_set_VertexData(newvrt);
      
      // Insert the new point (split the edge).
      int fflag = FLIP_24;
      TriEdge tt[4];
      tt[0] = E; // [pa, pb, c]
      //tt[2] = tt[0].esym(); // [e2, e1, d]
      flip(tt, &newvrt, fflag, NULL);
      
      // Remove pc.
      
    }

  } else {
    // The two edges are similar.
    // Shrink the edge [B,C].
    if ((pb->is_fixed()) || (pb->on_bd.tri != NULL)) {
      // We can't move pb. Try to delete pc.
      if ((pc->is_fixed()) || (pc->on_bd.tri != NULL)) {
        return 0; // No way to remove this small angle.
      }
      if (!HDE_remove_point(pc, fqueue)) {
        return 0;
      }
    } else {
      if ((pc->is_fixed()) || (pc->on_bd.tri != NULL)) {
        // We can't move pc. Try to delete pb.
        if (!HDE_remove_point(pb, fqueue)) {
          return 0;
        }
      } else {
        // Both pb and pc are free to move.
        // Collpase the opposite edge [B,C].
        // First bisect the edge [B,C], then remove both vertices B and C.
        Vertex *ppt; // for returning the new vertex.
        E = E.enext(); // the split edge [b,c].
        if (!HDE_split_edge(E, 0., &ppt, fqueue)) { // t = 0.
          return 0;
        }
        if (HDE_remove_point(pb, fqueue)) {
          (*remove_count)++;
        }
        if (HDE_remove_point(pc, fqueue)) {
          (*remove_count)++;
        }
      }
    }
  }

  return 1;
}

//==============================================================================
/*
int HDE_Triangulation::HDE_repair_triangles()
{
  arraypool *fqueue = new arraypool(sizeof(TriEdge), 8);
  TriEdge E;
  int tri_count = 0;

  for (int i = 0; i < tr_tris->used_items; i++) {
    E.tri = (Triang *) tr_tris->get(i);
    if (E.tri->is_deleted()) continue;
    if (E.tri->is_hulltri()) continue;
    if (HDE_check_triangle_inequality(E)) {
      Vertex *newpt;
      if (HDE_split_edge(E, 0., &newpt, fqueue)) { // split, t = 0.
        tri_count++;
      }
    }
  }

  delete fqueue;
  return tri_count;
}
*/

int HDE_Triangulation::HDE_repair_triangles()
{
  arraypool *tri_list = new arraypool(sizeof(Triang), 10);
  TriEdge E;
  int repair_count = 0;
  int type, i;
  
  for (i = 0; i < tr_tris->used_items; i++) {
    E.tri = (Triang *) tr_tris->get(i);
    if (E.tri->is_deleted()) continue;
    if (E.tri->is_hulltri()) continue;
    type = HDE_check_triangle_quality(E);
    if (type > 0) {
      // Found a bad quality triangle.
      Triang *tri = (Triang *) tri_list->alloc();
      tri->vrt[0] = E.org();
      tri->vrt[1] = E.dest();
      tri->vrt[2] = E.apex();
      tri->idx = type;
    }
  }
  
  if (tri_list->objects == 0) {
    delete tri_list;
    return repair_count;
  }

  if (op_db_verbose) {
      printf("  Found %d max angle.\n", tri_list->objects);
  }
  if (op_db_verbose > 4) {
    FILE *fout = fopen("split_tri.lua", "w");
    HDE_dump_triangles(tri_list, fout);
    fclose(fout);
  }
  
  //arraypool *fqueue = new arraypool(sizeof(TriEdge), 8);
  //int rem_count = 0;

  for (i = 0; i < tri_list->objects; i++) {
    Triang *tri = (Triang *) tri_list->get(i);
    type = tri->idx;
    if (type == 1) {
      // Repair an inverted/degenerated triangle.
    } else if (type == 2) {
      // repair a large angle.
    } else if (type == 3) {
      // repair a small angle.
    } else {
        assert(0); // unknown type
    }
  }

  //delete fqueue;
  delete tri_list;
  return repair_count;
}

//==============================================================================
/*
int HDE_Triangulation::HDE_repair_large_angles()
{
  arraypool *tri_list = new arraypool(sizeof(Triang), 10);
  int repair_count = 0, remove_count = 0;
  TriEdge E;

  for (int i = 0; i < tr_tris->used_items; i++) {
    E.tri = (Triang *) tr_tris->get(i);
    if (E.tri->is_deleted() || E.tri->is_hulltri()) continue;
    double max_ang = HDE_get_max_angle(E);
    if (max_ang > op_target_max_angle) {
      // Found a large angle.
      Triang *trinew = (Triang *) tri_list->alloc();
      trinew->vrt[0] = E.org();
      trinew->vrt[1] = E.dest();
      trinew->vrt[2] = E.apex();
      trinew->cct[0] = max_ang;
    }
  }

  if (tri_list->objects > 0) {
    if (op_db_verbose) {
      printf("  Found %d max angle.\n", tri_list->objects);
    }
    if (op_db_verbose > 2) {
      FILE *fout = fopen("split_tri.lua", "w");
      HDE_dump_triangles(tri_list, fout);
      fclose(fout);
    }
    //mesh_phase = 4;

    // Sort the list according to their max_angle.
    Triang swapt, *ti, *tj;
    bool swapped;
    int n = tri_list->used_items;
    do {
      swapped = false;
      for (int i = 1; i < n; i++) {
        ti = (Triang *) tri_list->get(i-1);
        tj = (Triang *) tri_list->get(i);
        if (ti->cct[0] < tj->cct[0]) {
          swapt = *ti;
          *ti = *tj;
          *tj = swapt;
          swapped = true;
        }
      }
      n--;
    } while (swapped);
    
    if (op_db_verbose > 2) {
      FILE *fout = fopen("split_tri_sorted.lua", "w");
      HDE_dump_triangles(tri_list, fout);
      fclose(fout);
    }

    arraypool *fqueue = new arraypool(sizeof(TriEdge), 8);
    int rem_count = 0;

    for (int i = 0; i < tri_list->objects; i++) {
      Triang *tri = (Triang *) tri_list->get(i);
      if (HDE_repair_large_angle(tri, &rem_count, fqueue)) {
        repair_count++;
        remove_count+=rem_count;
      }
    }

    if (op_db_verbose > 1) {
      printf("  Split %d edges, removed %d vertices\n", repair_count, remove_count);
    }

    delete fqueue;
    //mesh_phase = 0;
  }

  delete tri_list;
  return repair_count;
}
*/
//==============================================================================
/*
int HDE_Triangulation::HDE_repair_small_angles()
{
  arraypool *tri_list = new arraypool(sizeof(Triang), 10);
  int repair_count = 0, remove_count = 0;
  TriEdge E;

  for (int i = 0; i < tr_tris->used_items; i++) {
    E.tri = (Triang *) tr_tris->get(i);
    if (E.tri->is_deleted() || E.tri->is_hulltri()) continue;
    double min_ang = HDE_get_min_angle(E);
    if (min_ang < op_target_min_angle) {
      // Found a small angle.
      Triang *trinew = (Triang *) tri_list->alloc();
      trinew->vrt[0] = E.org();
      trinew->vrt[1] = E.dest();
      trinew->vrt[2] = E.apex();
      trinew->cct[0] = min_ang;
    }
  }

  if (tri_list->objects > 0) {
    if (op_db_verbose) {
      printf("  Found %d min angle.\n", tri_list->objects);
    }
    if (op_db_verbose > 2) {
      FILE *fout = fopen("split_tri.lua", "w");
      HDE_dump_triangles(tri_list, fout);
      fclose(fout);
    }
    //mesh_phase = 4;

    // Sort the list according to their max_angle.
    Triang swapt, *ti, *tj;
    bool swapped;
    int n = tri_list->used_items;
    do {
      swapped = false;
      for (int i = 1; i < n; i++) {
        ti = (Triang *) tri_list->get(i-1);
        tj = (Triang *) tri_list->get(i);
        if (ti->cct[0] > tj->cct[0]) {
          swapt = *ti;
          *ti = *tj;
          *tj = swapt;
          swapped = true;
        }
      }
      n--;
    } while (swapped);
    
    if (op_db_verbose > 2) {
      FILE *fout = fopen("split_tri_sorted.lua", "w");
      HDE_dump_triangles(tri_list, fout);
      fclose(fout);
    }

    arraypool *fqueue = new arraypool(sizeof(TriEdge), 8);
    int rem_count = 0;

    for (int i = 0; i < tri_list->objects; i++) {
      Triang *tri = (Triang *) tri_list->get(i);
      if (HDE_repair_small_angle(tri, &rem_count, fqueue)) {
        repair_count++;
        remove_count+=rem_count;
      }
    }

    if (op_db_verbose > 1) {
      printf("  Shrinked %d edges, removed %d vertices\n", repair_count, remove_count);
    }

    delete fqueue;
    //mesh_phase = 0;
  }

  delete tri_list;
  return repair_count;
}
*/
//==============================================================================

void HDE_Triangulation::HDE_mesh_adapt()
{
  //HDE_prepare();
  //if (op_use_metric) {
  //  HDE_metric_prepare();
  //}

  mesh_statistics();
  HDE_quality_statistic();
  //if (op_report_quality_only) { // report_quality=1
  //  if (op_save_inter_meshes) { // save_inter_meshes=1;
  //    writeEmbeddedTriangleError(0);
  //  }
  //  return;
  //}

  op_no_bisect = 1; // Default, do not modify boundaries.

  int meshidx = 0;
  // Save an input for conformal mapping.
  //save_m(); // to file dump_hde2.m
  //writeEmbeddedMeshLifted(meshidx); meshidx++; // to file lift_0.inp

  if (op_target_length == 0.) {
    op_target_length = geo_average_length; // HDE_get_average_length();
  }

  printf("Mesh adaptation via HDE.\n");
  printf("  - Target HDE edge length = %g.\n", op_target_length);
  //printf("  - Target HDE min angle = %g (degree).\n", op_target_angle/PI*180.);
  printf("  - s1 = %g, s2 = %g, s3 = %g\n", op_s1, op_s2, op_s3);
  printf("  - max size iteration = %d.\n", op_max_size_iter);
  printf("  - max quality iteration = %d.\n", op_max_quality_iter);
  printf("  - use %d integral points.\n", op_use_intpoints);

  arraypool *fqueue = new arraypool(sizeof(TriEdge), 10);
  int total_rem_count = 0;
  int total_split_count = 0;
  int total_repair_count = 0;
  int count;
  int it = 0;

  if (op_save_inter_meshes) {
    writeEmbeddedEdgeLength(meshidx);
    writeEmbeddedMeshLifted(meshidx); meshidx++;
  }

  // Pre-processing
  if (op_target_length > 0.) {
    HDE_lawson_flip(NULL, fqueue);
    // Remove too small edges.
    for (int s = 0; s < 3; s++) {
      int count = HDE_coarsen_mesh();
      if (count == 0) break;
    }
    if (op_save_inter_meshes) {
      writeEmbeddedEdgeLength(meshidx);
      writeEmbeddedMeshLifted(meshidx); meshidx++;
    }
  }

  // Mesh adaptation for mesh size
  for (it = 0; it < op_max_size_iter; it++) {
    printf("Mesh size iter %d:\n", it+1);
    
    int rem_count = 0;
    int split_count = 0;
    int smooth_count = 0;
    int repair_count = 0;

    //if (op_save_inter_meshes) {
    //  //writeEmbeddedTriangleError(meshidx);
    //  writeEmbeddedEdgeLength(meshidx);
    //  writeEmbeddedMeshLifted(meshidx); meshidx++;
    //}

    if (op_target_length > 0.0) {
      // Adding Steiner points to satisfy the mesh size.
      int s = 0;

      //for (s = 0; s < op_split_iter; s++) {
        // Split long edges.
        count = HDE_split_edges();
        if (count == 0) break;

        split_count += count; total_split_count += count; 
        if (op_save_inter_meshes) {
          writeEmbeddedMeshLifted(meshidx); meshidx++;
        }

        // Remove too close Steiner points.
        //count = HDE_coarsen_mesh();

        rem_count+=count; total_rem_count += count;
        if (op_save_inter_meshes && (count > 0)) {
          writeEmbeddedMeshLifted(meshidx); meshidx++;
        }
      //}

      if (op_db_verbose) {
        printf("  Used %d rounds, split %d edges, removed %d vertices\n",
               s, split_count, rem_count);
      } 
      assert(fqueue->objects == 0);

      count = HDE_lawson_flip(NULL, fqueue);
      if (op_save_inter_meshes && (count > 0)) {
        writeEmbeddedMeshLifted(meshidx); meshidx++;
      }
    }

    if (0) { //} if (op_use_smoothing) { // [2019-11-06] Need smoothing.
      for (int s = 0; s < op_smooth_iter; s++) {
        count = HDE_smooth_vertices();
        if (count == 0) break;
        smooth_count += count; //total_smooth_count += count;
      }

      if (op_db_verbose) {
        printf("  smoothed %d vertices\n", smooth_count);
      }
      if (op_save_inter_meshes && (smooth_count > 0)) {
        writeEmbeddedMeshLifted(meshidx); meshidx++;
      }

      assert(fqueue->objects == 0);
      count = HDE_lawson_flip(NULL, fqueue);
      if (op_save_inter_meshes && (count > 0)) {
        writeEmbeddedMeshLifted(meshidx); meshidx++;
      }
    } // if (op_use_smoothing)

    if (0) { // if (op_use_repairing) {
      // Repair triangle inequality.
      for (int s = 0; s < 3; s++) {
        count = HDE_repair_triangles();
        if (count == 0) break;
        repair_count += count; total_repair_count += count;
        if (op_save_inter_meshes && (count > 0)) {
          writeEmbeddedMeshLifted(meshidx); meshidx++;
        }
      }
      if (op_db_verbose) {
        printf("  repaired %d triangles\n", repair_count);
      }
    }

    // Stop earlier when no operation has been performed.
    int totalcount = rem_count + split_count + repair_count; // + smooth_count;
    if (totalcount == 0) break;
  } // it

  printf("\nMesh size done.\n");
  if (op_db_verbose) {
    printf(" - Total number of iterations: %d.\n", it+1);
    printf(" - Total number of deleted vertices: %d.\n", total_rem_count);
    printf(" - Total number of split edges: %d.\n", total_split_count);
    printf(" - Total number of repaired triangles: %d.\n", total_repair_count);

    HDE_quality_statistic();
  }

  /*
  // Mesh adaptation for improving mesh quality
  total_repair_count = 0;
  for (it = 0; it < op_max_quality_iter; it++) {
    printf("Mesh quality iter %d:\n", it+1);
    //if (op_save_inter_meshes) {
    //  writeEmbeddedTriangleError(meshidx);
    //}

    int countMaxAng = 0, countMinAng = 0;
    if (op_target_max_angle > 0.) {
      if (op_save_inter_meshes) {
        writeEmbeddedTriangleMaxAngle(meshidx);
      }
      countMaxAng = HDE_repair_large_angles();
      if (countMaxAng > 0) {
        if (op_db_verbose) {
          printf("  Repaired %d large angles\n", countMaxAng);
        }
        total_repair_count += countMaxAng;
        if (op_save_inter_meshes) {
          writeEmbeddedMeshLifted(meshidx); meshidx++;
        }
      } // if (countMaxAng > 0)
    }
    if (op_target_min_angle > 0.) {
      if (op_save_inter_meshes) {
        writeEmbeddedTriangleMinAngle(meshidx);
      }
      countMinAng = HDE_repair_small_angles();
      if (countMinAng > 0) {
        if (op_db_verbose) {
          printf("  Repaired %d small angles\n", countMinAng);
        }
        total_repair_count += countMinAng;
        if (op_save_inter_meshes) {
          writeEmbeddedMeshLifted(meshidx); meshidx++;
        }
      } // if (countMinAng > 0)
    } // if (op_target_min_angle > 0.)

    if (countMaxAng + countMinAng == 0) break;

    if (op_use_smoothing) {
      int smooth_count = 0;
      for (int s = 0; s < op_smooth_iter; s++) {
        count = HDE_smooth_vertices();
        if (count == 0) break;
        smooth_count += count; //total_smooth_count += count;
      }
      if (op_db_verbose) {
        printf("  smoothed %d vertices\n", smooth_count);
      }
      if (op_save_inter_meshes && (smooth_count > 0)) {
        writeEmbeddedMeshLifted(meshidx); meshidx++;
      }
      assert(fqueue->objects == 0);
      count = HDE_lawson_flip(NULL, fqueue);
      if (op_save_inter_meshes && (count > 0)) {
        writeEmbeddedMeshLifted(meshidx); meshidx++;
      }
    }

    if (op_use_repairing) {
      // Repair triangle inequality.
      int repair_count = 0;
      for (int s = 0; s < 3; s++) {
        count = HDE_repair_triangles();
        if (count == 0) break;
        repair_count += count; total_repair_count += count;
        if (op_save_inter_meshes && (count > 0)) {
          writeEmbeddedMeshLifted(meshidx); meshidx++;
        }
      }
      if (op_db_verbose) {
        printf("  repaired %d triangles\n", repair_count);
      }
    }
  } // for (it = 0
  
  printf("\nMesh quality done.\n");
  if (op_db_verbose) {
    printf(" - Total number of repaired triangles: %d.\n", total_repair_count);
  }
  */

  // Output the final mesh with solution.
  writeEmbeddedMeshLifted(meshidx);

  mesh_statistics();
  HDE_quality_statistic();

  delete fqueue;
}

//==============================================================================

void HDE_Triangulation::HDE_quality_statistic()
{
  printf("\nHDE Mesh quality statistics:\n\n");

  int angletable[18];
  REAL edgelength;
  REAL smallestangle = PI;
  REAL biggestangle = 0.;
  REAL shortest, longest;
  int tendegree;
  int tineq_count = 0;
  int i;

  //REAL radconst = PI / 18.0;
  REAL degconst = 180.0 / PI;

  for (i = 0; i < 18; i++) {
    angletable[i] = 0;
  }

  shortest = 1.0e30; // geo_domain_diameter;
  longest = 0.0;

  TriEdge smallEdge, longEdge;
  TriEdge smallAngle, largeAngle;
  TriEdge E;

  for (int I = 0; I < tr_tris->used_items; I++) {
    E.tri = (Triang *) tr_tris->get(I);
    if (E.tri->is_deleted()) continue;
    if (E.tri->is_hulltri()) continue;

    E.ver = 0;
    Vertex *pa = E.org();
    Vertex *pb = E.dest();
    Vertex *pc = E.apex();

    if (op_db_verbose > 3) {
      printf("  Triangle ABC: [%d,%d,%d]:\n", pa->idx, pb->idx, pc->idx);
    }

    REAL l_ab = HDE_dist(pa, pb);
    REAL l_bc = HDE_dist(pb, pc);
    REAL l_ca = HDE_dist(pc, pa);

    if (op_db_verbose > 3) {
      printf("  Lengths AB=%g, BC=%g, CA=%g\n", l_ab, l_bc, l_ca);
    }

    bool tineq = true;  // check the triangle inequality.
    if ((l_ab + l_bc) <= l_ca) {
      // edge [c,a] is too long
      if (op_db_verbose > 3) {
        printf("  AB(%g)+BC(%g)>CA(%g)\n", l_ab, l_bc, l_ca);
      }
      E = E.eprev(); // edge [c,a]
      tineq = false; 
    } 
    else if ((l_bc + l_ca) <= l_ab) {
      // edge [a,b] is too long
      if (op_db_verbose > 3) {
        printf("  BC(%g)+CA(%g)>AB(%g)\n", l_bc, l_ca, l_ab);
      }
      tineq = false; 
    }
    else if ((l_ca + l_ab) <= l_bc) {
      // edge [b,c] is too long
      if (op_db_verbose > 3) {
        printf("  CA(%g)+AB(%g)>BC(%g)\n", l_ca, l_ab, l_bc);
      }
      E = E.enext(); // edge [b,c]
      tineq = false; 
    }

    for (E.ver = 0; E.ver < 3; E.ver++) {
      //edgelength = HDE_dist(E.org(), E.dest());
      if (E.ver == 0) {
        edgelength = l_ab;
      } else if (E.ver == 1) {
        edgelength = l_bc;
      } else {
        edgelength = l_ca;
      }
      if (edgelength > longest) {
        longest = edgelength;
        longEdge = E;
      }
      if (edgelength < shortest) {
        shortest = edgelength;
        smallEdge = E;
      }
    }

    if (tineq) {
      // Calculate angles.
      REAL cosA = (l_ca*l_ca + l_ab*l_ab - l_bc*l_bc) / (2.* l_ca * l_ab);
      REAL cosB = (l_ab*l_ab + l_bc*l_bc - l_ca*l_ca) / (2.* l_ab * l_bc);
      REAL cosC = (l_bc*l_bc + l_ca*l_ca - l_ab*l_ab) / (2.* l_bc * l_ca);
      if (cosA >  1.0) cosA =  1.0;
      if (cosA < -1.0) cosA = -1.0;
      if (cosB >  1.0) cosB =  1.0;
      if (cosB < -1.0) cosB = -1.0;
      if (cosC >  1.0) cosC =  1.0;
      if (cosC < -1.0) cosC = -1.0;
      if (op_db_verbose > 3) {
        printf("  Angles (degree) A=%g, B=%g, C=%g\n", acos(cosA) / PI * 180.0, 
           acos(cosB) / PI * 180.0, acos(cosC) / PI * 180.0);
      }
      for (E.ver = 0; E.ver < 3; E.ver++) {
        //REAL ang = HDE_angle(E.org(), E.dest(), E.apex());
        REAL ang = 0.;
        if (E.ver == 0) {
          ang = acos(cosA);
        } else if (E.ver == 1) {
          ang = acos(cosB);
        } else {
          ang = acos(cosC);
        }
        if (ang < smallestangle) {
          smallestangle = ang;
          smallAngle = E;
        } 
        if (ang > biggestangle) {
          biggestangle = ang;
          largeAngle = E;
        }
        REAL angdegree = ang * degconst;
        tendegree = (int) angdegree / 10.;
        angletable[tendegree]++;
      }
    } else {
      tineq_count++;
    }
  } // I

  printf("  Shortest edge: %16.5g   |  Longest edge: %16.5g\n",
         shortest, longest);
  printf("  Smallest angle: %15.5g   |  Largest angle: %15.5g\n\n",
         smallestangle * degconst, biggestangle * degconst);

  printf("  Angle histogram:\n");
  for (i = 0; i < 9; i++) {
    printf("    %3d - %3d degrees:  %8d    |    %3d - %3d degrees:  %8d\n",
           i * 10, i * 10 + 10, angletable[i],
           i * 10 + 90, i * 10 + 100, angletable[i + 9]);
  }
  printf("\n");

  printf("Number of triangles not satisfying triangle inequality: %d.\n", tineq_count);
  printf("\n");

  if (op_db_verbose) {
    Vertex *v0, *v1, *v2;
    REAL hdist, hangle;

    v0 = smallEdge.org();
    v1 = smallEdge.dest();
    v2 = smallEdge.apex();
    hdist = HDE_dist(v0, v1);
    printf("Shortest edge: [%d,%d]-%d, hde_dist=%g\n", v0->idx, v1->idx, v2->idx, hdist);

    v0 = longEdge.org();
    v1 = longEdge.dest();
    v2 = longEdge.apex();
    hdist = HDE_dist(v0, v1);
    printf("Longest  edge: [%d,%d]-%d, hde_dist=%g\n", v0->idx, v1->idx, v2->idx, hdist);

    v0 = smallAngle.org();
    v1 = smallAngle.dest();
    v2 = smallAngle.apex();
    hangle = HDE_angle(v0, v1, v2);
    printf("Smallest angle: [%d]-%d,%d, hde_ang=%g\n", v0->idx, v1->idx, v2->idx, hangle / PI * 180.);

    v0 = largeAngle.org();
    v1 = largeAngle.dest();
    v2 = largeAngle.apex();
    hangle = HDE_angle(v0, v1, v2);
    printf("Largest angle: [%d]-%d,%d, hde_ang=%g\n", v0->idx, v1->idx, v2->idx, hangle / PI * 180.);
  }

  // Report error.
  //REAL L2err=0., H1err=0.;
  //HDE_get_interpolation_error(&L2err, &H1err);
  //printf("\nL2err=%g, H1err=%g\n\n", L2err, H1err);
}

//==============================================================================
// Return the area of this triangle.
// Function from Liyong Zhu (buaa.edu)

REAL HDE_Triangulation::HDE_get_interpolation_errors(Triang* tri, REAL &L2err, REAL &H1err)
{
  int j,m; // i, p
  double a[3],b[3],c[3],uv[3],vx[3],vy[3],lambda[3],J,x,y,d1,d2,d3;
  double uI,uIx,uIy,exact_u,exact_ux,exact_uy;
  double ss,ss1,err,err1; // s, s1;

  //weight and nodes for numerical integration
  static double w[7]={9.0/40,1.0/15,1.0/15,1.0/15,1.0/40,1.0/40,1.0/40};
  static double g[7][3]={{1.0/3,1.0/3,1.0/3},{1.0/2,1.0/2,0},{1.0/2,0,1.0/2},{0,1.0/2,1.0/2},{1.0,0,0},{0,1.0,0},{0,0,1.0}};
  
  for (j = 0; j < 3; j++) {
    vx[j] = tri->vrt[j]->crd[0]; // x
    vy[j] = tri->vrt[j]->crd[1]; // y
    uv[j] = Func(tri->vrt[j]);   // the function value
  }
  
  //calculate the Jacobian determinant on each element
  J=(vx[0]-vx[2])*(vy[1]-vy[2])-(vy[0]-vy[2])*(vx[1]-vx[2]);
  
  a[0]=vy[1]-vy[2];a[1]=vy[2]-vy[0];a[2]=vy[0]-vy[1];
  b[0]=vx[2]-vx[1];b[1]=vx[0]-vx[2];b[2]=vx[1]-vx[0];
  c[0]=vx[1]*vy[2]-vx[2]*vy[1];
  c[1]=vx[2]*vy[0]-vx[0]*vy[2];
  c[2]=vx[0]*vy[1]-vx[1]*vy[0];

  // The gradient is constant over this triangle.
  uIx=(1.0/J)*(uv[0]*a[0]+uv[1]*a[1]+uv[2]*a[2]);
  uIy=(1.0/J)*(uv[0]*b[0]+uv[1]*b[1]+uv[2]*b[2]);

  Vertex Ipt;
  ss=0;ss1=0;
  for(m=0;m<7;m++)
  {
    d1=g[m][0];
    d2=g[m][1];
    d3=g[m][2];
    x=vx[0]*d1+vx[1]*d2+vx[2]*d3;
    y=vy[0]*d1+vy[1]*d2+vy[2]*d3;
    Ipt.crd[0] = x;
    Ipt.crd[1] = y;
    //calculate the area coordinates
    for(j=0;j<3;j++)
    {
      lambda[j]=(1.0/J)*(a[j]*x+b[j]*y+c[j]);
    }
    uI=uv[0]*lambda[0]+uv[1]*lambda[1]+uv[2]*lambda[2];
            
    exact_u  = Func (&Ipt);   // f(x,y);
    exact_ux = GradX(&Ipt); // fx(x,y);
    exact_uy = GradY(&Ipt); // fy(x,y);
            
    err=(exact_u-uI)*(exact_u-uI);
    err1=(exact_ux-uIx)*(exact_ux-uIx)+(exact_uy-uIy)*(exact_uy-uIy);
        
    ss=ss+w[m]*err*J;
    ss1=ss1+w[m]*err1*J;
  }

  L2err=ss;
  H1err=ss1;

  return J;
}

//==============================================================================

REAL HDE_Triangulation::HDE_get_interpolation_error(REAL* L2err, REAL* H1err)
{
  REAL total_l2err = 0., total_h1err = 0.;
  REAL area = 0.;
  REAL l2err, h1err;

  for (int I = 0; I < tr_tris->used_items; I++) {
    Triang *tri = (Triang *) tr_tris->get(I);
    if (tri->is_deleted()) continue;
    if (tri->is_hulltri()) continue;
    l2err = h1err = 0.;
    area += HDE_get_interpolation_errors(tri, l2err, h1err);
    total_l2err += l2err;
    total_h1err += h1err;    
  }

  *L2err = sqrt(total_l2err);
  *H1err = sqrt(total_h1err);
  return area;
}

//==============================================================================

void HDE_Triangulation::HDE_initialize()
{
  //initialize(); // initialise Detri2

  OMT_domain_VertexDataPool = NULL;

  VertexDataPool = NULL;
  Func = GradX = GradY = NULL;
  FunXX = FunXY = FunYY = NULL;

  op_use_metric = 0;
  op_use_HDE_metric = 0;

  geo_domain_diameter = 0.0;
  geo_average_length = 0.0;
  //geo_hmin = geo_hmax = 0.0;

  op_max_fun_abs = 0.0;
  op_max_grd_mag = 0.0;

  op_target_length = 0.0;

  op_s1 = 1.;
  op_s2 = 1.;
  op_s3 = 1.;

  //op_mtr_coef = 1.0;
  //op_mtr_anisomax = 1.e+6;

  op_max_size_iter = 5;
  op_max_quality_iter = 5;
  op_use_smoothing = 1; 
  op_use_repairing = 1;
  op_report_quality_only = 0;
  op_use_intpoints = 0;

  op_smooth_iter = 10;
  op_smooth_alpha = 0.01;  
  op_split_iter = 5;
  op_edge_bisect_iter = 2;
  op_edge_split_factor = 1.3;
  op_edge_collapse_factor = 0.7;
  op_max_enc_angle = 175.0 / 180.0 * PI;
  op_min_enc_angle = 5.0 / 180.0 * PI;
  
  op_save_inter_meshes = 0;
  op_test_function = 0;
}

void HDE_Triangulation::HDE_clean()
{
  if (VertexDataPool) delete VertexDataPool;
  if (OMT_domain_VertexDataPool) delete OMT_domain_VertexDataPool;
  //clean();  // clean Detri2
}

HDE_Triangulation::HDE_Triangulation()
{
  HDE_initialize();
}

HDE_Triangulation::~HDE_Triangulation()
{
  HDE_clean();
}

//==============================================================================

//int main(int argc, char *argv[])
//{
//  printf("Detri2 HDE (2019-11)\n");
//  return 1;
//}
