#include "scribblearea.h"
//#include "hdeoptionpanel.h"
//#include <QDebug>

hdeoptionPanel::hdeoptionPanel(void *scribblearea, QWidget *parent) : QWidget(parent)
{
    _scribblearea = scribblearea;

    QGroupBox *groupBox_HDE = new QGroupBox(tr("HDE options"));
    QGridLayout *layout_HDE = new QGridLayout;
    hde_s1_label = new QLabel("s1");
    hde_s1 = new QLineEdit;
    hde_s1->setText(tr("1.0"));
    hde_s2_label = new QLabel("s2");
    hde_s2 = new QLineEdit;
    hde_s2->setText(tr("1.0"));
    hde_min_len_label = new QLabel("Target length");
    hde_min_len = new QLineEdit;
    hde_min_len->setText(tr("0.3"));
    hde_min_angle_label = new QLabel("Target angle (degree)");
    hde_min_angle = new QLineEdit;
    hde_min_angle->setText(tr("10"));
    hde_max_size_iter_label = new QLabel("Mesh size iterations");
    hde_max_size_iter = new QLineEdit;
    hde_max_size_iter->setText(tr("3"));
    hde_max_quality_iter_label = new QLabel("Mesh quality iteration");
    hde_max_quality_iter = new QLineEdit;
    hde_max_quality_iter->setText(tr("2"));
    hde_use_intpoints_label = new QLabel("Interior points");
    hde_use_intpoints = new QLineEdit;
    hde_use_intpoints->setText(tr("2"));

    hde_use_smooth = new QCheckBox("Use smoothing");
    hde_use_smooth->setChecked(true);
    hde_smooth_iter_label = new QLabel("Smoothing iterations");
    hde_smooth_iter = new QLineEdit;
    hde_smooth_iter->setText(tr("5"));
    hde_smooth_alpha_label = new QLabel("Smoothing alpha");
    hde_smooth_alpha = new QLineEdit;
    hde_smooth_alpha->setText(tr("0.01"));

    //op_verbose_label = new QLabel(tr("Verbose"));
    //line_op_verbose = new QLineEdit;
    //line_op_verbose->setText(tr("0"));

    layout_HDE->addWidget(hde_s1_label, 0, 0, 1, 1);
    layout_HDE->addWidget(hde_s1, 0, 1, 1, 1);
    layout_HDE->addWidget(hde_s2_label, 1, 0, 1, 1);
    layout_HDE->addWidget(hde_s2, 1, 1, 1, 1);
    layout_HDE->addWidget(hde_min_len_label, 2, 0, 1, 1);
    layout_HDE->addWidget(hde_min_len, 2, 1, 1, 1);
    layout_HDE->addWidget(hde_min_angle_label, 3, 0, 1, 1);
    layout_HDE->addWidget(hde_min_angle, 3, 1, 1, 1);
    layout_HDE->addWidget(hde_max_size_iter_label, 4, 0, 1, 1);
    layout_HDE->addWidget(hde_max_size_iter, 4, 1, 1, 1);
    layout_HDE->addWidget(hde_max_quality_iter_label, 5, 0, 1, 1);
    layout_HDE->addWidget(hde_max_quality_iter, 5, 1, 1, 1);
    layout_HDE->addWidget(hde_use_intpoints_label, 6, 0, 1, 1);
    layout_HDE->addWidget(hde_use_intpoints, 6, 1, 1, 1);
    layout_HDE->addWidget(hde_use_smooth, 7,0,1,1);
    layout_HDE->addWidget(hde_smooth_iter_label, 8, 0, 1, 1);
    layout_HDE->addWidget(hde_smooth_iter, 8, 1, 1, 1);
    layout_HDE->addWidget(hde_smooth_alpha_label, 9, 0, 1, 1);
    layout_HDE->addWidget(hde_smooth_alpha, 9, 1, 1, 1);
    //layout_HDE->addWidget(op_verbose_label, 10,0);
    //layout_HDE->addWidget(line_op_verbose, 10,1);
    groupBox_HDE->setLayout(layout_HDE);

    /*
    listWidget = new QListWidget(this);
    QListWidgetItem *newItem1 = new QListWidgetItem;
    newItem1->setText("test function 1");
    listWidget->insertItem(0, newItem1);
    QListWidgetItem *newItem2 = new QListWidgetItem;
    newItem2->setText("test function 2");
    listWidget->insertItem(1, newItem2);
    */

    /*
    printf("Please choose a test function by set test_fun=#:\n");
    printf("  1, Gaussian.\n");
    printf("  2, Lennard.\n");
    printf("  3, Alauzet.\n");
    printf("  4, Huang.\n");
    printf("  5, Du.\n");
    printf("  6, Gaussian2.\n");
    printf("  7, BAMG.\n");
    printf("  8, Rosenbrock.\n");
    */

    hde_test_fun_label = new QLabel("test function");
    hde_testfun_ComboBox = new QComboBox();
    hde_testfun_ComboBox->addItem("1, Gaussian");
    hde_testfun_ComboBox->addItem("2, f2, Lennard");
    hde_testfun_ComboBox->addItem("3, f3, Alauzet");
    hde_testfun_ComboBox->addItem("4, Huang");
    hde_testfun_ComboBox->addItem("5, f4"); //hde_testfun_ComboBox->addItem("5, Du");
    hde_testfun_ComboBox->addItem("6, Gaussian2");
    hde_testfun_ComboBox->addItem("7, BAMG");
    hde_testfun_ComboBox->addItem("8, Rosenbrock");

    QHBoxLayout *hbox_testfun = new QHBoxLayout;
    hbox_testfun->addWidget(hde_test_fun_label);
    hbox_testfun->addWidget(hde_testfun_ComboBox);
    QGroupBox *group_testfun = new QGroupBox;
    group_testfun->setLayout(hbox_testfun);

    hde_report_error_only = new QCheckBox(tr("Report (L2 and H1) errors only"));

    //QHBoxLayout *hbox_Btn = new QHBoxLayout;
    QGridLayout *layout_Btn = new QGridLayout;
    btnGenerate = new QPushButton;
    btnGenerate->setText(tr("Generate"));
    btnAnimation = new QPushButton;
    btnAnimation->setText(tr("Show Animation"));
    btnClear = new QPushButton;
    btnClear->setText(tr("Clear"));
    btnClose = new QPushButton;
    btnClose->setText(tr("Close"));
    layout_Btn->addWidget(btnGenerate, 0, 0);
    layout_Btn->addWidget(btnAnimation, 0, 1);
    layout_Btn->addWidget(btnClear, 1, 0);
    layout_Btn->addWidget(btnClose, 1, 1);
    QGroupBox *groupBox_Btn = new QGroupBox;
    groupBox_Btn->setLayout(layout_Btn);

    QGridLayout *gridlayout = new QGridLayout;
    gridlayout->addWidget(groupBox_HDE, 1, 0);
    gridlayout->addWidget(group_testfun, 2, 0);
    gridlayout->addWidget(hde_report_error_only, 3, 0);
    gridlayout->addWidget(groupBox_Btn, 4, 0);
    setLayout(gridlayout);

    connect(btnGenerate, SIGNAL(clicked()), this, SLOT(generate()));
    connect(btnAnimation, SIGNAL(clicked()), this, SLOT(show_animation()));
    connect(btnClear, SIGNAL(clicked()), this, SLOT(clear_mesh()));
    connect(btnClose, SIGNAL(clicked()), this, SLOT(close()));
}

void hdeoptionPanel::generate()
{
    qDebug()<<"Generate btn clicked";
    int test_fun = hde_testfun_ComboBox->currentIndex();
    if (test_fun == -1) {
      qDebug()<<"No test function is selected";
      return;
    } else {
      qDebug()<<"test_fun="<<test_fun+1;
    }
    if (_scribblearea != NULL) {
      ((ScribbleArea *)_scribblearea)->detri2_HDE_act();
    }
}

void hdeoptionPanel::show_animation()
{
    qDebug()<<"Show animation btn clicked";
    if (_scribblearea != NULL) {
      //((ScribbleArea *)_scribblearea)->generate_mesh_ani_act();
    }
}

void hdeoptionPanel::clear_mesh()
{
    if (_scribblearea != NULL) {
      ((ScribbleArea *)_scribblearea)->clean_mesh_act();
    }
}

void hdeoptionPanel::close()
{
    qDebug()<<"close btn clicked";
    hide(); //close();
}
