#ifndef HDEOPTIONPANEL_H
#define HDEOPTIONPANEL_H

#include <QObject>
#include <QWidget>

#include <QGridLayout>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGroupBox>
#include <QRadioButton>
#include <QCheckBox>
#include <QLabel>
#include <QLineEdit>
#include <QPushButton>
#include <QListWidget>
#include <QComboBox>

class hdeoptionPanel : public QWidget
{
    Q_OBJECT
public:
    explicit hdeoptionPanel(void *scribblearea, QWidget *parent = nullptr);

    void *_scribblearea;

    // HDE options
    QLabel *hde_s1_label;
    QLabel *hde_s2_label;
    QLabel *hde_min_len_label;
    QLabel *hde_min_angle_label;
    QLabel *hde_max_size_iter_label;
    QLabel *hde_max_quality_iter_label;
    QLabel *hde_use_intpoints_label;
    QLabel *hde_use_smooth_label;
    QLabel *hde_smooth_iter_label;
    QLabel *hde_smooth_alpha_label;
    QLabel *hde_test_fun_label;

    QLineEdit *hde_s1;
    QLineEdit *hde_s2;
    QLineEdit *hde_min_len;
    QLineEdit *hde_min_angle;
    QLineEdit *hde_max_size_iter;
    QLineEdit *hde_max_quality_iter;
    QLineEdit *hde_use_intpoints;
    QCheckBox *hde_use_smooth;
    QLineEdit *hde_smooth_iter;
    QLineEdit *hde_smooth_alpha;
    //QLabel *op_verbose_label;
    //QLineEdit *line_op_verbose;

    QComboBox *hde_testfun_ComboBox;

    QCheckBox *hde_report_error_only;

    QPushButton *btnGenerate;
    QPushButton *btnAnimation;
    QPushButton *btnClear;
    QPushButton *btnClose;
signals:

public slots:
    void generate();
    void show_animation();
    void clear_mesh();
    void close();
};

#endif // HDEOPTIONPANEL_H
