
#include <QtWidgets>
#include <QFileDialog>
#include <QDir>
//#include <QDebug>

#include "scribblearea.h"
#include "metricpanel.h"

/*
meshoptionPanel::meshoptionPanel(void *scribblearea, QWidget *parent) : QWidget(parent)
{
    _scribblearea = scribbearea;

    setWindowTitle(tr("Mesh algorithms & options"));

    QVBoxLayout *verticalLayout;
    verticalLayout = new QVBoxLayout(this);

    QGroupBox *groupBox_Algorithms = new QGroupBox(tr("Mesh algorithms"));
    op_Convexhull = new QRadioButton("Convex hull (point sets)");
    op_Delaunay = new QRadioButton("(Delaunay) Triangulations (point sets)");
    op_Flip     = new QRadioButton("Lawson flipping (using Delaunay criterion)");
    op_CDT      = new QRadioButton("Constrained (Delaunay) Triangulations (line segments)");
    op_Quality  = new QRadioButton("Quality mesh generation (polygonal regions)");
    op_Smooth   = new QRadioButton("Smoth mesh vertices");
    op_Adapt    = new QRadioButton("Mesh adaptation");
    op_Delaunay->setChecked(true);
    QVBoxLayout *vbox_Algo = new QVBoxLayout;
    vbox_Algo->addWidget(op_Convexhull);
    vbox_Algo->addWidget(op_Delaunay);
    vbox_Algo->addWidget(op_Flip);
    vbox_Algo->addWidget(op_CDT);
    vbox_Algo->addWidget(op_Quality);
    vbox_Algo->addWidget(op_Smooth);
    vbox_Algo->addWidget(op_Adapt);
    vbox_Algo->addStretch(1);
    groupBox_Algorithms->setLayout(vbox_Algo);
    verticalLayout->addWidget(groupBox_Algorithms);

    //connect(radio1,SIGNAL(clicked()),this,SLOT(Radio1Selected()));
    //connect(radio2,SIGNAL(clicked()),this,SLOT(Radio2Selected()));
    //connect(radio3,SIGNAL(clicked()),this,SLOT(Radio3Selected()));

    /////////////////////////////////////////////////////////////

    // Delaunay options
    op_DT  = new QRadioButton(tr("nearest-point"));
    op_FDT = new QRadioButton(tr("furthest-point"));
    op_DT->setChecked(true); // default
    op_weighted = new QCheckBox("Weighted");
    op_weighted->setChecked(true); // default
    op_no_sort = new QCheckBox("no sort");
    op_no_flip = new QCheckBox("no edge flip (Delaunay)");

    // Quality options
    QLabel *op_maxarea_label = new QLabel(tr("Maxmimum triangle area (> 0)"));
    line_op_maxarea = new QLineEdit;
    line_op_maxarea->setText(tr("0"));
    QLabel *op_minangle_label = new QLabel(tr("Minimum triangle angle (degree)"));
    line_op_minangle = new QLineEdit;
    line_op_minangle->setText(tr("20"));
    QLabel *op_minlen_label = new QLabel(tr("Minimum edge length (> 0)"));
    line_op_minlen = new QLineEdit;
    line_op_minlen->setText(tr("0"));
    op_metric = new QCheckBox(tr("Use mesh size (defined on vertices, segments, subregions)"));

    // Smooth options
    QLabel *smooth_methods_label = new QLabel(tr("Smooth method"));
    _cb_smooth_methods = new QComboBox;
    _cb_smooth_methods->addItem(tr("Laplacian"));
    _cb_smooth_methods->addItem(tr("CVT"));
    _cb_smooth_methods->addItem(tr("Distmesh"));
    QLabel *smooth_iter_label = new QLabel(tr("Number of iterations"));
    line_smooth_iters = new QLineEdit();
    line_smooth_iters->setText(tr("1")); // default is 1 iteration
    QLabel *op_len_label = new QLabel(tr("Target edge length (> 0)"));
    line_op_target_len = new QLineEdit;
    QLabel *op_dt_label = new QLabel(tr("Distmesh dt"));
    line_op_deltat = new QLineEdit;
    line_op_deltat->setText(tr("0.1"));

    // File dump options
    op_dump_to_ucd = new QCheckBox(tr("Save intermediate meshes"));
    op_dump_lift_map = new QCheckBox(tr("Save lifting maps"));
    line_dump_file_name = new QLineEdit;
    line_dump_file_name->setText(QDir::currentPath() + "/sol");
    btnfilename = new QPushButton(tr("file name"));

    QToolBox *toolbox = new QToolBox;
    verticalLayout->addWidget(toolbox);

    QWidget *page = new QWidget;
    QGridLayout *layout = new QGridLayout(page);
    //layout->setColumnStretch(1, 1);
    //layout->setColumnMinimumWidth(1, 250);
    layout->addWidget(op_DT, 0, 0, 1, 1);
    layout->addWidget(op_FDT, 0, 1, 1, 1);
    layout->addWidget(op_weighted, 0,2, 1, 1);
    layout->addWidget(op_no_sort, 1,0,1,1);
    layout->addWidget(op_no_flip, 1,1,1,2);
    toolbox->addItem(page, tr("Incremental (Delaunay) triangulation options"));

    page = new QWidget;
    layout = new QGridLayout(page);
    //layout->setColumnStretch(1, 1);
    //layout->setColumnMinimumWidth(1, 250);
    //layout->addWidget(groupBox_Quality, 0, 0);
    layout->addWidget(op_minangle_label, 0, 0, 1, 1);
    layout->addWidget(line_op_minangle, 0, 1, 1, 1);
    layout->addWidget(op_maxarea_label, 1, 0, 1, 1);
    layout->addWidget(line_op_maxarea, 1, 1, 1, 1);
    layout->addWidget(op_minlen_label, 2, 0, 1, 1);
    layout->addWidget(line_op_minlen, 2, 1, 1, 1);
    //layout->addWidget(op_verbose_label, 2, 0, 1, 1);
    //layout->addWidget(line_op_verbose, 2, 1, 1, 1);
    layout->addWidget(op_metric, 3, 0, 1, 2);
    toolbox->addItem(page, tr("Mesh quality options"));

    page = new QWidget;
    layout = new QGridLayout(page);
    //layout->setColumnStretch(1, 1);
    //layout->setColumnMinimumWidth(1, 250);
    //layout->addWidget(groupBox_Smooth, 0, 0);
    layout->addWidget(smooth_methods_label, 0, 0);
    layout->addWidget(_cb_smooth_methods, 0, 1);
    layout->addWidget(smooth_iter_label, 1, 0);
    layout->addWidget(line_smooth_iters, 1, 1);
    layout->addWidget(op_len_label, 2, 0);
    layout->addWidget(line_op_target_len, 2, 1);
    layout->addWidget(op_dt_label, 3, 0);
    layout->addWidget(line_op_deltat, 3, 1);
    toolbox->addItem(page, tr("Smooth options"));

    page = new QWidget;
    layout = new QGridLayout(page);
    //layout->setColumnStretch(1, 1);
    //layout->setColumnMinimumWidth(1, 250);
    //layout->addWidget(groupBox_dump, 0, 0);
    layout->addWidget(op_dump_to_ucd, 0,0,1,1);
    layout->addWidget(op_dump_lift_map, 0,1,1,1);
    layout->addWidget(btnfilename, 0,2,1,1);
    layout->addWidget(line_dump_file_name, 1,0,1,3);
    toolbox->addItem(page, tr("Save intermediate meshes options"));

    /////////////////////////////////////////////////////////////

    btnGenerate = new QPushButton;
    btnGenerate->setText(tr("Generate"));
    btnAnimation = new QPushButton;
    btnAnimation->setText(tr("Show Animation"));
    btnClear = new QPushButton;
    btnClear->setText(tr("Clear"));
    btnClose = new QPushButton;
    btnClose->setText(tr("Close"));
    QGridLayout *hbox_Btn = new QGridLayout;
    hbox_Btn->addWidget(btnGenerate, 0,0);
    hbox_Btn->addWidget(btnAnimation,0,1);
    hbox_Btn->addWidget(btnClear,1,0);
    hbox_Btn->addWidget(btnClose,1,1);
    QGroupBox *groupBox_Btn = new QGroupBox;
    groupBox_Btn->setLayout(hbox_Btn);
    verticalLayout->addWidget(groupBox_Btn);

    connect(btnfilename, SIGNAL(clicked()), this, SLOT(on_filename()));

    connect(btnGenerate, SIGNAL(clicked()), this, SLOT(generate()));
    connect(btnAnimation, SIGNAL(clicked()), this, SLOT(show_animation()));
    connect(btnClear, SIGNAL(clicked()), this, SLOT(clear_mesh()));
    connect(btnClose, SIGNAL(clicked()), this, SLOT(close()));
}
*/

meshoptionPanel::meshoptionPanel(void *scribblearea, QWidget *parent) : QWidget(parent)
{
    _scribblearea = scribblearea;

    setWindowTitle(tr("Meshing algorithms & options"));

    //op_Convexhull = new QRadioButton("Convex hull (from a point set)");
    op_Incre    = new QRadioButton("Incremental construction (Convex hull, Triangulation)");
    op_Flip     = new QRadioButton("Lawson flipping (Delaunay criterion or metrics)");
    op_Refine   = new QRadioButton("Mesh refinment (adding vertices)");
    op_Coarsen  = new QRadioButton("Mesh coarsening (removing vertices)");
    op_Smooth   = new QRadioButton("Mesh Smoothing (moving vertices)");

    QGridLayout *layout = new QGridLayout;
    //layout->addWidget(op_Convexhull, 0, 0);
    layout->addWidget(op_Incre, 0, 0);
    layout->addWidget(op_Flip, 1, 0);
    layout->addWidget(op_Refine, 2, 0);
    layout->addWidget(op_Coarsen, 3, 0);
    layout->addWidget(op_Smooth, 4, 0);
    //layout->addStretch(1);
    QGroupBox *groupBox_Algorithms = new QGroupBox(tr("Meshing algorithms"));
    groupBox_Algorithms->setLayout(layout);

    // Delaunay options
    op_FDT = new QCheckBox(tr("furthest-point"));
    op_weighted = new QCheckBox("weighted");
    op_no_sort = new QCheckBox("no sort");
    op_no_flip = new QCheckBox("no edge flip");
    op_constraints = new QCheckBox("with constraints");
    op_nonconvex = new QCheckBox("non convex");
    op_set_metric = new QPushButton(tr("set metric..."));

    layout = new QGridLayout;
    //layout->setColumnStretch(1, 1);
    //layout->setColumnMinimumWidth(1, 250);    
    layout->addWidget(op_FDT, 0, 0, 1, 1);
    layout->addWidget(op_weighted, 0, 1, 1, 1);    
    layout->addWidget(op_constraints,0,2,1,1);
    layout->addWidget(op_no_sort, 1,0,1,1);
    layout->addWidget(op_no_flip, 1,1,1,2);    
    layout->addWidget(op_nonconvex,1,2,1,1);
    layout->addWidget(op_set_metric, 2, 2, 1, 1);
    QGroupBox *groupBox_Triang_Options = new QGroupBox(tr("Incremental (Delaunay) triangulation options"));
    groupBox_Triang_Options->setLayout(layout);

    // Refine and coarsen options
    QLabel *op_minangle_label = new QLabel(tr("Minimum triangle angle (degree)"));
    line_op_minangle = new QLineEdit;
    line_op_minangle->setText(tr("20"));
    QLabel *op_maxarea_label = new QLabel(tr("Maxmimum triangle area (> 0)"));
    line_op_maxarea = new QLineEdit;
    line_op_maxarea->setText(tr("0"));
    QLabel *op_len_label = new QLabel(tr("Unit edge length (> 0)"));
    line_op_target_len = new QLineEdit;
    line_op_target_len->setText(tr("0"));

    layout = new QGridLayout;
    layout->addWidget(op_minangle_label, 0, 0, 1, 1);
    layout->addWidget(line_op_minangle, 0, 1, 1, 1);
    layout->addWidget(op_maxarea_label, 1, 0, 1, 1);
    layout->addWidget(line_op_maxarea, 1, 1, 1, 1);
    layout->addWidget(op_len_label, 2, 0, 1, 1);
    layout->addWidget(line_op_target_len, 2, 1, 1, 1);
    //layout->addWidget(op_use_metric, 3, 0, 1, 2);
    QGroupBox *groupBox_Refine_Options = new QGroupBox(tr("Refining and coarsening options"));
    groupBox_Refine_Options->setLayout(layout);

    // Smooth options
    QLabel *smooth_methods_label = new QLabel(tr("Smoothing method"));
    _cb_smooth_methods = new QComboBox;
    _cb_smooth_methods->addItem(tr("Laplacian"));
    _cb_smooth_methods->addItem(tr("CVT"));
    _cb_smooth_methods->addItem(tr("Distmesh"));
    QLabel *smooth_iter_label = new QLabel(tr("Iterations"));
    line_smooth_iters = new QLineEdit();
    line_smooth_iters->setText(tr("1")); // default is 1 iteration
    //QLabel *op_len_label = new QLabel(tr("Target edge length (> 0)"));
    //line_op_target_len = new QLineEdit;
    QLabel *op_dt_label = new QLabel(tr("dt"));
    line_op_deltat = new QLineEdit;
    line_op_deltat->setText(tr("0.2"));

    layout = new QGridLayout;
    layout->addWidget(smooth_methods_label, 0, 0, 1, 2);
    layout->addWidget(_cb_smooth_methods, 0, 2, 1, 2);
    layout->addWidget(smooth_iter_label, 1, 0, 1, 1);
    layout->addWidget(line_smooth_iters, 1, 1, 1, 1);
    layout->addWidget(op_dt_label, 1, 2, 1, 1);
    layout->addWidget(line_op_deltat, 1, 3, 1, 1);
    QGroupBox *groupBox_Smooth_Options = new QGroupBox(tr("Mesh smoothing options"));
    groupBox_Smooth_Options->setLayout(layout);

    // Metric options
    //op_use_metric = new QCheckBox(tr("Enable metric"));

    /*
    // Function interpolation options ....
    InterFunc = new QCheckBox(tr("Interpolate function..."));
    InterFunc->setCheckable(true);

    func = new QLineEdit;
    func_x = new QLineEdit;
    func_y = new QLineEdit;

    func_template = new QComboBox();
    func_template->addItem("none"); // 0
    func_template->addItem("Gaussian"); // 1
    func_template->addItem("Lennard");  // 2
    func_template->addItem("Alauzet");  // 3
    func_template->addItem("Huang");  // 4
    //func_template->addItem("Frey"); // 5 Differential Geometry book, p. 279
    func_template->addItem("BAMG"); // 5

    hde_s1 = new QLineEdit;
    hde_s1->setText(tr("1.0"));
    hde_s2 = new QLineEdit;
    hde_s2->setText(tr("1.0"));

    btnView3d = new QPushButton(tr("View 3d..."));
    btnTest = new QPushButton(tr("Evaulate..."));

    QLabel *lbl_func = new QLabel(tr("f"));
    QLabel *lbl_fx = new QLabel(tr("fx"));
    QLabel *lbl_fy = new QLabel(tr("fy"));
    QLabel *lbl_s1 = new QLabel(tr("s1"));
    QLabel *lbl_s2 = new QLabel(tr("s2"));
    QLabel *lbl_template = new QLabel(tr("examples"));

    QGridLayout *layout_func = new QGridLayout;
    layout_func->addWidget(lbl_func, 0, 0, 1, 1);
    layout_func->addWidget(func, 0, 1, 1, 4);
    layout_func->addWidget(lbl_fx, 1, 0, 1, 1);
    layout_func->addWidget(func_x, 1, 1, 1, 4);
    layout_func->addWidget(lbl_fy, 2, 0, 1, 1);
    layout_func->addWidget(func_y, 2, 1, 1, 4);
    layout_func->addWidget(lbl_template, 3, 0, 1, 1);
    layout_func->addWidget(func_template, 3, 1, 1, 3);
    layout_func->addWidget(lbl_s1, 4,0,1,1);
    layout_func->addWidget(hde_s1, 4,1,1,1);
    layout_func->addWidget(lbl_s2, 4,2,1,1);
    layout_func->addWidget(hde_s2, 4,3,1,1);
    layout_func->addWidget(btnView3d, 5,0,1,1);
    layout_func->addWidget(btnTest, 5,1,1,1);
    QGroupBox *group_func = new QGroupBox; // (tr("Function and gradients"));
    group_func->setLayout(layout_func);
    // End of function interpolation options ....
    */

    btnGenerate = new QPushButton;
    btnGenerate->setText(tr("Generate"));
    btnResetOptions = new QPushButton;
    btnResetOptions->setText(tr("Reset options"));
    btnClear = new QPushButton;
    btnClear->setText(tr("Clear mesh"));
    //btnClose = new QPushButton;
    //btnClose->setText(tr("Close"));

    layout = new QGridLayout;
    layout->addWidget(btnGenerate, 0,0);
    layout->addWidget(btnResetOptions,0,1);
    layout->addWidget(btnClear,0,2);
    //layout->addWidget(btnClose,1,1);
    QGroupBox *groupBox_Btn = new QGroupBox;
    groupBox_Btn->setLayout(layout);

    op_animation = new QCheckBox(tr("Show intermediate steps"));

    QGridLayout *mainlayout = new QGridLayout(this);
    mainlayout->addWidget(groupBox_Algorithms, 0, 0);
    mainlayout->addWidget(groupBox_Triang_Options, 1, 0);
    mainlayout->addWidget(groupBox_Refine_Options, 2, 0);
    mainlayout->addWidget(groupBox_Smooth_Options, 3, 0);
    //mainlayout->addWidget(InterFunc,4,0);
    //mainlayout->addWidget(group_func,5,0);
    mainlayout->addWidget(op_animation,6,0);
    mainlayout->addWidget(groupBox_Btn,7,0);

    /*
    group_func->setVisible(false);
    connect(func_template, SIGNAL(currentIndexChanged(int)), SLOT(setFunction(int)));
    connect(btnView3d, SIGNAL(clicked()), this, SLOT(view3d()));
    connect(btnTest, SIGNAL(clicked()), this, SLOT(evaluate_function()));

    //connect(InterFuncButton, &QAbstractButton::toggled, group_func, &QWidget::setVisible);
    connect(InterFunc, &QCheckBox::clicked, group_func, &QWidget::setVisible);
    */

    connect(op_set_metric, SIGNAL(clicked()), this, SLOT(on_set_metric()));

    connect(op_Incre,SIGNAL(clicked()),this,SLOT(on_incremental()));
    connect(op_Flip,SIGNAL(clicked()),this,SLOT(on_flip()));
    connect(op_Refine,SIGNAL(clicked()),this, SLOT(on_refine()));
    //connect(op_Coarsen,SIGNAL(clicked()),this,SLOT(on_coarsen()));
    connect(op_Smooth,SIGNAL(clicked()), this, SLOT(on_smooth()));

    connect(btnGenerate, SIGNAL(clicked()), this, SLOT(generate()));
    connect(btnResetOptions, SIGNAL(clicked()), this, SLOT(on_reset_options()));
    connect(btnClear, SIGNAL(clicked()), this, SLOT(clear_mesh()));
    //connect(btnClose, SIGNAL(clicked()), this, SLOT(close()));

    on_reset_options();
}

/*
void meshoptionPanel::on_filename()
{
   QString filepath = QDir::currentPath(); // get current working directory
   if (_scribblearea != NULL) {
     filepath = ((ScribbleArea *)_scribblearea)->_file_last_used_path;
   }

    QString fileName = QFileDialog::getSaveFileName(this,
                                              tr("Dump file name"),
                                              filepath
                                              );
    if (!fileName.isEmpty()) {
      line_dump_file_name->setText(fileName);
    }
}
*/

void meshoptionPanel::on_reset_options()
{
  ScribbleArea *sa = (ScribbleArea *) _scribblearea;
  //if (sa->_tria != NULL) {
  //  sa->_tria->reset_options();
  //}
  op_Incre->setChecked(true);
  op_animation->setChecked(false);
  op_FDT->setChecked(false);
  op_weighted->setChecked(true);
  op_no_sort->setChecked(false);
  op_no_flip->setChecked(false);
  op_constraints->setChecked(false);
  line_op_minangle->setText(tr("20"));
  line_op_maxarea->setText(tr("0"));
  line_op_target_len->setText(tr("0"));
  line_smooth_iters->setText(tr("1"));
  line_op_deltat->setText(tr("0.2"));
  //InterFunc->setChecked(false);
  //func->setText(tr(""));
  //func_x->setText(tr(""));
  //func_y->setText(tr(""));
  //hde_s1->setText(tr("1.0"));
  //hde_s2->setText(tr("1.0"));
}

void meshoptionPanel::on_set_metric()
{
    ScribbleArea *sa = (ScribbleArea *) _scribblearea;
    metricDialog *m = new metricDialog(&sa->_a11, &sa->_a21, &sa->_a22);
    m->exec();
    delete m;
    //qDebug()<<"Current metric: a11="<<sa->_a11<<", a21="<<sa->_a21<<", a22="<<sa->_a22;
}

void meshoptionPanel::on_incremental()
{
  //qDebug()<<"on Delaunay";
  /*
  ScribbleArea *sa = (ScribbleArea *) _scribblearea;
  if (sa->_tria != NULL) {
    if (op_FDT->isChecked()) {
      sa->_tria->op_dt_nearest = -1;
    }
    if (op_no_sort->isChecked()) {
      sa->_tria->so_nosort = 1;
    }
    if (op_no_flip->isChecked()) {
      sa->_tria->op_no_incremental_flip = 1;
    }
    if (op_constraints->isChecked()) {
      sa->_tria->op_poly = 1; // CDT
    }
  }
  */
}

void meshoptionPanel::on_flip()
{
  /*
  ScribbleArea *sa = (ScribbleArea *) _scribblearea;
  if (sa->_tria != NULL) {
    if (op_FDT->isChecked()) {
      sa->_tria->op_dt_nearest = -1;
    }
    sa->_tria->op_no_incremental_flip = 0; // must disable this option.  
  }
  */
}

void meshoptionPanel::on_refine()
{
  //qDebug()<<"on refine";
  /*
  ScribbleArea *sa = (ScribbleArea *) _scribblearea;
  if (sa->_tria != NULL) {
    sa->_tria->op_quality = 1;
    sa->_tria->op_minangle = line_op_minangle->text().toDouble();
    sa->_tria->op_maxarea = line_op_maxarea->text().toDouble();
    sa->_tria->op_target_length = line_op_target_len->text().toDouble();
  }
  */
}

/*
void meshoptionPanel::on_coarsen()
{

}
*/

void meshoptionPanel::on_smooth()
{
  //qDebug()<<"on smooth";
  /*
  ScribbleArea *sa = (ScribbleArea *) _scribblearea;
  if (sa->_tria != NULL) {
    int curidx = _cb_smooth_methods->currentIndex();
    qDebug()<<"curidx = "<<curidx;
    if (curidx == 0) {
      sa->_tria->op_smooth_criterion = SMOOTH_LAPLACIAN;
    } else if (curidx == 1) {
      sa->_tria->op_smooth_criterion = SMOOTH_CVT;
      sa->_tria->OMT_domain = sa->_geom;
    } else if (curidx == 2) {
      sa->_tria->op_smooth_criterion = SMOOTH_DISTMESH;
    } else {
      return; // Unknown criterion.
    }
    sa->_tria->op_max_iter = line_smooth_iters->text().toInt();
    // needed by distmesh smoother
    sa->_tria->op_target_length = line_op_target_len->text().toDouble();
    sa->_tria->op_smooth_deltat = line_op_deltat->text().toDouble();
  }
  */
}

//==============================================================================
//#include "muParser.h"

mu::Parser User_Func; // function
mu::Parser User_Func_X, User_Func_Y;
double user_x, user_y;

double callback_user_func(const detri2::Vertex * vert)
{
    user_x = vert->crd[0];
    user_y = vert->crd[1];
    return User_Func.Eval();
}

double callback_user_func_X(const detri2::Vertex * vert)
{
    user_x = vert->crd[0];
    user_y = vert->crd[1];
    return User_Func_X.Eval();
}

double callback_user_func_Y(const detri2::Vertex * vert)
{
    user_x = vert->crd[0];
    user_y = vert->crd[1];
    return User_Func_Y.Eval();
}

void meshoptionPanel::setFunction( int idx ) {
    qDebug()<<"idx="<<idx;
    /*
    // do another stuff
    if (idx == 1) {
      func->setText(tr("4.0 * exp(-(x * x + y * y) / 2.0)"));
      func_x->setText(tr("-x * 4.* exp(-(x * x + y * y) / 2.0)"));
      func_y->setText(tr("-y * 4.* exp(-(x * x + y * y) / 2.0)"));
    } else if (idx == 2) {
      func->setText(tr("tanh(60.*x)-tanh(60.*x-60.*y-30.)"));
      func_x->setText(tr("60.*tanh(60.*x-60.*y-30.)*tanh(60.*x-60.*y-30.)-60.*tanh(60.*x)*tanh(60.*x)"));
      func_y->setText(tr("-60.+60.*tanh(60.*x-60.*y-30.)*tanh(60.*x-60.*y-30.)"));
    } else if (idx == 3) {
      func->setText(tr("sin(5.*(x-0.2)*(x-0.2)*(x-0.2)*(y*y-y+1.))"));
      func_x->setText(tr("cos(5.*(x-0.2)*(x-0.2)*(x-0.2)*(y*y-y+1.))*3.*(x-0.2)*(x-0.2)"));
      func_y->setText(tr("cos(5.*(x-0.2)*(x-0.2)*(x-0.2)*(y*y-y+1.))*(2.*y-1.)"));
    } else if (idx == 4) {
      func->setText(tr("-10*((y-0.4*sin(1.0*pi*x))^2)"));
      func_x->setText(tr("-tanh(-10*((-1.0.*sin(1.0*pi*x) / 5. + y))^2)"));
      func_y->setText(tr("-tanh(-10*((y-1.0*sin(1.0*pi*x) / 5.)^2))"));
    } else if (idx == 5) {
      func->setText(tr(""));
      func_x->setText(tr(""));
      func_y->setText(tr(""));
    } else {
      func->setText(tr(""));
      func_x->setText(tr(""));
      func_y->setText(tr(""));
    }
    */
}

void meshoptionPanel::evaluate_function() {
    qDebug()<<"Evaluate";
    /*
    if (!func->text().isEmpty()) {
      MuParserDialog _testdialog(_scribblearea); // = new MuParserDialog();
      _testdialog.textLabel->setText(func->text());
      _testdialog.exec();
    }
    */
}

void meshoptionPanel::view3d() {
    /*
    if (func->text().isEmpty()) {
      QMessageBox msg;
      msg.setText("A function expression is needed!");
      msg.exec();
      return;
    }

    ScribbleArea *sa = (ScribbleArea *) _scribblearea;
    if (sa->_tria == NULL) {
      QMessageBox msg;
      msg.setText("Please first generate a mesh!");
      msg.exec();
      return;
    }

    // Use the function given by the user
    User_Func.SetExpr(std::string(func->text().toStdString()));
    User_Func.DefineVar("x", &user_x);
    User_Func.DefineVar("y", &user_y);
    sa->_tria->Func = &callback_user_func;

    User_Func_X.SetExpr(std::string(func_x->text().toStdString()));
    User_Func_X.DefineVar("x", &user_x);
    User_Func_X.DefineVar("y", &user_y);
    sa->_tria->GradX = &callback_user_func_X;

    User_Func_Y.SetExpr(std::string(func_y->text().toStdString()));
    User_Func_Y.DefineVar("x", &user_x);
    User_Func_Y.DefineVar("y", &user_y);
    sa->_tria->GradY = &callback_user_func_Y;

    sa->_tria->op_hde_s1 = hde_s1->text().toDouble();
    sa->_tria->op_hde_s2 = hde_s2->text().toDouble();

    // set the function values on nodes.
    sa->_tria->op_metric = METRIC_HDE;
    sa->_tria->set_vertex_metrics();
    //sa->_tria->op_metric = METRIC_Euclidean;

    sa->viewgl_act();
    */
}

//==============================================================================

void meshoptionPanel::generate()
{
    qDebug()<<"Generate btn clicked";
    if (_scribblearea != NULL) {
      ((ScribbleArea *)_scribblearea)->generate_mesh_act();
    }
}

void meshoptionPanel::clear_mesh()
{
    if (_scribblearea != NULL) {
      ((ScribbleArea *)_scribblearea)->clean_mesh_act();
    }
}

void meshoptionPanel::close()
{
    //qDebug()<<"close btn clicked";
    hide(); //close();
}
