#ifndef MESHOPTIONPANEL_H
#define MESHOPTIONPANEL_H

#include <QObject>
#include <QWidget>

#include <QGridLayout>
#include <QGroupBox>
#include <QRadioButton>
#include <QCheckBox>
#include <QLabel>
#include <QLineEdit>
#include <QPushButton>
#include <QComboBox>

class meshoptionPanel : public QWidget
{
    Q_OBJECT
public:
    explicit meshoptionPanel(void* scribblearea, QWidget *parent = nullptr);

    void *_scribblearea;

    // Mesh algorithms
    //QRadioButton *op_Convexhull;
    QRadioButton *op_Incre;
    QRadioButton *op_Flip;
    QRadioButton *op_Refine;
    QRadioButton *op_Coarsen;
    QRadioButton *op_Smooth;
    QCheckBox *op_animation;

    // weighted Delaunay options
    QCheckBox *op_FDT;
    QCheckBox *op_weighted;
    QCheckBox *op_no_sort;
    QCheckBox *op_no_flip;
    QCheckBox *op_constraints;
    QCheckBox *op_nonconvex;
    QPushButton *op_set_metric;

    // Refine and coarsen options
    //QLineEdit *line_op_minlen;
    QLineEdit *line_op_minangle;
    QLineEdit *line_op_maxarea;
    QLineEdit *line_op_target_len;

    QComboBox *_cb_smooth_methods;
    QLineEdit *line_smooth_iters;
    QLineEdit *line_op_deltat;

    //QCheckBox *op_use_metric;

    //QCheckBox *op_dump_to_ucd;
    //QCheckBox *op_dump_lift_map;
    //QLineEdit *line_dump_file_name;
    //QPushButton *btnfilename;

    /*
    // Function interpolation (via HDE)
    QCheckBox *InterFunc;
    QLineEdit *func, *func_x, *func_y;
    QComboBox *func_template;
    QLineEdit *hde_s1, *hde_s2;
    QPushButton *btnView3d;
    QPushButton *btnTest;
    */

    QPushButton *btnGenerate;
    QPushButton *btnResetOptions;
    QPushButton *btnClear;
    QPushButton *btnClose;

    //QGroupBox *groupBox_Triang_Options;
    //QGroupBox *groupBox_Refine_Options;
    //QGroupBox *groupBox_Smooth_Options;

signals:

public slots:
    //void on_filename();
    void on_set_metric();
    void on_incremental();
    void on_flip();
    void on_refine();
    //void on_coarsen();
    void on_smooth();
    void on_reset_options();
    void setFunction( int idx );
    void evaluate_function();
    void view3d();

    void generate();
    void clear_mesh();
    void close();
};

#endif // MESHOPTIONPANEL_H
