#include <QtWidgets>

#include "scribblearea.h"
//#include "muParserdialog.h"

MuParserDialog::MuParserDialog(void *scribblearea, QWidget *parent)
    : QDialog(parent)
{
    _scribblearea = scribblearea;

    int frameStyle = QFrame::Sunken | QFrame::Panel;

    textLabel = new QLabel;
    textLabel->setFrameStyle(frameStyle);
    QPushButton *textButton = new QPushButton(tr("input formula"));

    //scaleLabel = new QLabel(tr("1.0"));
    //scaleLabel->setFrameStyle(frameStyle);
    //QPushButton *scaleButton = new QPushButton(tr("set sacle"));

    _x = new QLineEdit;
    _x->setText(tr("0"));
    _y = new QLineEdit;
    _y->setText(tr("0"));
    QLabel *_xlabel = new QLabel(tr("x = "));
    QLabel *_ylabel = new QLabel(tr("y = "));

    text2Label = new QLabel;
    text2Label->setFrameStyle(frameStyle);
    QPushButton *text2Button = new QPushButton(tr("evaluate"));

    connect(textButton, &QAbstractButton::clicked, this, &MuParserDialog::setText);
    //connect(scaleButton, &QAbstractButton::clicked, this, &MuParserDialog::setScale);
    connect(text2Button, &QAbstractButton::clicked, this, &MuParserDialog::eval);

    QGridLayout *layout = new QGridLayout(this);
    layout->addWidget(textButton, 0, 0);
    layout->addWidget(textLabel, 0, 1);
    //layout->addWidget(scaleButton, 1, 0);
    //layout->addWidget(scaleLabel, 1, 1);
    layout->addWidget(_xlabel, 1, 0);
    layout->addWidget(_x, 1, 1);
    layout->addWidget(_ylabel, 2, 0);
    layout->addWidget(_y, 2, 1);
    layout->addWidget(text2Button, 3, 0);
    layout->addWidget(text2Label, 3, 1);

    mup.DefineVar("x", &x);
    mup.DefineVar("y", &y);
}

void MuParserDialog::setText()
{
    //qDebug()<<"clicked here";
    ScribbleArea *sa = (ScribbleArea *) _scribblearea;
    bool ok;
    QString text = QInputDialog::getText(this, tr("Input formula"),
                                         tr("formula:"), QLineEdit::Normal,
                                         QString(""), &ok);
    if (ok && !text.isEmpty()) {
      textLabel->setText(text);
      //strcpy(sa->_geom->op_expr, text.toStdString().c_str());
    } else {
      // Clear expression
      //sa->_geom->op_expr[0] = 0;
    }
}

void MuParserDialog::setScale()
{
    /*
    bool ok;
    double d = QInputDialog::getDouble(this, // parent Widget
                                       tr("Set scale"), // title
                                       tr("scale = "), // label
                                       scaleLabel->text().toDouble(), // value
                                       1.e-30, // min
                                       1.e30,  // max
                                       10,     // maximum number of decimal
                                       &ok);
    if (ok) {
      scaleLabel->setText(QString::number(d));
      ScribbleArea *sa = (ScribbleArea *) _scribblearea;
      sa->_geom->op_scale = d;
    }
    */
}

void MuParserDialog::eval()
{
    qDebug()<<"evalute, to do ... ";
    mup.SetExpr(textLabel->text().toStdString());
    x = _x->text().toDouble();
    y = _y->text().toDouble();
    double ans = mup.Eval();
    text2Label->setText(QString::number(ans));
}
