#ifndef NEWFILEPANEL_H
#define NEWFILEPANEL_H

#include <QObject>
#include <QWidget>
#include <QDialog>

#include <QRadioButton>
#include <QCheckBox>
#include <QLabel>
#include <QLineEdit>
#include <QPushButton>

class GeometryInputPanel : public QDialog
{
    Q_OBJECT
public:
    explicit GeometryInputPanel(int geomtype, QDialog *parent = nullptr);

    QLabel *lbl_centx;
    QLabel *lbl_centy;
    QLabel *lbl_rect_width;
    QLabel *lbl_rect_heigh;

    QLineEdit *centx;
    QLineEdit *centy;
    QLineEdit *rect_width;
    QLineEdit *rect_height;
    QLineEdit *cir_radius;
    QLineEdit *cir_angle_start; // for circular-arc
    QLineEdit *cir_angle_end;   // for circular-arc
    QLineEdit *cir_segnum;
    QLineEdit *segment_tag;

    QCheckBox *use_trans;
    QLineEdit *rot_cx;
    QLineEdit *rot_cy;
    QLineEdit *rot_angle;
    QLineEdit *trans_x;
    QLineEdit *trans_y;
    
    QPushButton *moreButton;

signals:

public slots:

};

class newfilePanel : public QWidget
{
    Q_OBJECT
public:
    explicit newfilePanel(void* scribblearea, int new_or_add, QWidget *parent = nullptr);

    void *_scribblearea;
    int  _new_or_add;

    QRadioButton *op_empty;
    QRadioButton *op_rbox;
    QRadioButton *op_rect;
    QRadioButton *op_circle;
    QRadioButton *op_vertex;

    QPushButton *btnNew;
    QPushButton *btnAdd;
    QPushButton *btnCancel;

signals:

public slots:
    void on_new();
    void on_add();
    void on_cancel();
    void get_from_File();
};

#endif // NEWFILEPANEL_H
