
#include <QToolBox>
#include <QLabel>
#include <QVBoxLayout>
//#include <QHBoxLayout>
//#include <QGridLayout>
//#include <QDebug>

#include "scribblearea.h"
//#include "sortoptionpanel.h"
//#include "detri2qt.h"
#include <math.h>

using namespace detri2;

sortOptionPanel::sortOptionPanel(void *scribblearea, QWidget *parent) : QWidget(parent)
{
    _scribblearea = scribblearea;

    setWindowTitle(tr("Sorting vertices"));

    QVBoxLayout *verticalLayout;
    verticalLayout = new QVBoxLayout(this);

    op_random_sort = new QRadioButton(tr("Random"));
    op_sweepline_sort = new QRadioButton(tr("Sweep line"));
    op_Hilbert_sort = new QRadioButton(tr("Hilbert curve"));
    op_BRIO_Hilbert_sort = new QRadioButton(tr("BRIO+Hilbert"));
    op_draw_Hilbert_curve = new QRadioButton(tr("Show Hilbert curve"));
    op_BRIO_Hilbert_sort->setChecked(true); // default

    QVBoxLayout *vbox_Algo = new QVBoxLayout;
    vbox_Algo->addWidget(op_random_sort);
    vbox_Algo->addWidget(op_sweepline_sort);
    vbox_Algo->addWidget(op_Hilbert_sort);
    vbox_Algo->addWidget(op_BRIO_Hilbert_sort);
    vbox_Algo->addWidget(op_draw_Hilbert_curve);
    //vbox_Algo->addStretch(1);
    QGroupBox *groupBox_Algorithms = new QGroupBox(tr("Sorting algorithms"));
    groupBox_Algorithms->setLayout(vbox_Algo);
    verticalLayout->addWidget(groupBox_Algorithms);

    ////////////////////////////////////////////////////////

    use_random_seed = new QCheckBox(tr("Use random seed"));
    random_seed = new QLineEdit;
    random_seed->setText(QString("1"));

    QLabel *lbl_sweep_x = new QLabel(tr("Vx"));
    QLabel *lbl_sweep_y = new QLabel(tr("Vy"));
    sweep_x = new QLineEdit;
    sweep_x->setText(tr("1.0"));
    sweep_y = new QLineEdit;
    sweep_y->setText(tr("1.0"));

    /*
    QHBoxLayout *sweeplayout = new QHBoxLayout;
    sweeplayout->addWidget(lbl_sweep_x);
    sweeplayout->addWidget(sweep_x);
    sweeplayout->addWidget(lbl_sweep_y);
    sweeplayout->addWidget(sweep_y);
    QGroupBox *sweepgroup = new QGroupBox(tr("Sweep line direction"));
    sweepgroup->setLayout(sweeplayout);
    */

    //show_Hilbert_curve = new QCheckBox(tr("Draw Hilbert curve"));
    show_Hilbert_index = new QCheckBox(tr("Show Hilbert index"));
    QLabel *lbl_hilbert_order = new QLabel(tr("Curve order"));
    hilbert_order = new QLineEdit;
    hilbert_order->setText(tr("2"));
    QLabel *lbl_hilbert_e = new QLabel(tr("Entry (e)"));
    hilbert_e = new QLineEdit;
    hilbert_e->setText(tr("0"));
    QLabel *lbl_hilbert_f = new QLabel(tr("Exit (f)"));
    hilbert_f = new QLineEdit;
    hilbert_f->setText(tr("1"));

    /*
    QHBoxLayout *optionlayout = new QHBoxLayout;
    optionlayout->addWidget(lbl_hilbert_order);
    optionlayout->addWidget(hilbert_order);
    optionlayout->addWidget(show_Hilbert_index);
    QHBoxLayout *optionlayout2 = new QHBoxLayout;
    optionlayout2->addWidget(lbl_hilbert_e);
    optionlayout2->addWidget(hilbert_e);
    //QHBoxLayout *optionlayout3 = new QHBoxLayout;
    optionlayout2->addWidget(lbl_hilbert_f);
    optionlayout2->addWidget(hilbert_f);
    //optionlayout->addStretch(1);
    QVBoxLayout *optionlayout4 = new QVBoxLayout;
    optionlayout4->addWidget(show_Hilbert_curve);
    optionlayout4->addLayout(optionlayout);
    optionlayout4->addLayout(optionlayout2);
    //optionlayout4->addLayout(optionlayout3);
    QGroupBox *groupBox_Options = new QGroupBox(tr("Hilbert curve options"));
    groupBox_Options->setLayout(optionlayout4);
    */

    QToolBox *toolbox = new QToolBox;
    verticalLayout->addWidget(toolbox);

    QWidget *page = new QWidget;
    QGridLayout *layout = new QGridLayout(page);
    //layout->setColumnStretch(1, 1);
    //layout->setColumnMinimumWidth(1, 250);
    layout->addWidget(use_random_seed, 0, 0, 1, 1);
    layout->addWidget(random_seed, 0, 1, 1, 1);
    toolbox->addItem(page, tr("Random sort seed"));

    page = new QWidget;
    layout = new QGridLayout(page);
    //layout->setColumnStretch(1, 1);
    //layout->setColumnMinimumWidth(1, 250);
    layout->addWidget(lbl_sweep_x, 0, 0, 1, 1);
    layout->addWidget(sweep_x, 0, 1, 1, 1);
    layout->addWidget(lbl_sweep_y, 0, 2, 1, 1);
    layout->addWidget(sweep_y, 0, 3, 1, 1);
    toolbox->addItem(page, tr("Sweepline sort direction"));

    page = new QWidget;
    layout = new QGridLayout(page);
    //layout->setColumnStretch(1, 1);
    //layout->setColumnMinimumWidth(1, 250);
    layout->addWidget(lbl_hilbert_order, 0, 0, 1, 1);
    layout->addWidget(hilbert_order, 0, 1, 1, 1);
    layout->addWidget(lbl_hilbert_e, 1, 0, 1, 1);
    layout->addWidget(hilbert_e, 1, 1, 1, 1);
    layout->addWidget(lbl_hilbert_f, 1, 2, 1, 1);
    layout->addWidget(hilbert_f, 1, 3, 1, 1);
    layout->addWidget(show_Hilbert_index, 2,0,1,2);
    toolbox->addItem(page, tr("Hilbert sort options"));

    /////////////////////////////////////////////////////////////

    _applybtn = new QPushButton(tr("Apply"));
    _closebtn = new QPushButton(tr("Close"));
    QHBoxLayout *btnlayout = new QHBoxLayout;
    btnlayout->addWidget(_applybtn);
    btnlayout->addWidget(_closebtn);
    QGroupBox *groupBox_Btns = new QGroupBox;
    groupBox_Btns->setLayout(btnlayout);
    verticalLayout->addWidget(groupBox_Btns);

    /*
    QVBoxLayout *mainlayout = new QVBoxLayout;
    mainlayout->addWidget(groupBox_Algorithms);
    mainlayout->addWidget(sweepgroup);
    mainlayout->addWidget(groupBox_Options);
    mainlayout->addWidget(groupBox_Btns);

    setLayout(mainlayout);
    */

    connect(_applybtn, SIGNAL(clicked()), this, SLOT(on_apply()));
    connect(_closebtn, SIGNAL(clicked()), this, SLOT(on_close()));
    //connect(_val, SIGNAL(textChanged(const QString &)), this, SLOT(val_changed()));
}

void sortOptionPanel::on_apply()
{
    qDebug()<<"apply!";

    ScribbleArea *sa = (ScribbleArea *)_scribblearea;
    sa->detri2_Sort_act();

    /*
    ScribbleArea *sa = (ScribbleArea *)_scribblearea;
    if (sa->_active_vertex) {
      // Update the vertex weight and mesh size.
      sa->_active_vertex->wei = _w->text().toDouble();
      sa->_active_vertex->val = _val->text().toDouble();
      // Move the vertex if possible.
      double u = _x->text().toDouble();
      double v = _y->text().toDouble();
      double px = sa->_active_vertex->crd[0];
      double py = sa->_active_vertex->crd[1];
      sa->_active_vertex->crd[2] = px*px+py*py*-sa->_active_vertex->wei;
      // Move the vertex if this (px, py) is close to (u, v);
      double dist = sqrt((px - u)*(px - u) + (py - v)*(py - v));
      if ((dist / sa->_geom->io_diagonal) > 0.01) {
        if (detri2_move_vertex(sa->_geom, &sa->_active_vertex, u, v)) {
          // Vertex moved. Update the scene.
          if (sa->_active_vertex->Pair != NULL) {
            Vertex *mv = sa->_active_vertex->Pair;
            mv->crd[0] = u;
            mv->crd[1] = v;
            mv->crd[2] = u*u + v*v - sa->_active_vertex->wei;
          }
          sa->_object_valid=0;
          sa->update();
        }
      }
    }
    */
    //hide();
}

void sortOptionPanel::on_close()
{
    hide();
}
