#ifndef sortOptionPanel_H
#define sortOptionPanel_H

#include <QObject>
#include <QWidget>

#include <QRadioButton>
#include <QLineEdit>
#include <QCheckBox>
#include <QPushButton>

class sortOptionPanel : public QWidget
{
    Q_OBJECT
public:
    sortOptionPanel(void *scribblearea, QWidget *parent = nullptr);

    void *_scribblearea;

    QRadioButton *op_random_sort;
    QRadioButton *op_sweepline_sort;
    QRadioButton *op_Hilbert_sort;
    QRadioButton *op_BRIO_Hilbert_sort;
    QRadioButton *op_draw_Hilbert_curve;

    QCheckBox *use_random_seed;
    QLineEdit *random_seed;

    QLineEdit *sweep_x;
    QLineEdit *sweep_y;

    QLineEdit *hilbert_order;
    QLineEdit *hilbert_limit;
    QLineEdit *hilbert_e;
    QLineEdit *hilbert_f;
    QLineEdit *brio_threshold;
    QLineEdit *brio_ratio;

    QCheckBox *show_Hilbert_index;

    QPushButton *_applybtn;
    QPushButton *_closebtn;

public slots:
    void on_apply();
    void on_close();
};

#endif // sortOptionPanel_H
