
//#include <QVBoxLayout>
//#include <QHBoxLayout>
#include <QGridLayout>
#include <QMessageBox>
//#include <QDebug>

#include "scribblearea.h"
//#include "subdomainpanel.h"

/*
subdomainPanel::subdomainPanel(void *scribblearea, QWidget *parent) : QWidget(parent)
{
    _scribblearea = scribblearea;

    QVBoxLayout* vLayout = new QVBoxLayout(this);

    _holeflag = new QCheckBox(tr("is a hole"));

    vLayout->addWidget(_holeflag);

    QLabel *tag_lbl = new QLabel(tr("tag"));
    QLabel *maxarea_lbl = new QLabel(tr("max area"));
    _tag = new QLineEdit;
    _maxarea = new QLineEdit;
    _tag->setText(tr("-1")); // Default tag=-1
    _maxarea->setText(tr("0"));

    QGridLayout* gLayout = new QGridLayout(this);
    gLayout->addWidget(tag_lbl,0,0);
    gLayout->addWidget(_tag,0,1);
    gLayout->addWidget(maxarea_lbl,1,0);
    gLayout->addWidget(_maxarea, 1,1);

    vLayout->addLayout(gLayout);

    _applybtn = new QPushButton(tr("Apply"));
    _closebtn = new QPushButton(tr("Close"));

    vLayout->addWidget(_applybtn); // , 0, Qt::AlignLeft
    vLayout->addWidget(_closebtn); // , 0, Qt::AlignRight

    connect(_applybtn, SIGNAL(clicked()), this, SLOT(on_apply()));
    connect(_closebtn, SIGNAL(clicked()), this, SLOT(on_close()));

    setLayout(vLayout);
    setWindowTitle(tr("Subdomain"));
}
*/

subdomainPanel::subdomainPanel(void *scribblearea, QWidget *parent) : QWidget(parent)
{
    _scribblearea = scribblearea;

    _holeflag = new QCheckBox(tr("is a hole"));

    QLabel *tag_lbl = new QLabel(tr("tag"));
    QLabel *maxarea_lbl = new QLabel(tr("max area"));
    _tag = new QLineEdit;
    _maxarea = new QLineEdit;
    _tag->setText(tr("-1")); // Default tag=-1
    _maxarea->setText(tr("0"));

    _applybtn = new QPushButton(tr("Apply"));
    _closebtn = new QPushButton(tr("Close"));

    connect(_applybtn, SIGNAL(clicked()), this, SLOT(on_apply()));
    connect(_closebtn, SIGNAL(clicked()), this, SLOT(on_close()));

    QGridLayout* gLayout = new QGridLayout(this);
    gLayout->addWidget(_holeflag,0,0);
    gLayout->addWidget(tag_lbl,1,0);
    gLayout->addWidget(_tag,1,1);
    gLayout->addWidget(maxarea_lbl,2,0);
    gLayout->addWidget(_maxarea, 2,1);
    gLayout->addWidget(_applybtn,3,0);
    gLayout->addWidget(_closebtn, 3,1);

    setLayout(gLayout);
    setWindowTitle(tr("Subdomain"));
}

void subdomainPanel::on_apply()
{
    if (_scribblearea) {
      if (((ScribbleArea *) _scribblearea)->_active_sdm_vertex != NULL) {
        if (_holeflag->isChecked()) {
          ((ScribbleArea *) _scribblearea)->_active_sdm_vertex->tag = 0;
        } else {
          ((ScribbleArea *) _scribblearea)->_active_sdm_vertex->tag = _tag->text().toInt();
        }
        ((ScribbleArea *) _scribblearea)->_active_sdm_vertex->val = _maxarea->text().toDouble();
      } else {
        // It is an undefined subdomain. Create a new subdomain vertex for it.
        int tag; double maxarea;
        if (_holeflag->isChecked()) {
          tag = 0; maxarea = 0.0;
        } else {
          tag = _tag->text().toInt();
          maxarea = _maxarea->text().toDouble();
          if (tag == 0) {
            QMessageBox msg;
            msg.setText("Warning (tag = 0): A valid mesh domain tag should be 0!");
            msg.exec();
          }
        }
        detri2_add_subdomain(&((ScribbleArea *) _scribblearea)->_geom,
                              ((ScribbleArea *) _scribblearea)->_active_trilist, tag, maxarea);
      }
    }
    hide();
}

void subdomainPanel::on_close()
{
    hide();
}
