
//#include <QVBoxLayout>
//#include <QHBoxLayout>
#include <QGridLayout>

#include "scribblearea.h"
//#include "vertexpanel.h"
//#include "detri2qt.h"
#include <math.h>

using namespace detri2;

/*
vertexPanel::vertexPanel(void *scribblearea, QWidget *parent) : QWidget(parent)
{
    _scribblearea = scribblearea;

    QVBoxLayout* vLayout = new QVBoxLayout(this);
    //vLayout->setSpacing(2);

    _idx = new QLabel;
    _idx->setText("-1");
    vLayout->addWidget(_idx);

    QLabel *x_lbl = new QLabel(tr("x"));
    QLabel *y_lbl = new QLabel(tr("y"));
    QLabel *w_lbl = new QLabel(tr("w"));
    QLabel *val_lbl = new QLabel(tr("mesh size"));
    _x = new QLineEdit;
    _y = new QLineEdit;
    _w = new QLineEdit;
    _val = new QLineEdit;
    _x->setText(tr("0"));
    _y->setText(tr("0"));
    _w->setText(tr("0"));
    _val->setText(tr("0"));

    QGridLayout* gLayout = new QGridLayout(this);
    gLayout->addWidget(x_lbl,0,0);
    gLayout->addWidget(_x,0,1);
    gLayout->addWidget(y_lbl,1,0);
    gLayout->addWidget(_y,1,1);
    gLayout->addWidget(w_lbl,2,0);
    gLayout->addWidget(_w, 2,1);
    gLayout->addWidget(val_lbl,3,0);
    gLayout->addWidget(_val, 3,1);
    QGroupBox *ggbox = new QGroupBox;
    ggbox->setLayout(gLayout);
    vLayout->addWidget(ggbox);

    _applybtn = new QPushButton(tr("Apply"));
    _closebtn = new QPushButton(tr("Close"));

    vLayout->addWidget(_applybtn); // , 0, Qt::AlignLeft
    vLayout->addWidget(_closebtn); // , 0, Qt::AlignRight

    connect(_applybtn, SIGNAL(clicked()), this, SLOT(on_apply()));
    connect(_closebtn, SIGNAL(clicked()), this, SLOT(on_close()));

    connect(_val, SIGNAL(textChanged(const QString &)), this, SLOT(val_changed()));

    setLayout(vLayout);
    setWindowTitle(tr("Vertex"));
}
*/

vertexPanel::vertexPanel(void *scribblearea, QWidget *parent) : QWidget(parent)
{
    _scribblearea = scribblearea;

    _idx = new QLabel;
    _idx->setText("-1");
    _typ = new QLabel;
    _typ->setText("unknown");
    QLabel *x_lbl = new QLabel(tr("x"));
    QLabel *y_lbl = new QLabel(tr("y"));
    QLabel *w_lbl = new QLabel(tr("w"));
    QLabel *val_lbl = new QLabel(tr("mesh size"));
    _x = new QLineEdit;
    _y = new QLineEdit;
    _w = new QLineEdit;
    _val = new QLineEdit;
    _x->setText(tr("0"));
    _y->setText(tr("0"));
    _w->setText(tr("0"));
    _val->setText(tr("0"));

    _applybtn = new QPushButton(tr("Apply"));
    _closebtn = new QPushButton(tr("Close"));

    connect(_applybtn, SIGNAL(clicked()), this, SLOT(on_apply()));
    connect(_closebtn, SIGNAL(clicked()), this, SLOT(on_close()));

    connect(_val, SIGNAL(textChanged(const QString &)), this, SLOT(val_changed()));

    QGridLayout* gLayout = new QGridLayout(this);
    gLayout->addWidget(_idx,0,0);
    gLayout->addWidget(_typ,0,1);
    gLayout->addWidget(x_lbl,1,0);
    gLayout->addWidget(_x,1,1);
    gLayout->addWidget(y_lbl,2,0);
    gLayout->addWidget(_y,2,1);
    gLayout->addWidget(w_lbl,3,0);
    gLayout->addWidget(_w, 3,1);
    gLayout->addWidget(val_lbl,4,0);
    gLayout->addWidget(_val, 4,1);
    //QGroupBox *ggbox = new QGroupBox;
    //ggbox->setLayout(gLayout);
    //vLayout->addWidget(ggbox);
    gLayout->addWidget(_applybtn,5,0);
    gLayout->addWidget(_closebtn, 5,1);

    setLayout(gLayout);
    setWindowTitle(tr("Vertex"));
}

void vertexPanel::on_apply()
{
    ScribbleArea *sa = (ScribbleArea *)_scribblearea;

    if (sa->_active_vertex) {
      // Update the vertex weight and mesh size.
      sa->_active_vertex->wei = _w->text().toDouble();
      sa->_active_vertex->val = _val->text().toDouble();
      // Move the vertex if possible.
      double u = _x->text().toDouble();
      double v = _y->text().toDouble();
      double px = sa->_active_vertex->crd[0];
      double py = sa->_active_vertex->crd[1];
      sa->_active_vertex->crd[2] = px*px+py*py*-sa->_active_vertex->wei;
      // Move the vertex if this (px, py) is close to (u, v);
      double dist = sqrt((px - u)*(px - u) + (py - v)*(py - v));
      if (dist > 0.0) { // The vertex position is changed.
        if (detri2_move_vertex(sa->_geom, &sa->_active_vertex, u, v)) {
          // Vertex moved. Update the scene.
          if (sa->_active_vertex->Pair != NULL) {
            Vertex *mv = sa->_active_vertex->Pair;
            mv->crd[0] = u;
            mv->crd[1] = v;
            mv->crd[2] = u*u + v*v - sa->_active_vertex->wei;
          }
          sa->_object_valid=0;
          sa->update();
        }
      }
    } else {
      double u = _x->text().toDouble();
      double v = _y->text().toDouble();
      qDebug()<<"Try to insert a new vertex at ("<<u<<","<<v<<")";
      double dist = 0; TriEdge E, NE; E.tri = NULL;
      int loc = detri2_locate_point(sa->_geom, u, v, E, dist, 1);
      if (loc == LOC_IN_OUTSIDE) {
        detri2_enlarge_bbox(&(sa->_geom), u,v);
        sa->calc_trans(sa->_geom->io_xmin, sa->_geom->io_xmax,
                       sa->_geom->io_ymin, sa->_geom->io_ymax);
        //qDebug()<< "Adding a new vertex at x="<<x<<" y="<<y;
        E.tri = 0; E.ver = 0; // Re=locate the point (x,y).
        detri2_insert_point(sa->_geom, u, v, E, loc);
        //set_active_vertex(E.org());
        sa->_object_valid=0;
        sa->update(); //updateGL();
      } else {
        double tol = dist / sa->_geom->io_diagonal;
        if (tol > 1.e-3) {
          //qDebug()<< "Adding a new vertex at x="<<x<<" y="<<y;
          detri2_insert_point(sa->_geom, u, v, E, loc);
          // draw this new vertex.
          sa->set_active_vertex(E.org());
          sa->set_active_vertex(NULL);
          // do not re-draw //_object_valid=0;
          sa->update(); //updateGL();
        } else {
          //qDebug()<< "This new vertex is too close to vertex "<<E.org()->idx;
          QString ss = "This new vertex is too close to vertex "+QString::number(E.org()->idx);
          sa->m_statusRight->setText(ss);
        }
      }
    }

    hide();
}

void vertexPanel::on_close()
{
    hide();
}

void vertexPanel::val_changed()
{
    qDebug()<<"Valued changed";
}
